#!/usr/bin/env node
import { createRequire } from 'module';const require = createRequire(import.meta.url);
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw new Error('Dynamic require of "' + x + '" is not supported');
});
var __commonJS = (cb, mod) => function __require2() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// ../../common/temp/node_modules/.pnpm/sprintf-js@1.0.3/node_modules/sprintf-js/src/sprintf.js
var require_sprintf = __commonJS({
  "../../common/temp/node_modules/.pnpm/sprintf-js@1.0.3/node_modules/sprintf-js/src/sprintf.js"(exports) {
    (function(window2) {
      var re = {
        not_string: /[^s]/,
        number: /[diefg]/,
        json: /[j]/,
        not_json: /[^j]/,
        text: /^[^\x25]+/,
        modulo: /^\x25{2}/,
        placeholder: /^\x25(?:([1-9]\d*)\$|\(([^\)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-gijosuxX])/,
        key: /^([a-z_][a-z_\d]*)/i,
        key_access: /^\.([a-z_][a-z_\d]*)/i,
        index_access: /^\[(\d+)\]/,
        sign: /^[\+\-]/
      };
      function sprintf() {
        var key = arguments[0], cache = sprintf.cache;
        if (!(cache[key] && cache.hasOwnProperty(key))) {
          cache[key] = sprintf.parse(key);
        }
        return sprintf.format.call(null, cache[key], arguments);
      }
      sprintf.format = function(parse_tree, argv) {
        var cursor = 1, tree_length = parse_tree.length, node_type = "", arg, output = [], i, k, match, pad, pad_character, pad_length, is_positive = true, sign = "";
        for (i = 0; i < tree_length; i++) {
          node_type = get_type(parse_tree[i]);
          if (node_type === "string") {
            output[output.length] = parse_tree[i];
          } else if (node_type === "array") {
            match = parse_tree[i];
            if (match[2]) {
              arg = argv[cursor];
              for (k = 0; k < match[2].length; k++) {
                if (!arg.hasOwnProperty(match[2][k])) {
                  throw new Error(sprintf("[sprintf] property '%s' does not exist", match[2][k]));
                }
                arg = arg[match[2][k]];
              }
            } else if (match[1]) {
              arg = argv[match[1]];
            } else {
              arg = argv[cursor++];
            }
            if (get_type(arg) == "function") {
              arg = arg();
            }
            if (re.not_string.test(match[8]) && re.not_json.test(match[8]) && (get_type(arg) != "number" && isNaN(arg))) {
              throw new TypeError(sprintf("[sprintf] expecting number but found %s", get_type(arg)));
            }
            if (re.number.test(match[8])) {
              is_positive = arg >= 0;
            }
            switch (match[8]) {
              case "b":
                arg = arg.toString(2);
                break;
              case "c":
                arg = String.fromCharCode(arg);
                break;
              case "d":
              case "i":
                arg = parseInt(arg, 10);
                break;
              case "j":
                arg = JSON.stringify(arg, null, match[6] ? parseInt(match[6]) : 0);
                break;
              case "e":
                arg = match[7] ? arg.toExponential(match[7]) : arg.toExponential();
                break;
              case "f":
                arg = match[7] ? parseFloat(arg).toFixed(match[7]) : parseFloat(arg);
                break;
              case "g":
                arg = match[7] ? parseFloat(arg).toPrecision(match[7]) : parseFloat(arg);
                break;
              case "o":
                arg = arg.toString(8);
                break;
              case "s":
                arg = (arg = String(arg)) && match[7] ? arg.substring(0, match[7]) : arg;
                break;
              case "u":
                arg = arg >>> 0;
                break;
              case "x":
                arg = arg.toString(16);
                break;
              case "X":
                arg = arg.toString(16).toUpperCase();
                break;
            }
            if (re.json.test(match[8])) {
              output[output.length] = arg;
            } else {
              if (re.number.test(match[8]) && (!is_positive || match[3])) {
                sign = is_positive ? "+" : "-";
                arg = arg.toString().replace(re.sign, "");
              } else {
                sign = "";
              }
              pad_character = match[4] ? match[4] === "0" ? "0" : match[4].charAt(1) : " ";
              pad_length = match[6] - (sign + arg).length;
              pad = match[6] ? pad_length > 0 ? str_repeat(pad_character, pad_length) : "" : "";
              output[output.length] = match[5] ? sign + arg + pad : pad_character === "0" ? sign + pad + arg : pad + sign + arg;
            }
          }
        }
        return output.join("");
      };
      sprintf.cache = {};
      sprintf.parse = function(fmt) {
        var _fmt = fmt, match = [], parse_tree = [], arg_names = 0;
        while (_fmt) {
          if ((match = re.text.exec(_fmt)) !== null) {
            parse_tree[parse_tree.length] = match[0];
          } else if ((match = re.modulo.exec(_fmt)) !== null) {
            parse_tree[parse_tree.length] = "%";
          } else if ((match = re.placeholder.exec(_fmt)) !== null) {
            if (match[2]) {
              arg_names |= 1;
              var field_list = [], replacement_field = match[2], field_match = [];
              if ((field_match = re.key.exec(replacement_field)) !== null) {
                field_list[field_list.length] = field_match[1];
                while ((replacement_field = replacement_field.substring(field_match[0].length)) !== "") {
                  if ((field_match = re.key_access.exec(replacement_field)) !== null) {
                    field_list[field_list.length] = field_match[1];
                  } else if ((field_match = re.index_access.exec(replacement_field)) !== null) {
                    field_list[field_list.length] = field_match[1];
                  } else {
                    throw new SyntaxError("[sprintf] failed to parse named argument key");
                  }
                }
              } else {
                throw new SyntaxError("[sprintf] failed to parse named argument key");
              }
              match[2] = field_list;
            } else {
              arg_names |= 2;
            }
            if (arg_names === 3) {
              throw new Error("[sprintf] mixing positional and named placeholders is not (yet) supported");
            }
            parse_tree[parse_tree.length] = match;
          } else {
            throw new SyntaxError("[sprintf] unexpected placeholder");
          }
          _fmt = _fmt.substring(match[0].length);
        }
        return parse_tree;
      };
      var vsprintf = function(fmt, argv, _argv) {
        _argv = (argv || []).slice(0);
        _argv.splice(0, 0, fmt);
        return sprintf.apply(null, _argv);
      };
      function get_type(variable) {
        return Object.prototype.toString.call(variable).slice(8, -1).toLowerCase();
      }
      function str_repeat(input, multiplier) {
        return Array(multiplier + 1).join(input);
      }
      if (typeof exports !== "undefined") {
        exports.sprintf = sprintf;
        exports.vsprintf = vsprintf;
      } else {
        window2.sprintf = sprintf;
        window2.vsprintf = vsprintf;
        if (typeof define === "function" && define.amd) {
          define(function() {
            return {
              sprintf,
              vsprintf
            };
          });
        }
      }
    })(typeof window === "undefined" ? exports : window);
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/const.js
var require_const = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/const.js"(exports, module) {
    "use strict";
    module.exports.EOL = "\n";
    module.exports.SUPPRESS = "==SUPPRESS==";
    module.exports.OPTIONAL = "?";
    module.exports.ZERO_OR_MORE = "*";
    module.exports.ONE_OR_MORE = "+";
    module.exports.PARSER = "A...";
    module.exports.REMAINDER = "...";
    module.exports._UNRECOGNIZED_ARGS_ATTR = "_unrecognized_args";
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/utils.js
var require_utils = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/utils.js"(exports) {
    "use strict";
    exports.repeat = function(str, num) {
      var result = "";
      for (var i = 0; i < num; i++) {
        result += str;
      }
      return result;
    };
    exports.arrayEqual = function(a, b) {
      if (a.length !== b.length) {
        return false;
      }
      for (var i = 0; i < a.length; i++) {
        if (a[i] !== b[i]) {
          return false;
        }
      }
      return true;
    };
    exports.trimChars = function(str, chars) {
      var start = 0;
      var end = str.length - 1;
      while (chars.indexOf(str.charAt(start)) >= 0) {
        start++;
      }
      while (chars.indexOf(str.charAt(end)) >= 0) {
        end--;
      }
      return str.slice(start, end + 1);
    };
    exports.capitalize = function(str) {
      return str.charAt(0).toUpperCase() + str.slice(1);
    };
    exports.arrayUnion = function() {
      var result = [];
      for (var i = 0, values = {}; i < arguments.length; i++) {
        var arr = arguments[i];
        for (var j = 0; j < arr.length; j++) {
          if (!values[arr[j]]) {
            values[arr[j]] = true;
            result.push(arr[j]);
          }
        }
      }
      return result;
    };
    function has(obj, key) {
      return Object.prototype.hasOwnProperty.call(obj, key);
    }
    exports.has = has;
    exports.extend = function(dest, src) {
      for (var i in src) {
        if (has(src, i)) {
          dest[i] = src[i];
        }
      }
    };
    exports.trimEnd = function(str) {
      return str.replace(/\s+$/g, "");
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action.js
var require_action = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action.js"(exports, module) {
    "use strict";
    var c = require_const();
    var Action = module.exports = function Action2(options) {
      options = options || {};
      this.optionStrings = options.optionStrings || [];
      this.dest = options.dest;
      this.nargs = typeof options.nargs !== "undefined" ? options.nargs : null;
      this.constant = typeof options.constant !== "undefined" ? options.constant : null;
      this.defaultValue = options.defaultValue;
      this.type = typeof options.type !== "undefined" ? options.type : null;
      this.choices = typeof options.choices !== "undefined" ? options.choices : null;
      this.required = typeof options.required !== "undefined" ? options.required : false;
      this.help = typeof options.help !== "undefined" ? options.help : null;
      this.metavar = typeof options.metavar !== "undefined" ? options.metavar : null;
      if (!(this.optionStrings instanceof Array)) {
        throw new Error("optionStrings should be an array");
      }
      if (typeof this.required !== "undefined" && typeof this.required !== "boolean") {
        throw new Error("required should be a boolean");
      }
    };
    Action.prototype.getName = function() {
      if (this.optionStrings.length > 0) {
        return this.optionStrings.join("/");
      } else if (this.metavar !== null && this.metavar !== c.SUPPRESS) {
        return this.metavar;
      } else if (typeof this.dest !== "undefined" && this.dest !== c.SUPPRESS) {
        return this.dest;
      }
      return null;
    };
    Action.prototype.isOptional = function() {
      return !this.isPositional();
    };
    Action.prototype.isPositional = function() {
      return this.optionStrings.length === 0;
    };
    Action.prototype.call = function() {
      throw new Error(".call() not defined");
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/help.js
var require_help = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/help.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var c = require_const();
    var ActionHelp = module.exports = function ActionHelp2(options) {
      options = options || {};
      if (options.defaultValue !== null) {
        options.defaultValue = options.defaultValue;
      } else {
        options.defaultValue = c.SUPPRESS;
      }
      options.dest = options.dest !== null ? options.dest : c.SUPPRESS;
      options.nargs = 0;
      Action.call(this, options);
    };
    util.inherits(ActionHelp, Action);
    ActionHelp.prototype.call = function(parser) {
      parser.printHelp();
      parser.exit();
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/append.js
var require_append = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/append.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var c = require_const();
    var ActionAppend = module.exports = function ActionAppend2(options) {
      options = options || {};
      if (this.nargs <= 0) {
        throw new Error("nargs for append actions must be > 0; if arg strings are not supplying the value to append, the append const action may be more appropriate");
      }
      if (!!this.constant && this.nargs !== c.OPTIONAL) {
        throw new Error("nargs must be OPTIONAL to supply const");
      }
      Action.call(this, options);
    };
    util.inherits(ActionAppend, Action);
    ActionAppend.prototype.call = function(parser, namespace, values) {
      var items = (namespace[this.dest] || []).slice();
      items.push(values);
      namespace.set(this.dest, items);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/append/constant.js
var require_constant = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/append/constant.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var ActionAppendConstant = module.exports = function ActionAppendConstant2(options) {
      options = options || {};
      options.nargs = 0;
      if (typeof options.constant === "undefined") {
        throw new Error("constant option is required for appendAction");
      }
      Action.call(this, options);
    };
    util.inherits(ActionAppendConstant, Action);
    ActionAppendConstant.prototype.call = function(parser, namespace) {
      var items = [].concat(namespace[this.dest] || []);
      items.push(this.constant);
      namespace.set(this.dest, items);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/count.js
var require_count = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/count.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var ActionCount = module.exports = function ActionCount2(options) {
      options = options || {};
      options.nargs = 0;
      Action.call(this, options);
    };
    util.inherits(ActionCount, Action);
    ActionCount.prototype.call = function(parser, namespace) {
      namespace.set(this.dest, (namespace[this.dest] || 0) + 1);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store.js
var require_store = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var c = require_const();
    var ActionStore = module.exports = function ActionStore2(options) {
      options = options || {};
      if (this.nargs <= 0) {
        throw new Error("nargs for store actions must be > 0; if you have nothing to store, actions such as store true or store const may be more appropriate");
      }
      if (typeof this.constant !== "undefined" && this.nargs !== c.OPTIONAL) {
        throw new Error("nargs must be OPTIONAL to supply const");
      }
      Action.call(this, options);
    };
    util.inherits(ActionStore, Action);
    ActionStore.prototype.call = function(parser, namespace, values) {
      namespace.set(this.dest, values);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store/constant.js
var require_constant2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store/constant.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var ActionStoreConstant = module.exports = function ActionStoreConstant2(options) {
      options = options || {};
      options.nargs = 0;
      if (typeof options.constant === "undefined") {
        throw new Error("constant option is required for storeAction");
      }
      Action.call(this, options);
    };
    util.inherits(ActionStoreConstant, Action);
    ActionStoreConstant.prototype.call = function(parser, namespace) {
      namespace.set(this.dest, this.constant);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store/true.js
var require_true = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store/true.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var ActionStoreConstant = require_constant2();
    var ActionStoreTrue = module.exports = function ActionStoreTrue2(options) {
      options = options || {};
      options.constant = true;
      options.defaultValue = options.defaultValue !== null ? options.defaultValue : false;
      ActionStoreConstant.call(this, options);
    };
    util.inherits(ActionStoreTrue, ActionStoreConstant);
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store/false.js
var require_false = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/store/false.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var ActionStoreConstant = require_constant2();
    var ActionStoreFalse = module.exports = function ActionStoreFalse2(options) {
      options = options || {};
      options.constant = false;
      options.defaultValue = options.defaultValue !== null ? options.defaultValue : true;
      ActionStoreConstant.call(this, options);
    };
    util.inherits(ActionStoreFalse, ActionStoreConstant);
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/version.js
var require_version = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/version.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var Action = require_action();
    var c = require_const();
    var ActionVersion = module.exports = function ActionVersion2(options) {
      options = options || {};
      options.defaultValue = options.defaultValue ? options.defaultValue : c.SUPPRESS;
      options.dest = options.dest || c.SUPPRESS;
      options.nargs = 0;
      this.version = options.version;
      Action.call(this, options);
    };
    util.inherits(ActionVersion, Action);
    ActionVersion.prototype.call = function(parser) {
      var version = this.version || parser.version;
      var formatter = parser._getFormatter();
      formatter.addText(version);
      parser.exit(0, formatter.formatHelp());
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument/error.js
var require_error = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument/error.js"(exports, module) {
    "use strict";
    var format = __require("util").format;
    var ERR_CODE = "ARGError";
    module.exports = function(argument, message) {
      var argumentName = null;
      var errMessage;
      var err;
      if (argument.getName) {
        argumentName = argument.getName();
      } else {
        argumentName = "" + argument;
      }
      if (!argumentName) {
        errMessage = message;
      } else {
        errMessage = format('argument "%s": %s', argumentName, message);
      }
      err = new TypeError(errMessage);
      err.code = ERR_CODE;
      return err;
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/subparsers.js
var require_subparsers = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action/subparsers.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var format = __require("util").format;
    var Action = require_action();
    var c = require_const();
    var argumentErrorHelper = require_error();
    function ChoicesPseudoAction(name, help) {
      var options = {
        optionStrings: [],
        dest: name,
        help
      };
      Action.call(this, options);
    }
    util.inherits(ChoicesPseudoAction, Action);
    function ActionSubparsers(options) {
      options = options || {};
      options.dest = options.dest || c.SUPPRESS;
      options.nargs = c.PARSER;
      this.debug = options.debug === true;
      this._progPrefix = options.prog;
      this._parserClass = options.parserClass;
      this._nameParserMap = {};
      this._choicesActions = [];
      options.choices = this._nameParserMap;
      Action.call(this, options);
    }
    util.inherits(ActionSubparsers, Action);
    ActionSubparsers.prototype.addParser = function(name, options) {
      var parser;
      var self = this;
      options = options || {};
      options.debug = this.debug === true;
      if (!options.prog) {
        options.prog = this._progPrefix + " " + name;
      }
      var aliases = options.aliases || [];
      if (!!options.help || typeof options.help === "string") {
        var help = options.help;
        delete options.help;
        var choiceAction = new ChoicesPseudoAction(name, help);
        this._choicesActions.push(choiceAction);
      }
      parser = new this._parserClass(options);
      this._nameParserMap[name] = parser;
      aliases.forEach(function(alias) {
        self._nameParserMap[alias] = parser;
      });
      return parser;
    };
    ActionSubparsers.prototype._getSubactions = function() {
      return this._choicesActions;
    };
    ActionSubparsers.prototype.call = function(parser, namespace, values) {
      var parserName = values[0];
      var argStrings = values.slice(1);
      if (this.dest !== c.SUPPRESS) {
        namespace[this.dest] = parserName;
      }
      if (this._nameParserMap[parserName]) {
        parser = this._nameParserMap[parserName];
      } else {
        throw argumentErrorHelper(format(
          'Unknown parser "%s" (choices: [%s]).',
          parserName,
          Object.keys(this._nameParserMap).join(", ")
        ));
      }
      parser.parseArgs(argStrings, namespace);
    };
    module.exports = ActionSubparsers;
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument/group.js
var require_group = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument/group.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var ActionContainer = require_action_container();
    var ArgumentGroup = module.exports = function ArgumentGroup2(container, options) {
      options = options || {};
      options.conflictHandler = options.conflictHandler || container.conflictHandler;
      options.prefixChars = options.prefixChars || container.prefixChars;
      options.argumentDefault = options.argumentDefault || container.argumentDefault;
      ActionContainer.call(this, options);
      this.title = options.title;
      this._groupActions = [];
      this._container = container;
      this._registries = container._registries;
      this._actions = container._actions;
      this._optionStringActions = container._optionStringActions;
      this._defaults = container._defaults;
      this._hasNegativeNumberOptionals = container._hasNegativeNumberOptionals;
      this._mutuallyExclusiveGroups = container._mutuallyExclusiveGroups;
    };
    util.inherits(ArgumentGroup, ActionContainer);
    ArgumentGroup.prototype._addAction = function(action) {
      action = ActionContainer.prototype._addAction.call(this, action);
      this._groupActions.push(action);
      return action;
    };
    ArgumentGroup.prototype._removeAction = function(action) {
      ActionContainer.prototype._removeAction.call(this, action);
      var actionIndex = this._groupActions.indexOf(action);
      if (actionIndex >= 0) {
        this._groupActions.splice(actionIndex, 1);
      }
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument/exclusive.js
var require_exclusive = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument/exclusive.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var ArgumentGroup = require_group();
    var MutuallyExclusiveGroup = module.exports = function MutuallyExclusiveGroup2(container, options) {
      var required;
      options = options || {};
      required = options.required || false;
      ArgumentGroup.call(this, container);
      this.required = required;
    };
    util.inherits(MutuallyExclusiveGroup, ArgumentGroup);
    MutuallyExclusiveGroup.prototype._addAction = function(action) {
      var msg;
      if (action.required) {
        msg = "mutually exclusive arguments must be optional";
        throw new Error(msg);
      }
      action = this._container._addAction(action);
      this._groupActions.push(action);
      return action;
    };
    MutuallyExclusiveGroup.prototype._removeAction = function(action) {
      this._container._removeAction(action);
      this._groupActions.remove(action);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action_container.js
var require_action_container = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/action_container.js"(exports, module) {
    "use strict";
    var format = __require("util").format;
    var c = require_const();
    var $$ = require_utils();
    var ActionHelp = require_help();
    var ActionAppend = require_append();
    var ActionAppendConstant = require_constant();
    var ActionCount = require_count();
    var ActionStore = require_store();
    var ActionStoreConstant = require_constant2();
    var ActionStoreTrue = require_true();
    var ActionStoreFalse = require_false();
    var ActionVersion = require_version();
    var ActionSubparsers = require_subparsers();
    var argumentErrorHelper = require_error();
    var ActionContainer = module.exports = function ActionContainer2(options) {
      options = options || {};
      this.description = options.description;
      this.argumentDefault = options.argumentDefault;
      this.prefixChars = options.prefixChars || "";
      this.conflictHandler = options.conflictHandler;
      this._registries = {};
      this.register("action", null, ActionStore);
      this.register("action", "store", ActionStore);
      this.register("action", "storeConst", ActionStoreConstant);
      this.register("action", "storeTrue", ActionStoreTrue);
      this.register("action", "storeFalse", ActionStoreFalse);
      this.register("action", "append", ActionAppend);
      this.register("action", "appendConst", ActionAppendConstant);
      this.register("action", "count", ActionCount);
      this.register("action", "help", ActionHelp);
      this.register("action", "version", ActionVersion);
      this.register("action", "parsers", ActionSubparsers);
      this._getHandler();
      this._actions = [];
      this._optionStringActions = {};
      this._actionGroups = [];
      this._mutuallyExclusiveGroups = [];
      this._defaults = {};
      this._regexpNegativeNumber = new RegExp("^[-]?[0-9]*\\.?[0-9]+([eE][-+]?[0-9]+)?$");
      this._hasNegativeNumberOptionals = [];
    };
    var ArgumentGroup = require_group();
    var MutuallyExclusiveGroup = require_exclusive();
    ActionContainer.prototype.register = function(registryName, value, object) {
      this._registries[registryName] = this._registries[registryName] || {};
      this._registries[registryName][value] = object;
    };
    ActionContainer.prototype._registryGet = function(registryName, value, defaultValue) {
      if (arguments.length < 3) {
        defaultValue = null;
      }
      return this._registries[registryName][value] || defaultValue;
    };
    ActionContainer.prototype.setDefaults = function(options) {
      options = options || {};
      for (var property in options) {
        if ($$.has(options, property)) {
          this._defaults[property] = options[property];
        }
      }
      this._actions.forEach(function(action) {
        if ($$.has(options, action.dest)) {
          action.defaultValue = options[action.dest];
        }
      });
    };
    ActionContainer.prototype.getDefault = function(dest) {
      var result = $$.has(this._defaults, dest) ? this._defaults[dest] : null;
      this._actions.forEach(function(action) {
        if (action.dest === dest && $$.has(action, "defaultValue")) {
          result = action.defaultValue;
        }
      });
      return result;
    };
    ActionContainer.prototype.addArgument = function(args, options) {
      args = args;
      options = options || {};
      if (typeof args === "string") {
        args = [args];
      }
      if (!Array.isArray(args)) {
        throw new TypeError("addArgument first argument should be a string or an array");
      }
      if (typeof options !== "object" || Array.isArray(options)) {
        throw new TypeError("addArgument second argument should be a hash");
      }
      if (!args || args.length === 1 && this.prefixChars.indexOf(args[0][0]) < 0) {
        if (args && !!options.dest) {
          throw new Error("dest supplied twice for positional argument");
        }
        options = this._getPositional(args, options);
      } else {
        options = this._getOptional(args, options);
      }
      if (typeof options.defaultValue === "undefined") {
        var dest = options.dest;
        if ($$.has(this._defaults, dest)) {
          options.defaultValue = this._defaults[dest];
        } else if (typeof this.argumentDefault !== "undefined") {
          options.defaultValue = this.argumentDefault;
        }
      }
      var ActionClass = this._popActionClass(options);
      if (typeof ActionClass !== "function") {
        throw new Error(format('Unknown action "%s".', ActionClass));
      }
      var action = new ActionClass(options);
      var typeFunction = this._registryGet("type", action.type, action.type);
      if (typeof typeFunction !== "function") {
        throw new Error(format('"%s" is not callable', typeFunction));
      }
      return this._addAction(action);
    };
    ActionContainer.prototype.addArgumentGroup = function(options) {
      var group = new ArgumentGroup(this, options);
      this._actionGroups.push(group);
      return group;
    };
    ActionContainer.prototype.addMutuallyExclusiveGroup = function(options) {
      var group = new MutuallyExclusiveGroup(this, options);
      this._mutuallyExclusiveGroups.push(group);
      return group;
    };
    ActionContainer.prototype._addAction = function(action) {
      var self = this;
      this._checkConflict(action);
      this._actions.push(action);
      action.container = this;
      action.optionStrings.forEach(function(optionString) {
        self._optionStringActions[optionString] = action;
      });
      action.optionStrings.forEach(function(optionString) {
        if (optionString.match(self._regexpNegativeNumber)) {
          if (!self._hasNegativeNumberOptionals.some(Boolean)) {
            self._hasNegativeNumberOptionals.push(true);
          }
        }
      });
      return action;
    };
    ActionContainer.prototype._removeAction = function(action) {
      var actionIndex = this._actions.indexOf(action);
      if (actionIndex >= 0) {
        this._actions.splice(actionIndex, 1);
      }
    };
    ActionContainer.prototype._addContainerActions = function(container) {
      var titleGroupMap = {};
      this._actionGroups.forEach(function(group) {
        if (titleGroupMap[group.title]) {
          throw new Error(format('Cannot merge actions - two groups are named "%s".', group.title));
        }
        titleGroupMap[group.title] = group;
      });
      var groupMap = {};
      function actionHash(action) {
        return action.getName();
      }
      container._actionGroups.forEach(function(group) {
        if (!titleGroupMap[group.title]) {
          titleGroupMap[group.title] = this.addArgumentGroup({
            title: group.title,
            description: group.description
          });
        }
        group._groupActions.forEach(function(action) {
          groupMap[actionHash(action)] = titleGroupMap[group.title];
        });
      }, this);
      var mutexGroup;
      container._mutuallyExclusiveGroups.forEach(function(group) {
        mutexGroup = this.addMutuallyExclusiveGroup({
          required: group.required
        });
        group._groupActions.forEach(function(action) {
          groupMap[actionHash(action)] = mutexGroup;
        });
      }, this);
      container._actions.forEach(function(action) {
        var key = actionHash(action);
        if (groupMap[key]) {
          groupMap[key]._addAction(action);
        } else {
          this._addAction(action);
        }
      });
    };
    ActionContainer.prototype._getPositional = function(dest, options) {
      if (Array.isArray(dest)) {
        dest = dest[0];
      }
      if (options.required) {
        throw new Error('"required" is an invalid argument for positionals.');
      }
      if (options.nargs !== c.OPTIONAL && options.nargs !== c.ZERO_OR_MORE) {
        options.required = true;
      }
      if (options.nargs === c.ZERO_OR_MORE && typeof options.defaultValue === "undefined") {
        options.required = true;
      }
      options.dest = dest;
      options.optionStrings = [];
      return options;
    };
    ActionContainer.prototype._getOptional = function(args, options) {
      var prefixChars = this.prefixChars;
      var optionStrings = [];
      var optionStringsLong = [];
      args.forEach(function(optionString) {
        if (prefixChars.indexOf(optionString[0]) < 0) {
          throw new Error(format(
            'Invalid option string "%s": must start with a "%s".',
            optionString,
            prefixChars
          ));
        }
        optionStrings.push(optionString);
        if (optionString.length > 1 && prefixChars.indexOf(optionString[1]) >= 0) {
          optionStringsLong.push(optionString);
        }
      });
      var dest = options.dest || null;
      delete options.dest;
      if (!dest) {
        var optionStringDest = optionStringsLong.length ? optionStringsLong[0] : optionStrings[0];
        dest = $$.trimChars(optionStringDest, this.prefixChars);
        if (dest.length === 0) {
          throw new Error(
            format('dest= is required for options like "%s"', optionStrings.join(", "))
          );
        }
        dest = dest.replace(/-/g, "_");
      }
      options.dest = dest;
      options.optionStrings = optionStrings;
      return options;
    };
    ActionContainer.prototype._popActionClass = function(options, defaultValue) {
      defaultValue = defaultValue || null;
      var action = options.action || defaultValue;
      delete options.action;
      var actionClass = this._registryGet("action", action, action);
      return actionClass;
    };
    ActionContainer.prototype._getHandler = function() {
      var handlerString = this.conflictHandler;
      var handlerFuncName = "_handleConflict" + $$.capitalize(handlerString);
      var func = this[handlerFuncName];
      if (typeof func === "undefined") {
        var msg = "invalid conflict resolution value: " + handlerString;
        throw new Error(msg);
      } else {
        return func;
      }
    };
    ActionContainer.prototype._checkConflict = function(action) {
      var optionStringActions = this._optionStringActions;
      var conflictOptionals = [];
      action.optionStrings.forEach(function(optionString) {
        var conflOptional = optionStringActions[optionString];
        if (typeof conflOptional !== "undefined") {
          conflictOptionals.push([optionString, conflOptional]);
        }
      });
      if (conflictOptionals.length > 0) {
        var conflictHandler = this._getHandler();
        conflictHandler.call(this, action, conflictOptionals);
      }
    };
    ActionContainer.prototype._handleConflictError = function(action, conflOptionals) {
      var conflicts = conflOptionals.map(function(pair) {
        return pair[0];
      });
      conflicts = conflicts.join(", ");
      throw argumentErrorHelper(
        action,
        format("Conflicting option string(s): %s", conflicts)
      );
    };
    ActionContainer.prototype._handleConflictResolve = function(action, conflOptionals) {
      var self = this;
      conflOptionals.forEach(function(pair) {
        var optionString = pair[0];
        var conflictingAction = pair[1];
        var i = conflictingAction.optionStrings.indexOf(optionString);
        if (i >= 0) {
          conflictingAction.optionStrings.splice(i, 1);
        }
        delete self._optionStringActions[optionString];
        if (conflictingAction.optionStrings.length === 0) {
          conflictingAction.container._removeAction(conflictingAction);
        }
      });
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/help/formatter.js
var require_formatter = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/help/formatter.js"(exports, module) {
    "use strict";
    var sprintf = require_sprintf().sprintf;
    var c = require_const();
    var $$ = require_utils();
    function Section(parent, heading) {
      this._parent = parent;
      this._heading = heading;
      this._items = [];
    }
    Section.prototype.addItem = function(callback) {
      this._items.push(callback);
    };
    Section.prototype.formatHelp = function(formatter) {
      var itemHelp, heading;
      if (this._parent) {
        formatter._indent();
      }
      itemHelp = this._items.map(function(item) {
        var obj, func, args;
        obj = formatter;
        func = item[0];
        args = item[1];
        return func.apply(obj, args);
      });
      itemHelp = formatter._joinParts(itemHelp);
      if (this._parent) {
        formatter._dedent();
      }
      if (!itemHelp) {
        return "";
      }
      heading = "";
      if (this._heading && this._heading !== c.SUPPRESS) {
        var currentIndent = formatter.currentIndent;
        heading = $$.repeat(" ", currentIndent) + this._heading + ":" + c.EOL;
      }
      return formatter._joinParts([c.EOL, heading, itemHelp, c.EOL]);
    };
    var HelpFormatter = module.exports = function HelpFormatter2(options) {
      options = options || {};
      this._prog = options.prog;
      this._maxHelpPosition = options.maxHelpPosition || 24;
      this._width = options.width || (process.env.COLUMNS || 80) - 2;
      this._currentIndent = 0;
      this._indentIncriment = options.indentIncriment || 2;
      this._level = 0;
      this._actionMaxLength = 0;
      this._rootSection = new Section(null);
      this._currentSection = this._rootSection;
      this._whitespaceMatcher = new RegExp("\\s+", "g");
      this._longBreakMatcher = new RegExp(c.EOL + c.EOL + c.EOL + "+", "g");
    };
    HelpFormatter.prototype._indent = function() {
      this._currentIndent += this._indentIncriment;
      this._level += 1;
    };
    HelpFormatter.prototype._dedent = function() {
      this._currentIndent -= this._indentIncriment;
      this._level -= 1;
      if (this._currentIndent < 0) {
        throw new Error("Indent decreased below 0.");
      }
    };
    HelpFormatter.prototype._addItem = function(func, args) {
      this._currentSection.addItem([func, args]);
    };
    HelpFormatter.prototype.startSection = function(heading) {
      this._indent();
      var section = new Section(this._currentSection, heading);
      var func = section.formatHelp.bind(section);
      this._addItem(func, [this]);
      this._currentSection = section;
    };
    HelpFormatter.prototype.endSection = function() {
      this._currentSection = this._currentSection._parent;
      this._dedent();
    };
    HelpFormatter.prototype.addText = function(text) {
      if (text && text !== c.SUPPRESS) {
        this._addItem(this._formatText, [text]);
      }
    };
    HelpFormatter.prototype.addUsage = function(usage, actions, groups, prefix) {
      if (usage !== c.SUPPRESS) {
        this._addItem(this._formatUsage, [usage, actions, groups, prefix]);
      }
    };
    HelpFormatter.prototype.addArgument = function(action) {
      if (action.help !== c.SUPPRESS) {
        var self = this;
        var invocations = [this._formatActionInvocation(action)];
        var invocationLength = invocations[0].length;
        var actionLength;
        if (action._getSubactions) {
          this._indent();
          action._getSubactions().forEach(function(subaction) {
            var invocationNew = self._formatActionInvocation(subaction);
            invocations.push(invocationNew);
            invocationLength = Math.max(invocationLength, invocationNew.length);
          });
          this._dedent();
        }
        actionLength = invocationLength + this._currentIndent;
        this._actionMaxLength = Math.max(this._actionMaxLength, actionLength);
        this._addItem(this._formatAction, [action]);
      }
    };
    HelpFormatter.prototype.addArguments = function(actions) {
      var self = this;
      actions.forEach(function(action) {
        self.addArgument(action);
      });
    };
    HelpFormatter.prototype.formatHelp = function() {
      var help = this._rootSection.formatHelp(this);
      if (help) {
        help = help.replace(this._longBreakMatcher, c.EOL + c.EOL);
        help = $$.trimChars(help, c.EOL) + c.EOL;
      }
      return help;
    };
    HelpFormatter.prototype._joinParts = function(partStrings) {
      return partStrings.filter(function(part) {
        return part && part !== c.SUPPRESS;
      }).join("");
    };
    HelpFormatter.prototype._formatUsage = function(usage, actions, groups, prefix) {
      if (!prefix && typeof prefix !== "string") {
        prefix = "usage: ";
      }
      actions = actions || [];
      groups = groups || [];
      if (usage) {
        usage = sprintf(usage, { prog: this._prog });
      } else if (!usage && actions.length === 0) {
        usage = this._prog;
      } else if (!usage) {
        var prog = this._prog;
        var optionals = [];
        var positionals = [];
        var actionUsage;
        var textWidth;
        actions.forEach(function(action) {
          if (action.isOptional()) {
            optionals.push(action);
          } else {
            positionals.push(action);
          }
        });
        actionUsage = this._formatActionsUsage([].concat(optionals, positionals), groups);
        usage = [prog, actionUsage].join(" ");
        textWidth = this._width - this._currentIndent;
        if (prefix.length + usage.length > textWidth) {
          var regexpPart = new RegExp("\\(.*?\\)+|\\[.*?\\]+|\\S+", "g");
          var optionalUsage = this._formatActionsUsage(optionals, groups);
          var positionalUsage = this._formatActionsUsage(positionals, groups);
          var optionalParts = optionalUsage.match(regexpPart);
          var positionalParts = positionalUsage.match(regexpPart) || [];
          if (optionalParts.join(" ") !== optionalUsage) {
            throw new Error(`assert "optionalParts.join(' ') === optionalUsage"`);
          }
          if (positionalParts.join(" ") !== positionalUsage) {
            throw new Error(`assert "positionalParts.join(' ') === positionalUsage"`);
          }
          var _getLines = function(parts2, indent2, prefix2) {
            var lines2 = [];
            var line = [];
            var lineLength = prefix2 ? prefix2.length - 1 : indent2.length - 1;
            parts2.forEach(function(part) {
              if (lineLength + 1 + part.length > textWidth) {
                lines2.push(indent2 + line.join(" "));
                line = [];
                lineLength = indent2.length - 1;
              }
              line.push(part);
              lineLength += part.length + 1;
            });
            if (line) {
              lines2.push(indent2 + line.join(" "));
            }
            if (prefix2) {
              lines2[0] = lines2[0].substr(indent2.length);
            }
            return lines2;
          };
          var lines, indent, parts;
          if (prefix.length + prog.length <= 0.75 * textWidth) {
            indent = $$.repeat(" ", prefix.length + prog.length + 1);
            if (optionalParts) {
              lines = [].concat(
                _getLines([prog].concat(optionalParts), indent, prefix),
                _getLines(positionalParts, indent)
              );
            } else if (positionalParts) {
              lines = _getLines([prog].concat(positionalParts), indent, prefix);
            } else {
              lines = [prog];
            }
          } else {
            indent = $$.repeat(" ", prefix.length);
            parts = optionalParts.concat(positionalParts);
            lines = _getLines(parts, indent);
            if (lines.length > 1) {
              lines = [].concat(
                _getLines(optionalParts, indent),
                _getLines(positionalParts, indent)
              );
            }
            lines = [prog].concat(lines);
          }
          usage = lines.join(c.EOL);
        }
      }
      return prefix + usage + c.EOL + c.EOL;
    };
    HelpFormatter.prototype._formatActionsUsage = function(actions, groups) {
      var groupActions = [];
      var inserts = [];
      var self = this;
      groups.forEach(function(group) {
        var end;
        var i2;
        var start = actions.indexOf(group._groupActions[0]);
        if (start >= 0) {
          end = start + group._groupActions.length;
          if ($$.arrayEqual(actions.slice(start, end), group._groupActions)) {
            group._groupActions.forEach(function(action) {
              groupActions.push(action);
            });
            if (!group.required) {
              if (inserts[start]) {
                inserts[start] += " [";
              } else {
                inserts[start] = "[";
              }
              inserts[end] = "]";
            } else {
              if (inserts[start]) {
                inserts[start] += " (";
              } else {
                inserts[start] = "(";
              }
              inserts[end] = ")";
            }
            for (i2 = start + 1; i2 < end; i2 += 1) {
              inserts[i2] = "|";
            }
          }
        }
      });
      var parts = [];
      actions.forEach(function(action, actionIndex) {
        var part;
        var optionString;
        var argsDefault;
        var argsString;
        if (action.help === c.SUPPRESS) {
          parts.push(null);
          if (inserts[actionIndex] === "|") {
            inserts.splice(actionIndex, actionIndex);
          } else if (inserts[actionIndex + 1] === "|") {
            inserts.splice(actionIndex + 1, actionIndex + 1);
          }
        } else if (!action.isOptional()) {
          part = self._formatArgs(action, action.dest);
          if (groupActions.indexOf(action) >= 0) {
            if (part[0] === "[" && part[part.length - 1] === "]") {
              part = part.slice(1, -1);
            }
          }
          parts.push(part);
        } else {
          optionString = action.optionStrings[0];
          if (action.nargs === 0) {
            part = "" + optionString;
          } else {
            argsDefault = action.dest.toUpperCase();
            argsString = self._formatArgs(action, argsDefault);
            part = optionString + " " + argsString;
          }
          if (!action.required && groupActions.indexOf(action) < 0) {
            part = "[" + part + "]";
          }
          parts.push(part);
        }
      });
      for (var i = inserts.length - 1; i >= 0; --i) {
        if (inserts[i] !== null) {
          parts.splice(i, 0, inserts[i]);
        }
      }
      var text = parts.filter(function(part) {
        return !!part;
      }).join(" ");
      text = text.replace(/([\[(]) /g, "$1");
      text = text.replace(/ ([\])])/g, "$1");
      text = text.replace(/\[ *\]/g, "");
      text = text.replace(/\( *\)/g, "");
      text = text.replace(/\(([^|]*)\)/g, "$1");
      text = text.trim();
      return text;
    };
    HelpFormatter.prototype._formatText = function(text) {
      text = sprintf(text, { prog: this._prog });
      var textWidth = this._width - this._currentIndent;
      var indentIncriment = $$.repeat(" ", this._currentIndent);
      return this._fillText(text, textWidth, indentIncriment) + c.EOL + c.EOL;
    };
    HelpFormatter.prototype._formatAction = function(action) {
      var self = this;
      var helpText;
      var helpLines;
      var parts;
      var indentFirst;
      var helpPosition = Math.min(this._actionMaxLength + 2, this._maxHelpPosition);
      var helpWidth = this._width - helpPosition;
      var actionWidth = helpPosition - this._currentIndent - 2;
      var actionHeader = this._formatActionInvocation(action);
      if (!action.help) {
        actionHeader = $$.repeat(" ", this._currentIndent) + actionHeader + c.EOL;
      } else if (actionHeader.length <= actionWidth) {
        actionHeader = $$.repeat(" ", this._currentIndent) + actionHeader + "  " + $$.repeat(" ", actionWidth - actionHeader.length);
        indentFirst = 0;
      } else {
        actionHeader = $$.repeat(" ", this._currentIndent) + actionHeader + c.EOL;
        indentFirst = helpPosition;
      }
      parts = [actionHeader];
      if (action.help) {
        helpText = this._expandHelp(action);
        helpLines = this._splitLines(helpText, helpWidth);
        parts.push($$.repeat(" ", indentFirst) + helpLines[0] + c.EOL);
        helpLines.slice(1).forEach(function(line) {
          parts.push($$.repeat(" ", helpPosition) + line + c.EOL);
        });
      } else if (actionHeader.charAt(actionHeader.length - 1) !== c.EOL) {
        parts.push(c.EOL);
      }
      if (action._getSubactions) {
        this._indent();
        action._getSubactions().forEach(function(subaction) {
          parts.push(self._formatAction(subaction));
        });
        this._dedent();
      }
      return this._joinParts(parts);
    };
    HelpFormatter.prototype._formatActionInvocation = function(action) {
      if (!action.isOptional()) {
        var format_func = this._metavarFormatter(action, action.dest);
        var metavars = format_func(1);
        return metavars[0];
      }
      var parts = [];
      var argsDefault;
      var argsString;
      if (action.nargs === 0) {
        parts = parts.concat(action.optionStrings);
      } else {
        argsDefault = action.dest.toUpperCase();
        argsString = this._formatArgs(action, argsDefault);
        action.optionStrings.forEach(function(optionString) {
          parts.push(optionString + " " + argsString);
        });
      }
      return parts.join(", ");
    };
    HelpFormatter.prototype._metavarFormatter = function(action, metavarDefault) {
      var result;
      if (action.metavar || action.metavar === "") {
        result = action.metavar;
      } else if (action.choices) {
        var choices = action.choices;
        if (typeof choices === "string") {
          choices = choices.split("").join(", ");
        } else if (Array.isArray(choices)) {
          choices = choices.join(",");
        } else {
          choices = Object.keys(choices).join(",");
        }
        result = "{" + choices + "}";
      } else {
        result = metavarDefault;
      }
      return function(size) {
        if (Array.isArray(result)) {
          return result;
        }
        var metavars = [];
        for (var i = 0; i < size; i += 1) {
          metavars.push(result);
        }
        return metavars;
      };
    };
    HelpFormatter.prototype._formatArgs = function(action, metavarDefault) {
      var result;
      var metavars;
      var buildMetavar = this._metavarFormatter(action, metavarDefault);
      switch (action.nargs) {
        case void 0:
        case null:
          metavars = buildMetavar(1);
          result = "" + metavars[0];
          break;
        case c.OPTIONAL:
          metavars = buildMetavar(1);
          result = "[" + metavars[0] + "]";
          break;
        case c.ZERO_OR_MORE:
          metavars = buildMetavar(2);
          result = "[" + metavars[0] + " [" + metavars[1] + " ...]]";
          break;
        case c.ONE_OR_MORE:
          metavars = buildMetavar(2);
          result = "" + metavars[0] + " [" + metavars[1] + " ...]";
          break;
        case c.REMAINDER:
          result = "...";
          break;
        case c.PARSER:
          metavars = buildMetavar(1);
          result = metavars[0] + " ...";
          break;
        default:
          metavars = buildMetavar(action.nargs);
          result = metavars.join(" ");
      }
      return result;
    };
    HelpFormatter.prototype._expandHelp = function(action) {
      var params = { prog: this._prog };
      Object.keys(action).forEach(function(actionProperty) {
        var actionValue = action[actionProperty];
        if (actionValue !== c.SUPPRESS) {
          params[actionProperty] = actionValue;
        }
      });
      if (params.choices) {
        if (typeof params.choices === "string") {
          params.choices = params.choices.split("").join(", ");
        } else if (Array.isArray(params.choices)) {
          params.choices = params.choices.join(", ");
        } else {
          params.choices = Object.keys(params.choices).join(", ");
        }
      }
      return sprintf(this._getHelpString(action), params);
    };
    HelpFormatter.prototype._splitLines = function(text, width) {
      var lines = [];
      var delimiters = [" ", ".", ",", "!", "?"];
      var re = new RegExp("[" + delimiters.join("") + "][^" + delimiters.join("") + "]*$");
      text = text.replace(/[\n\|\t]/g, " ");
      text = text.trim();
      text = text.replace(this._whitespaceMatcher, " ");
      text.split(c.EOL).forEach(function(line) {
        if (width >= line.length) {
          lines.push(line);
          return;
        }
        var wrapStart = 0;
        var wrapEnd = width;
        var delimiterIndex = 0;
        while (wrapEnd <= line.length) {
          if (wrapEnd !== line.length && delimiters.indexOf(line[wrapEnd] < -1)) {
            delimiterIndex = (re.exec(line.substring(wrapStart, wrapEnd)) || {}).index;
            wrapEnd = wrapStart + delimiterIndex + 1;
          }
          lines.push(line.substring(wrapStart, wrapEnd));
          wrapStart = wrapEnd;
          wrapEnd += width;
        }
        if (wrapStart < line.length) {
          lines.push(line.substring(wrapStart, wrapEnd));
        }
      });
      return lines;
    };
    HelpFormatter.prototype._fillText = function(text, width, indent) {
      var lines = this._splitLines(text, width);
      lines = lines.map(function(line) {
        return indent + line;
      });
      return lines.join(c.EOL);
    };
    HelpFormatter.prototype._getHelpString = function(action) {
      return action.help;
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/namespace.js
var require_namespace = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/namespace.js"(exports, module) {
    "use strict";
    var $$ = require_utils();
    var Namespace = module.exports = function Namespace2(options) {
      $$.extend(this, options);
    };
    Namespace.prototype.isset = function(key) {
      return $$.has(this, key);
    };
    Namespace.prototype.set = function(key, value) {
      if (typeof key === "object") {
        $$.extend(this, key);
      } else {
        this[key] = value;
      }
      return this;
    };
    Namespace.prototype.get = function(key, defaultValue) {
      return !this[key] ? defaultValue : this[key];
    };
    Namespace.prototype.unset = function(key, defaultValue) {
      var value = this[key];
      if (value !== null) {
        delete this[key];
        return value;
      }
      return defaultValue;
    };
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument_parser.js
var require_argument_parser = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argument_parser.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var format = __require("util").format;
    var Path = __require("path");
    var sprintf = require_sprintf().sprintf;
    var c = require_const();
    var $$ = require_utils();
    var ActionContainer = require_action_container();
    var argumentErrorHelper = require_error();
    var HelpFormatter = require_formatter();
    var Namespace = require_namespace();
    function ArgumentParser(options) {
      if (!(this instanceof ArgumentParser)) {
        return new ArgumentParser(options);
      }
      var self = this;
      options = options || {};
      options.description = options.description || null;
      options.argumentDefault = options.argumentDefault || null;
      options.prefixChars = options.prefixChars || "-";
      options.conflictHandler = options.conflictHandler || "error";
      ActionContainer.call(this, options);
      options.addHelp = typeof options.addHelp === "undefined" || !!options.addHelp;
      options.parents = options.parents || [];
      options.prog = options.prog || Path.basename(process.argv[1]);
      this.prog = options.prog;
      this.usage = options.usage;
      this.epilog = options.epilog;
      this.version = options.version;
      this.debug = options.debug === true;
      this.formatterClass = options.formatterClass || HelpFormatter;
      this.fromfilePrefixChars = options.fromfilePrefixChars || null;
      this._positionals = this.addArgumentGroup({ title: "Positional arguments" });
      this._optionals = this.addArgumentGroup({ title: "Optional arguments" });
      this._subparsers = null;
      function FUNCTION_IDENTITY(o) {
        return o;
      }
      this.register("type", "auto", FUNCTION_IDENTITY);
      this.register("type", null, FUNCTION_IDENTITY);
      this.register("type", "int", function(x) {
        var result = parseInt(x, 10);
        if (isNaN(result)) {
          throw new Error(x + " is not a valid integer.");
        }
        return result;
      });
      this.register("type", "float", function(x) {
        var result = parseFloat(x);
        if (isNaN(result)) {
          throw new Error(x + " is not a valid float.");
        }
        return result;
      });
      this.register("type", "string", function(x) {
        return "" + x;
      });
      var defaultPrefix = this.prefixChars.indexOf("-") > -1 ? "-" : this.prefixChars[0];
      if (options.addHelp) {
        this.addArgument(
          [defaultPrefix + "h", defaultPrefix + defaultPrefix + "help"],
          {
            action: "help",
            defaultValue: c.SUPPRESS,
            help: "Show this help message and exit."
          }
        );
      }
      if (typeof this.version !== "undefined") {
        this.addArgument(
          [defaultPrefix + "v", defaultPrefix + defaultPrefix + "version"],
          {
            action: "version",
            version: this.version,
            defaultValue: c.SUPPRESS,
            help: "Show program's version number and exit."
          }
        );
      }
      options.parents.forEach(function(parent) {
        self._addContainerActions(parent);
        if (typeof parent._defaults !== "undefined") {
          for (var defaultKey in parent._defaults) {
            if (parent._defaults.hasOwnProperty(defaultKey)) {
              self._defaults[defaultKey] = parent._defaults[defaultKey];
            }
          }
        }
      });
    }
    util.inherits(ArgumentParser, ActionContainer);
    ArgumentParser.prototype.addSubparsers = function(options) {
      if (this._subparsers) {
        this.error("Cannot have multiple subparser arguments.");
      }
      options = options || {};
      options.debug = this.debug === true;
      options.optionStrings = [];
      options.parserClass = options.parserClass || ArgumentParser;
      if (!!options.title || !!options.description) {
        this._subparsers = this.addArgumentGroup({
          title: options.title || "subcommands",
          description: options.description
        });
        delete options.title;
        delete options.description;
      } else {
        this._subparsers = this._positionals;
      }
      if (!options.prog) {
        var formatter = this._getFormatter();
        var positionals = this._getPositionalActions();
        var groups = this._mutuallyExclusiveGroups;
        formatter.addUsage(this.usage, positionals, groups, "");
        options.prog = formatter.formatHelp().trim();
      }
      var ParsersClass = this._popActionClass(options, "parsers");
      var action = new ParsersClass(options);
      this._subparsers._addAction(action);
      return action;
    };
    ArgumentParser.prototype._addAction = function(action) {
      if (action.isOptional()) {
        this._optionals._addAction(action);
      } else {
        this._positionals._addAction(action);
      }
      return action;
    };
    ArgumentParser.prototype._getOptionalActions = function() {
      return this._actions.filter(function(action) {
        return action.isOptional();
      });
    };
    ArgumentParser.prototype._getPositionalActions = function() {
      return this._actions.filter(function(action) {
        return action.isPositional();
      });
    };
    ArgumentParser.prototype.parseArgs = function(args, namespace) {
      var argv;
      var result = this.parseKnownArgs(args, namespace);
      args = result[0];
      argv = result[1];
      if (argv && argv.length > 0) {
        this.error(
          format("Unrecognized arguments: %s.", argv.join(" "))
        );
      }
      return args;
    };
    ArgumentParser.prototype.parseKnownArgs = function(args, namespace) {
      var self = this;
      args = args || process.argv.slice(2);
      namespace = namespace || new Namespace();
      self._actions.forEach(function(action) {
        if (action.dest !== c.SUPPRESS) {
          if (!$$.has(namespace, action.dest)) {
            if (action.defaultValue !== c.SUPPRESS) {
              var defaultValue = action.defaultValue;
              if (typeof action.defaultValue === "string") {
                defaultValue = self._getValue(action, defaultValue);
              }
              namespace[action.dest] = defaultValue;
            }
          }
        }
      });
      Object.keys(self._defaults).forEach(function(dest) {
        namespace[dest] = self._defaults[dest];
      });
      try {
        var res = this._parseKnownArgs(args, namespace);
        namespace = res[0];
        args = res[1];
        if ($$.has(namespace, c._UNRECOGNIZED_ARGS_ATTR)) {
          args = $$.arrayUnion(args, namespace[c._UNRECOGNIZED_ARGS_ATTR]);
          delete namespace[c._UNRECOGNIZED_ARGS_ATTR];
        }
        return [namespace, args];
      } catch (e) {
        this.error(e);
      }
    };
    ArgumentParser.prototype._parseKnownArgs = function(argStrings, namespace) {
      var self = this;
      var extras = [];
      if (this.fromfilePrefixChars !== null) {
        argStrings = this._readArgsFromFiles(argStrings);
      }
      function actionHash(action) {
        return action.getName();
      }
      var conflicts, key;
      var actionConflicts = {};
      this._mutuallyExclusiveGroups.forEach(function(mutexGroup) {
        mutexGroup._groupActions.forEach(function(mutexAction, i, groupActions) {
          key = actionHash(mutexAction);
          if (!$$.has(actionConflicts, key)) {
            actionConflicts[key] = [];
          }
          conflicts = actionConflicts[key];
          conflicts.push.apply(conflicts, groupActions.slice(0, i));
          conflicts.push.apply(conflicts, groupActions.slice(i + 1));
        });
      });
      var optionStringIndices = {};
      var argStringPatternParts = [];
      argStrings.forEach(function(argString, argStringIndex) {
        if (argString === "--") {
          argStringPatternParts.push("-");
          while (argStringIndex < argStrings.length) {
            argStringPatternParts.push("A");
            argStringIndex++;
          }
        } else {
          var pattern;
          var optionTuple = self._parseOptional(argString);
          if (!optionTuple) {
            pattern = "A";
          } else {
            optionStringIndices[argStringIndex] = optionTuple;
            pattern = "O";
          }
          argStringPatternParts.push(pattern);
        }
      });
      var argStringsPattern = argStringPatternParts.join("");
      var seenActions = [];
      var seenNonDefaultActions = [];
      function takeAction(action, argumentStrings, optionString) {
        seenActions.push(action);
        var argumentValues = self._getValues(action, argumentStrings);
        if (argumentValues !== action.defaultValue) {
          seenNonDefaultActions.push(action);
          if (actionConflicts[actionHash(action)]) {
            actionConflicts[actionHash(action)].forEach(function(actionConflict) {
              if (seenNonDefaultActions.indexOf(actionConflict) >= 0) {
                throw argumentErrorHelper(
                  action,
                  format('Not allowed with argument "%s".', actionConflict.getName())
                );
              }
            });
          }
        }
        if (argumentValues !== c.SUPPRESS) {
          action.call(self, namespace, argumentValues, optionString);
        }
      }
      function consumeOptional(startIndex2) {
        var optionTuple = optionStringIndices[startIndex2];
        var action = optionTuple[0];
        var optionString = optionTuple[1];
        var explicitArg = optionTuple[2];
        var actionTuples = [];
        var args, argCount, start, stop;
        for (; ; ) {
          if (!action) {
            extras.push(argStrings[startIndex2]);
            return startIndex2 + 1;
          }
          if (explicitArg) {
            argCount = self._matchArgument(action, "A");
            var chars = self.prefixChars;
            if (argCount === 0 && chars.indexOf(optionString[1]) < 0) {
              actionTuples.push([action, [], optionString]);
              optionString = optionString[0] + explicitArg[0];
              var newExplicitArg = explicitArg.slice(1) || null;
              var optionalsMap = self._optionStringActions;
              if (Object.keys(optionalsMap).indexOf(optionString) >= 0) {
                action = optionalsMap[optionString];
                explicitArg = newExplicitArg;
              } else {
                throw argumentErrorHelper(action, sprintf("ignored explicit argument %r", explicitArg));
              }
            } else if (argCount === 1) {
              stop = startIndex2 + 1;
              args = [explicitArg];
              actionTuples.push([action, args, optionString]);
              break;
            } else {
              throw argumentErrorHelper(action, sprintf("ignored explicit argument %r", explicitArg));
            }
          } else {
            start = startIndex2 + 1;
            var selectedPatterns = argStringsPattern.substr(start);
            argCount = self._matchArgument(action, selectedPatterns);
            stop = start + argCount;
            args = argStrings.slice(start, stop);
            actionTuples.push([action, args, optionString]);
            break;
          }
        }
        if (actionTuples.length < 1) {
          throw new Error("length should be > 0");
        }
        for (var i = 0; i < actionTuples.length; i++) {
          takeAction.apply(self, actionTuples[i]);
        }
        return stop;
      }
      var positionals = self._getPositionalActions();
      function consumePositionals(startIndex2) {
        var selectedPattern = argStringsPattern.substr(startIndex2);
        var argCounts = self._matchArgumentsPartial(positionals, selectedPattern);
        for (var i = 0; i < positionals.length; i++) {
          var action = positionals[i];
          var argCount = argCounts[i];
          if (typeof argCount === "undefined") {
            continue;
          }
          var args = argStrings.slice(startIndex2, startIndex2 + argCount);
          startIndex2 += argCount;
          takeAction(action, args);
        }
        positionals = positionals.slice(argCounts.length);
        return startIndex2;
      }
      var startIndex = 0;
      var position;
      var maxOptionStringIndex = -1;
      Object.keys(optionStringIndices).forEach(function(position2) {
        maxOptionStringIndex = Math.max(maxOptionStringIndex, parseInt(position2, 10));
      });
      var positionalsEndIndex, nextOptionStringIndex;
      while (startIndex <= maxOptionStringIndex) {
        nextOptionStringIndex = null;
        for (position in optionStringIndices) {
          if (!optionStringIndices.hasOwnProperty(position)) {
            continue;
          }
          position = parseInt(position, 10);
          if (position >= startIndex) {
            if (nextOptionStringIndex !== null) {
              nextOptionStringIndex = Math.min(nextOptionStringIndex, position);
            } else {
              nextOptionStringIndex = position;
            }
          }
        }
        if (startIndex !== nextOptionStringIndex) {
          positionalsEndIndex = consumePositionals(startIndex);
          if (positionalsEndIndex > startIndex) {
            startIndex = positionalsEndIndex;
            continue;
          } else {
            startIndex = positionalsEndIndex;
          }
        }
        if (!optionStringIndices[startIndex]) {
          var strings = argStrings.slice(startIndex, nextOptionStringIndex);
          extras = extras.concat(strings);
          startIndex = nextOptionStringIndex;
        }
        startIndex = consumeOptional(startIndex);
      }
      var stopIndex = consumePositionals(startIndex);
      extras = extras.concat(argStrings.slice(stopIndex));
      if (positionals.length > 0) {
        self.error("too few arguments");
      }
      self._actions.forEach(function(action) {
        if (action.required) {
          if (seenActions.indexOf(action) < 0) {
            self.error(format('Argument "%s" is required', action.getName()));
          }
        }
      });
      var actionUsed = false;
      self._mutuallyExclusiveGroups.forEach(function(group) {
        if (group.required) {
          actionUsed = group._groupActions.some(function(action) {
            return seenNonDefaultActions.indexOf(action) !== -1;
          });
          if (!actionUsed) {
            var names = [];
            group._groupActions.forEach(function(action) {
              if (action.help !== c.SUPPRESS) {
                names.push(action.getName());
              }
            });
            names = names.join(" ");
            var msg = "one of the arguments " + names + " is required";
            self.error(msg);
          }
        }
      });
      return [namespace, extras];
    };
    ArgumentParser.prototype._readArgsFromFiles = function(argStrings) {
      var self = this;
      var fs = __require("fs");
      var newArgStrings = [];
      argStrings.forEach(function(argString) {
        if (self.fromfilePrefixChars.indexOf(argString[0]) < 0) {
          newArgStrings.push(argString);
        } else {
          try {
            var argstrs = [];
            var filename = argString.slice(1);
            var content = fs.readFileSync(filename, "utf8");
            content = content.trim().split("\n");
            content.forEach(function(argLine) {
              self.convertArgLineToArgs(argLine).forEach(function(arg) {
                argstrs.push(arg);
              });
              argstrs = self._readArgsFromFiles(argstrs);
            });
            newArgStrings.push.apply(newArgStrings, argstrs);
          } catch (error) {
            return self.error(error.message);
          }
        }
      });
      return newArgStrings;
    };
    ArgumentParser.prototype.convertArgLineToArgs = function(argLine) {
      return [argLine];
    };
    ArgumentParser.prototype._matchArgument = function(action, regexpArgStrings) {
      var regexpNargs = new RegExp("^" + this._getNargsPattern(action));
      var matches = regexpArgStrings.match(regexpNargs);
      var message;
      if (!matches) {
        switch (action.nargs) {
          case void 0:
          case null:
            message = "Expected one argument.";
            break;
          case c.OPTIONAL:
            message = "Expected at most one argument.";
            break;
          case c.ONE_OR_MORE:
            message = "Expected at least one argument.";
            break;
          default:
            message = "Expected %s argument(s)";
        }
        throw argumentErrorHelper(
          action,
          format(message, action.nargs)
        );
      }
      return matches[1].length;
    };
    ArgumentParser.prototype._matchArgumentsPartial = function(actions, regexpArgStrings) {
      var self = this;
      var result = [];
      var actionSlice, pattern, matches;
      var i, j;
      function getLength(string) {
        return string.length;
      }
      for (i = actions.length; i > 0; i--) {
        pattern = "";
        actionSlice = actions.slice(0, i);
        for (j = 0; j < actionSlice.length; j++) {
          pattern += self._getNargsPattern(actionSlice[j]);
        }
        pattern = new RegExp("^" + pattern);
        matches = regexpArgStrings.match(pattern);
        if (matches && matches.length > 0) {
          matches = matches.splice(1);
          result = result.concat(matches.map(getLength));
          break;
        }
      }
      return result;
    };
    ArgumentParser.prototype._parseOptional = function(argString) {
      var action, optionString, argExplicit, optionTuples;
      if (!argString) {
        return null;
      }
      if (this.prefixChars.indexOf(argString[0]) < 0) {
        return null;
      }
      if (this._optionStringActions[argString]) {
        return [this._optionStringActions[argString], argString, null];
      }
      if (argString.length === 1) {
        return null;
      }
      if (argString.indexOf("=") >= 0) {
        optionString = argString.split("=", 1)[0];
        argExplicit = argString.slice(optionString.length + 1);
        if (this._optionStringActions[optionString]) {
          action = this._optionStringActions[optionString];
          return [action, optionString, argExplicit];
        }
      }
      optionTuples = this._getOptionTuples(argString);
      if (optionTuples.length > 1) {
        var optionStrings = optionTuples.map(function(optionTuple) {
          return optionTuple[1];
        });
        this.error(format(
          'Ambiguous option: "%s" could match %s.',
          argString,
          optionStrings.join(", ")
        ));
      } else if (optionTuples.length === 1) {
        return optionTuples[0];
      }
      if (argString.match(this._regexpNegativeNumber)) {
        if (!this._hasNegativeNumberOptionals.some(Boolean)) {
          return null;
        }
      }
      if (argString.search(" ") >= 0) {
        return null;
      }
      return [null, argString, null];
    };
    ArgumentParser.prototype._getOptionTuples = function(optionString) {
      var result = [];
      var chars = this.prefixChars;
      var optionPrefix;
      var argExplicit;
      var action;
      var actionOptionString;
      if (chars.indexOf(optionString[0]) >= 0 && chars.indexOf(optionString[1]) >= 0) {
        if (optionString.indexOf("=") >= 0) {
          var optionStringSplit = optionString.split("=", 1);
          optionPrefix = optionStringSplit[0];
          argExplicit = optionStringSplit[1];
        } else {
          optionPrefix = optionString;
          argExplicit = null;
        }
        for (actionOptionString in this._optionStringActions) {
          if (actionOptionString.substr(0, optionPrefix.length) === optionPrefix) {
            action = this._optionStringActions[actionOptionString];
            result.push([action, actionOptionString, argExplicit]);
          }
        }
      } else if (chars.indexOf(optionString[0]) >= 0 && chars.indexOf(optionString[1]) < 0) {
        optionPrefix = optionString;
        argExplicit = null;
        var optionPrefixShort = optionString.substr(0, 2);
        var argExplicitShort = optionString.substr(2);
        for (actionOptionString in this._optionStringActions) {
          if (!$$.has(this._optionStringActions, actionOptionString))
            continue;
          action = this._optionStringActions[actionOptionString];
          if (actionOptionString === optionPrefixShort) {
            result.push([action, actionOptionString, argExplicitShort]);
          } else if (actionOptionString.substr(0, optionPrefix.length) === optionPrefix) {
            result.push([action, actionOptionString, argExplicit]);
          }
        }
      } else {
        throw new Error(format("Unexpected option string: %s.", optionString));
      }
      return result;
    };
    ArgumentParser.prototype._getNargsPattern = function(action) {
      var regexpNargs;
      switch (action.nargs) {
        case void 0:
        case null:
          regexpNargs = "(-*A-*)";
          break;
        case c.OPTIONAL:
          regexpNargs = "(-*A?-*)";
          break;
        case c.ZERO_OR_MORE:
          regexpNargs = "(-*[A-]*)";
          break;
        case c.ONE_OR_MORE:
          regexpNargs = "(-*A[A-]*)";
          break;
        case c.REMAINDER:
          regexpNargs = "([-AO]*)";
          break;
        case c.PARSER:
          regexpNargs = "(-*A[-AO]*)";
          break;
        default:
          regexpNargs = "(-*" + $$.repeat("-*A", action.nargs) + "-*)";
      }
      if (action.isOptional()) {
        regexpNargs = regexpNargs.replace(/-\*/g, "");
        regexpNargs = regexpNargs.replace(/-/g, "");
      }
      return regexpNargs;
    };
    ArgumentParser.prototype._getValues = function(action, argStrings) {
      var self = this;
      if (action.nargs !== c.PARSER && action.nargs !== c.REMAINDER) {
        argStrings = argStrings.filter(function(arrayElement) {
          return arrayElement !== "--";
        });
      }
      var value, argString;
      if (argStrings.length === 0 && action.nargs === c.OPTIONAL) {
        value = action.isOptional() ? action.constant : action.defaultValue;
        if (typeof value === "string") {
          value = this._getValue(action, value);
          this._checkValue(action, value);
        }
      } else if (argStrings.length === 0 && action.nargs === c.ZERO_OR_MORE && action.optionStrings.length === 0) {
        value = action.defaultValue || argStrings;
        this._checkValue(action, value);
      } else if (argStrings.length === 1 && (!action.nargs || action.nargs === c.OPTIONAL)) {
        argString = argStrings[0];
        value = this._getValue(action, argString);
        this._checkValue(action, value);
      } else if (action.nargs === c.REMAINDER) {
        value = argStrings.map(function(v) {
          return self._getValue(action, v);
        });
      } else if (action.nargs === c.PARSER) {
        value = argStrings.map(function(v) {
          return self._getValue(action, v);
        });
        this._checkValue(action, value[0]);
      } else {
        value = argStrings.map(function(v) {
          return self._getValue(action, v);
        });
        value.forEach(function(v) {
          self._checkValue(action, v);
        });
      }
      return value;
    };
    ArgumentParser.prototype._getValue = function(action, argString) {
      var result;
      var typeFunction = this._registryGet("type", action.type, action.type);
      if (typeof typeFunction !== "function") {
        var message = format("%s is not callable", typeFunction);
        throw argumentErrorHelper(action, message);
      }
      try {
        result = typeFunction(argString);
      } catch (e) {
        var name = null;
        if (typeof action.type === "string") {
          name = action.type;
        } else {
          name = action.type.name || action.type.displayName || "<function>";
        }
        var msg = format("Invalid %s value: %s", name, argString);
        if (name === "<function>") {
          msg += "\n" + e.message;
        }
        throw argumentErrorHelper(action, msg);
      }
      return result;
    };
    ArgumentParser.prototype._checkValue = function(action, value) {
      var choices = action.choices;
      if (choices) {
        if ((typeof choices === "string" || Array.isArray(choices)) && choices.indexOf(value) !== -1) {
          return;
        }
        if (typeof choices === "object" && !Array.isArray(choices) && choices[value]) {
          return;
        }
        if (typeof choices === "string") {
          choices = choices.split("").join(", ");
        } else if (Array.isArray(choices)) {
          choices = choices.join(", ");
        } else {
          choices = Object.keys(choices).join(", ");
        }
        var message = format("Invalid choice: %s (choose from [%s])", value, choices);
        throw argumentErrorHelper(action, message);
      }
    };
    ArgumentParser.prototype.formatUsage = function() {
      var formatter = this._getFormatter();
      formatter.addUsage(this.usage, this._actions, this._mutuallyExclusiveGroups);
      return formatter.formatHelp();
    };
    ArgumentParser.prototype.formatHelp = function() {
      var formatter = this._getFormatter();
      formatter.addUsage(this.usage, this._actions, this._mutuallyExclusiveGroups);
      formatter.addText(this.description);
      this._actionGroups.forEach(function(actionGroup) {
        formatter.startSection(actionGroup.title);
        formatter.addText(actionGroup.description);
        formatter.addArguments(actionGroup._groupActions);
        formatter.endSection();
      });
      formatter.addText(this.epilog);
      return formatter.formatHelp();
    };
    ArgumentParser.prototype._getFormatter = function() {
      var FormatterClass = this.formatterClass;
      var formatter = new FormatterClass({ prog: this.prog });
      return formatter;
    };
    ArgumentParser.prototype.printUsage = function() {
      this._printMessage(this.formatUsage());
    };
    ArgumentParser.prototype.printHelp = function() {
      this._printMessage(this.formatHelp());
    };
    ArgumentParser.prototype._printMessage = function(message, stream) {
      if (!stream) {
        stream = process.stdout;
      }
      if (message) {
        stream.write("" + message);
      }
    };
    ArgumentParser.prototype.exit = function(status, message) {
      if (message) {
        if (status === 0) {
          this._printMessage(message);
        } else {
          this._printMessage(message, process.stderr);
        }
      }
      process.exit(status);
    };
    ArgumentParser.prototype.error = function(err) {
      var message;
      if (err instanceof Error) {
        if (this.debug === true) {
          throw err;
        }
        message = err.message;
      } else {
        message = err;
      }
      var msg = format("%s: error: %s", this.prog, message) + c.EOL;
      if (this.debug === true) {
        throw new Error(msg);
      }
      this.printUsage(process.stderr);
      return this.exit(2, msg);
    };
    module.exports = ArgumentParser;
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/help/added_formatters.js
var require_added_formatters = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/help/added_formatters.js"(exports, module) {
    "use strict";
    var util = __require("util");
    var c = require_const();
    var $$ = require_utils();
    var HelpFormatter = require_formatter();
    function ArgumentDefaultsHelpFormatter(options) {
      HelpFormatter.call(this, options);
    }
    util.inherits(ArgumentDefaultsHelpFormatter, HelpFormatter);
    ArgumentDefaultsHelpFormatter.prototype._getHelpString = function(action) {
      var help = action.help;
      if (action.help.indexOf("%(defaultValue)s") === -1) {
        if (action.defaultValue !== c.SUPPRESS) {
          var defaulting_nargs = [c.OPTIONAL, c.ZERO_OR_MORE];
          if (action.isOptional() || defaulting_nargs.indexOf(action.nargs) >= 0) {
            help += " (default: %(defaultValue)s)";
          }
        }
      }
      return help;
    };
    module.exports.ArgumentDefaultsHelpFormatter = ArgumentDefaultsHelpFormatter;
    function RawDescriptionHelpFormatter(options) {
      HelpFormatter.call(this, options);
    }
    util.inherits(RawDescriptionHelpFormatter, HelpFormatter);
    RawDescriptionHelpFormatter.prototype._fillText = function(text, width, indent) {
      var lines = text.split("\n");
      lines = lines.map(function(line) {
        return $$.trimEnd(indent + line);
      });
      return lines.join("\n");
    };
    module.exports.RawDescriptionHelpFormatter = RawDescriptionHelpFormatter;
    function RawTextHelpFormatter(options) {
      RawDescriptionHelpFormatter.call(this, options);
    }
    util.inherits(RawTextHelpFormatter, RawDescriptionHelpFormatter);
    RawTextHelpFormatter.prototype._splitLines = function(text) {
      return text.split("\n");
    };
    module.exports.RawTextHelpFormatter = RawTextHelpFormatter;
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argparse.js
var require_argparse = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/lib/argparse.js"(exports, module) {
    "use strict";
    module.exports.ArgumentParser = require_argument_parser();
    module.exports.Namespace = require_namespace();
    module.exports.Action = require_action();
    module.exports.HelpFormatter = require_formatter();
    module.exports.Const = require_const();
    module.exports.ArgumentDefaultsHelpFormatter = require_added_formatters().ArgumentDefaultsHelpFormatter;
    module.exports.RawDescriptionHelpFormatter = require_added_formatters().RawDescriptionHelpFormatter;
    module.exports.RawTextHelpFormatter = require_added_formatters().RawTextHelpFormatter;
  }
});

// ../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/index.js
var require_argparse2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/argparse@1.0.10/node_modules/argparse/index.js"(exports, module) {
    "use strict";
    module.exports = require_argparse();
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/BaseClasses.js
var require_BaseClasses = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/BaseClasses.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineParameterWithArgument = exports.CommandLineParameter = exports.CommandLineParameterKind = void 0;
    var CommandLineParameterKind;
    (function(CommandLineParameterKind2) {
      CommandLineParameterKind2[CommandLineParameterKind2["Choice"] = 0] = "Choice";
      CommandLineParameterKind2[CommandLineParameterKind2["Flag"] = 1] = "Flag";
      CommandLineParameterKind2[CommandLineParameterKind2["Integer"] = 2] = "Integer";
      CommandLineParameterKind2[CommandLineParameterKind2["String"] = 3] = "String";
      CommandLineParameterKind2[CommandLineParameterKind2["StringList"] = 4] = "StringList";
      CommandLineParameterKind2[CommandLineParameterKind2["ChoiceList"] = 5] = "ChoiceList";
      CommandLineParameterKind2[CommandLineParameterKind2["IntegerList"] = 6] = "IntegerList";
    })(CommandLineParameterKind = exports.CommandLineParameterKind || (exports.CommandLineParameterKind = {}));
    var LONG_NAME_REGEXP = /^-(-[a-z0-9]+)+$/;
    var SHORT_NAME_REGEXP = /^-[a-zA-Z]$/;
    var SCOPE_REGEXP = /^[a-z0-9]+(-[a-z0-9]+)*$/;
    var ENVIRONMENT_VARIABLE_NAME_REGEXP = /^[A-Z_][A-Z0-9_]*$/;
    var CommandLineParameter = class {
      /** @internal */
      constructor(definition) {
        this.longName = definition.parameterLongName;
        this.shortName = definition.parameterShortName;
        this.parameterGroup = definition.parameterGroup;
        this.parameterScope = definition.parameterScope;
        this.description = definition.description;
        this.required = !!definition.required;
        this.environmentVariable = definition.environmentVariable;
        this.undocumentedSynonyms = definition.undocumentedSynonyms;
        if (!LONG_NAME_REGEXP.test(this.longName)) {
          throw new Error(`Invalid name: "${this.longName}". The parameter long name must be lower-case and use dash delimiters (e.g. "--do-a-thing")`);
        }
        if (this.shortName) {
          if (!SHORT_NAME_REGEXP.test(this.shortName)) {
            throw new Error(`Invalid name: "${this.shortName}". The parameter short name must be a dash followed by a single upper-case or lower-case letter (e.g. "-a")`);
          }
        }
        if (this.parameterScope) {
          if (!SCOPE_REGEXP.test(this.parameterScope)) {
            throw new Error(`Invalid scope: "${this.parameterScope}". The parameter scope name must be lower-case and use dash delimiters (e.g. "my-scope")`);
          }
          const unprefixedLongName = this.longName.slice(2);
          this.scopedLongName = `--${this.parameterScope}:${unprefixedLongName}`;
        }
        if (this.environmentVariable) {
          if (this.required) {
            throw new Error(`An "environmentVariable" cannot be specified for "${this.longName}" because it is a required parameter`);
          }
          if (!ENVIRONMENT_VARIABLE_NAME_REGEXP.test(this.environmentVariable)) {
            throw new Error(`Invalid environment variable name: "${this.environmentVariable}". The name must consist only of upper-case letters, numbers, and underscores. It may not start with a number.`);
          }
        }
        if (this.undocumentedSynonyms && this.undocumentedSynonyms.length > 0) {
          for (const undocumentedSynonym of this.undocumentedSynonyms) {
            if (this.longName === undocumentedSynonym) {
              throw new Error(`Invalid name: "${undocumentedSynonym}". Undocumented synonyms must not be the same as the the long name.`);
            } else if (!LONG_NAME_REGEXP.test(undocumentedSynonym)) {
              throw new Error(`Invalid name: "${undocumentedSynonym}". All undocumented synonyms name must be lower-case and use dash delimiters (e.g. "--do-a-thing")`);
            }
          }
        }
      }
      /**
       * Returns additional text used by the help formatter.
       * @internal
       */
      _getSupplementaryNotes(supplementaryNotes) {
        if (this.environmentVariable !== void 0) {
          supplementaryNotes.push("This parameter may alternatively be specified via the " + this.environmentVariable + " environment variable.");
        }
      }
      /**
       * Internal usage only.  Used to report unexpected output from the argparse library.
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      reportInvalidData(data) {
        throw new Error(`Unexpected data object for parameter "${this.longName}": ` + JSON.stringify(data));
      }
      validateDefaultValue(hasDefaultValue) {
        if (this.required && hasDefaultValue) {
          throw new Error(`A default value cannot be specified for "${this.longName}" because it is a "required" parameter`);
        }
      }
    };
    exports.CommandLineParameter = CommandLineParameter;
    var CommandLineParameterWithArgument = class extends CommandLineParameter {
      /** @internal */
      constructor(definition) {
        super(definition);
        if (definition.argumentName === "") {
          throw new Error("The argument name cannot be an empty string. (For the default name, specify undefined.)");
        }
        if (definition.argumentName.toUpperCase() !== definition.argumentName) {
          throw new Error(`Invalid name: "${definition.argumentName}". The argument name must be all upper case.`);
        }
        const match = definition.argumentName.match(CommandLineParameterWithArgument._invalidArgumentNameRegExp);
        if (match) {
          throw new Error(`The argument name "${definition.argumentName}" contains an invalid character "${match[0]}". Only upper-case letters, numbers, and underscores are allowed.`);
        }
        this.argumentName = definition.argumentName;
        this.completions = definition.completions;
      }
    };
    exports.CommandLineParameterWithArgument = CommandLineParameterWithArgument;
    CommandLineParameterWithArgument._invalidArgumentNameRegExp = /[^A-Z_0-9]/;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineChoiceParameter.js
var require_CommandLineChoiceParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineChoiceParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineChoiceParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var CommandLineChoiceParameter2 = class extends BaseClasses_1.CommandLineParameter {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._value = void 0;
        if (definition.alternatives.length < 1) {
          throw new Error(`When defining a choice parameter, the alternatives list must contain at least one value.`);
        }
        if (definition.defaultValue && definition.alternatives.indexOf(definition.defaultValue) === -1) {
          throw new Error(`The specified default value "${definition.defaultValue}" is not one of the available options: ${definition.alternatives.toString()}`);
        }
        this.alternatives = definition.alternatives;
        this.defaultValue = definition.defaultValue;
        this.validateDefaultValue(!!this.defaultValue);
        this.completions = definition.completions;
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.Choice;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (typeof data !== "string") {
            this.reportInvalidData(data);
          }
          this._value = data;
          return;
        }
        if (this.environmentVariable !== void 0) {
          const environmentValue = process.env[this.environmentVariable];
          if (environmentValue !== void 0 && environmentValue !== "") {
            if (this.alternatives.indexOf(environmentValue) < 0) {
              const choices = '"' + this.alternatives.join('", "') + '"';
              throw new Error(`Invalid value "${environmentValue}" for the environment variable ${this.environmentVariable}.  Valid choices are: ${choices}`);
            }
            this._value = environmentValue;
            return;
          }
        }
        if (this.defaultValue !== void 0) {
          this._value = this.defaultValue;
          return;
        }
        this._value = void 0;
      }
      /**
       * {@inheritDoc CommandLineParameter._getSupplementaryNotes}
       * @internal
       */
      _getSupplementaryNotes(supplementaryNotes) {
        super._getSupplementaryNotes(supplementaryNotes);
        if (this.defaultValue !== void 0) {
          supplementaryNotes.push(`The default value is "${this.defaultValue}".`);
        }
      }
      /**
       * Returns the argument value for a choice parameter that was parsed from the command line.
       *
       * @remarks
       * The return value will be `undefined` if the command-line has not been parsed yet,
       * or if the parameter was omitted and has no default value.
       */
      get value() {
        return this._value;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.value !== void 0) {
          argList.push(this.longName);
          argList.push(this.value);
        }
      }
    };
    exports.CommandLineChoiceParameter = CommandLineChoiceParameter2;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/EnvironmentVariableParser.js
var require_EnvironmentVariableParser = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/EnvironmentVariableParser.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.EnvironmentVariableParser = void 0;
    var EnvironmentVariableParser = class {
      static parseAsList(envVarName) {
        const environmentValue = process.env[envVarName];
        if (environmentValue !== void 0) {
          if (environmentValue.trimLeft()[0] === "[") {
            try {
              const parsedJson = JSON.parse(environmentValue);
              if (!Array.isArray(parsedJson) || !parsedJson.every((x) => typeof x === "string" || typeof x === "boolean" || typeof x === "number")) {
                throw new Error(`The ${environmentValue} environment variable value must be a JSON  array containing only strings, numbers, and booleans.`);
              }
              return parsedJson.map((x) => x.toString());
            } catch (ex) {
              throw new Error(`The ${environmentValue} environment variable value looks like a JSON array but failed to parse: ` + ex.message);
            }
          } else {
            return [environmentValue];
          }
        }
        return void 0;
      }
    };
    exports.EnvironmentVariableParser = EnvironmentVariableParser;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineChoiceListParameter.js
var require_CommandLineChoiceListParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineChoiceListParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineChoiceListParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var EnvironmentVariableParser_1 = require_EnvironmentVariableParser();
    var CommandLineChoiceListParameter = class extends BaseClasses_1.CommandLineParameter {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._values = [];
        if (definition.alternatives.length < 1) {
          throw new Error(`When defining a choice list parameter, the alternatives list must contain at least one value.`);
        }
        this.alternatives = definition.alternatives;
        this.completions = definition.completions;
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.ChoiceList;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (!Array.isArray(data)) {
            this.reportInvalidData(data);
          }
          for (const arrayItem of data) {
            if (typeof arrayItem !== "string") {
              this.reportInvalidData(data);
            }
          }
          this._values = data;
          return;
        }
        if (this.environmentVariable !== void 0) {
          const values = EnvironmentVariableParser_1.EnvironmentVariableParser.parseAsList(this.environmentVariable);
          if (values) {
            for (const value of values) {
              if (this.alternatives.indexOf(value) < 0) {
                const choices = '"' + this.alternatives.join('", "') + '"';
                throw new Error(`Invalid value "${value}" for the environment variable ${this.environmentVariable}.  Valid choices are: ${choices}`);
              }
            }
            this._values = values;
            return;
          }
        }
        this._values = [];
      }
      /**
       * Returns the string arguments for a choice list parameter that was parsed from the command line.
       *
       * @remarks
       * The array will be empty if the command-line has not been parsed yet,
       * or if the parameter was omitted and has no default value.
       */
      get values() {
        return this._values;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.values.length > 0) {
          for (const value of this.values) {
            argList.push(this.longName);
            argList.push(value);
          }
        }
      }
    };
    exports.CommandLineChoiceListParameter = CommandLineChoiceListParameter;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineIntegerParameter.js
var require_CommandLineIntegerParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineIntegerParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineIntegerParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var CommandLineIntegerParameter = class extends BaseClasses_1.CommandLineParameterWithArgument {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._value = void 0;
        this.defaultValue = definition.defaultValue;
        this.validateDefaultValue(!!this.defaultValue);
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.Integer;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (typeof data !== "number") {
            this.reportInvalidData(data);
          }
          this._value = data;
          return;
        }
        if (this.environmentVariable !== void 0) {
          const environmentValue = process.env[this.environmentVariable];
          if (environmentValue !== void 0 && environmentValue !== "") {
            const parsed = parseInt(environmentValue, 10);
            if (isNaN(parsed) || environmentValue.indexOf(".") >= 0) {
              throw new Error(`Invalid value "${environmentValue}" for the environment variable ${this.environmentVariable}.  It must be an integer value.`);
            }
            this._value = parsed;
            return;
          }
        }
        if (this.defaultValue !== void 0) {
          this._value = this.defaultValue;
          return;
        }
        this._value = void 0;
      }
      /**
       * {@inheritDoc CommandLineParameter._getSupplementaryNotes}
       * @internal
       */
      _getSupplementaryNotes(supplementaryNotes) {
        super._getSupplementaryNotes(supplementaryNotes);
        if (this.defaultValue !== void 0) {
          supplementaryNotes.push(`The default value is ${this.defaultValue}.`);
        }
      }
      /**
       * Returns the argument value for an integer parameter that was parsed from the command line.
       *
       * @remarks
       * The return value will be undefined if the command-line has not been parsed yet,
       * or if the parameter was omitted and has no default value.
       */
      get value() {
        return this._value;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.value !== void 0) {
          argList.push(this.longName);
          argList.push(this.value.toString());
        }
      }
    };
    exports.CommandLineIntegerParameter = CommandLineIntegerParameter;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineIntegerListParameter.js
var require_CommandLineIntegerListParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineIntegerListParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineIntegerListParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var EnvironmentVariableParser_1 = require_EnvironmentVariableParser();
    var CommandLineIntegerListParameter = class extends BaseClasses_1.CommandLineParameterWithArgument {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._values = [];
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.IntegerList;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (!Array.isArray(data)) {
            this.reportInvalidData(data);
          }
          for (const arrayItem of data) {
            if (typeof arrayItem !== "number") {
              this.reportInvalidData(data);
            }
          }
          this._values = data;
          return;
        }
        if (this.environmentVariable !== void 0) {
          const values = EnvironmentVariableParser_1.EnvironmentVariableParser.parseAsList(this.environmentVariable);
          if (values) {
            const parsedValues = [];
            for (const value of values) {
              const parsed = parseInt(value, 10);
              if (isNaN(parsed) || value.indexOf(".") >= 0) {
                throw new Error(`Invalid value "${value}" for the environment variable ${this.environmentVariable}.  It must be an integer value.`);
              }
              parsedValues.push(parsed);
            }
            this._values = parsedValues;
            return;
          }
        }
        this._values = [];
      }
      /**
       * Returns the integer arguments for an integer list parameter that was parsed from the command line.
       *
       * @remarks
       * The array will be empty if the command-line has not been parsed yet,
       * or if the parameter was omitted and has no default value.
       */
      get values() {
        return this._values;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.values.length > 0) {
          for (const value of this.values) {
            argList.push(this.longName);
            argList.push(value.toString());
          }
        }
      }
    };
    exports.CommandLineIntegerListParameter = CommandLineIntegerListParameter;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineFlagParameter.js
var require_CommandLineFlagParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineFlagParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineFlagParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var CommandLineFlagParameter2 = class extends BaseClasses_1.CommandLineParameter {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._value = false;
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.Flag;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (typeof data !== "boolean") {
            this.reportInvalidData(data);
          }
          if (data) {
            this._value = data;
            return;
          }
        }
        if (this.environmentVariable !== void 0) {
          const environmentValue = process.env[this.environmentVariable];
          if (environmentValue !== void 0 && environmentValue !== "") {
            if (environmentValue !== "0" && environmentValue !== "1") {
              throw new Error(`Invalid value "${environmentValue}" for the environment variable ${this.environmentVariable}.  Valid choices are 0 or 1.`);
            }
            this._value = environmentValue === "1";
            return;
          }
        }
        this._value = false;
      }
      /**
       * Returns a boolean indicating whether the parameter was included in the command line.
       *
       * @remarks
       * The return value will be false if the command-line has not been parsed yet,
       * or if the flag was not used.
       */
      get value() {
        return this._value;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.value) {
          argList.push(this.longName);
        }
      }
    };
    exports.CommandLineFlagParameter = CommandLineFlagParameter2;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineStringParameter.js
var require_CommandLineStringParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineStringParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineStringParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var CommandLineStringParameter2 = class extends BaseClasses_1.CommandLineParameterWithArgument {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._value = void 0;
        this.defaultValue = definition.defaultValue;
        this.validateDefaultValue(!!this.defaultValue);
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.String;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (typeof data !== "string") {
            this.reportInvalidData(data);
          }
          this._value = data;
          return;
        }
        if (this.environmentVariable !== void 0) {
          const environmentValue = process.env[this.environmentVariable];
          if (environmentValue !== void 0) {
            this._value = environmentValue;
            return;
          }
        }
        if (this.defaultValue !== void 0) {
          this._value = this.defaultValue;
          return;
        }
        this._value = void 0;
      }
      /**
       * {@inheritDoc CommandLineParameter._getSupplementaryNotes}
       * @internal
       */
      _getSupplementaryNotes(supplementaryNotes) {
        super._getSupplementaryNotes(supplementaryNotes);
        if (this.defaultValue !== void 0) {
          if (this.defaultValue.length < 160) {
            supplementaryNotes.push(`The default value is ${JSON.stringify(this.defaultValue)}.`);
          }
        }
      }
      /**
       * Returns the argument value for a string parameter that was parsed from the command line.
       *
       * @remarks
       * The return value will be undefined if the command-line has not been parsed yet,
       * or if the parameter was omitted and has no default value.
       */
      get value() {
        return this._value;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.value !== void 0) {
          argList.push(this.longName);
          argList.push(this.value);
        }
      }
    };
    exports.CommandLineStringParameter = CommandLineStringParameter2;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineStringListParameter.js
var require_CommandLineStringListParameter = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineStringListParameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineStringListParameter = void 0;
    var BaseClasses_1 = require_BaseClasses();
    var EnvironmentVariableParser_1 = require_EnvironmentVariableParser();
    var CommandLineStringListParameter = class extends BaseClasses_1.CommandLineParameterWithArgument {
      /** @internal */
      constructor(definition) {
        super(definition);
        this._values = [];
      }
      /** {@inheritDoc CommandLineParameter.kind} */
      get kind() {
        return BaseClasses_1.CommandLineParameterKind.StringList;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (data !== null && data !== void 0) {
          if (!Array.isArray(data)) {
            this.reportInvalidData(data);
          }
          for (const arrayItem of data) {
            if (typeof arrayItem !== "string") {
              this.reportInvalidData(data);
            }
          }
          this._values = data;
          return;
        }
        if (this.environmentVariable !== void 0) {
          const values = EnvironmentVariableParser_1.EnvironmentVariableParser.parseAsList(this.environmentVariable);
          if (values) {
            this._values = values;
            return;
          }
        }
        this._values = [];
      }
      /**
       * Returns the string arguments for a string list parameter that was parsed from the command line.
       *
       * @remarks
       * The array will be empty if the command-line has not been parsed yet,
       * or if the parameter was omitted and has no default value.
       */
      get values() {
        return this._values;
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.values.length > 0) {
          for (const value of this.values) {
            argList.push(this.longName);
            argList.push(value);
          }
        }
      }
    };
    exports.CommandLineStringListParameter = CommandLineStringListParameter;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineRemainder.js
var require_CommandLineRemainder = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/parameters/CommandLineRemainder.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineRemainder = void 0;
    var CommandLineRemainder = class {
      /** @internal */
      constructor(definition) {
        this._values = [];
        this.description = definition.description;
      }
      /**
       * Returns any remaining command line arguments after the recognized portion
       * that was parsed from the command line.
       *
       * @remarks
       * The array will be empty if the command-line has not been parsed yet.
       */
      get values() {
        return this._values;
      }
      /**
       * {@inheritDoc CommandLineParameter._setValue}
       * @internal
       */
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      _setValue(data) {
        if (!Array.isArray(data) || !data.every((x) => typeof x === "string")) {
          throw new Error(`Unexpected data object for remainder: ` + JSON.stringify(data));
        }
        this._values.push(...data);
      }
      /** {@inheritDoc CommandLineParameter.appendToArgList} @override */
      appendToArgList(argList) {
        if (this.values.length > 0) {
          for (const value of this.values) {
            argList.push(value);
          }
        }
      }
    };
    exports.CommandLineRemainder = CommandLineRemainder;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/Constants.js
var require_Constants = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/Constants.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SCOPING_PARAMETER_GROUP = void 0;
    exports.SCOPING_PARAMETER_GROUP = Symbol("scoping");
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineParameterProvider.js
var require_CommandLineParameterProvider = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineParameterProvider.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineParameterProvider = void 0;
    var argparse = __importStar(require_argparse2());
    var BaseClasses_1 = require_BaseClasses();
    var CommandLineChoiceParameter_1 = require_CommandLineChoiceParameter();
    var CommandLineChoiceListParameter_1 = require_CommandLineChoiceListParameter();
    var CommandLineIntegerParameter_1 = require_CommandLineIntegerParameter();
    var CommandLineIntegerListParameter_1 = require_CommandLineIntegerListParameter();
    var CommandLineFlagParameter_1 = require_CommandLineFlagParameter();
    var CommandLineStringParameter_1 = require_CommandLineStringParameter();
    var CommandLineStringListParameter_1 = require_CommandLineStringListParameter();
    var CommandLineRemainder_1 = require_CommandLineRemainder();
    var Constants_1 = require_Constants();
    var SCOPE_GROUP_NAME = "scope";
    var LONG_NAME_GROUP_NAME = "longName";
    var POSSIBLY_SCOPED_LONG_NAME_REGEXP = /^--((?<scope>[a-z0-9]+(-[a-z0-9]+)*):)?(?<longName>[a-z0-9]+((-[a-z0-9]+)+)?)$/;
    var CommandLineParameterProvider = class {
      /** @internal */
      // Third party code should not inherit subclasses or call this constructor
      constructor() {
        this._parameters = [];
        this._parametersByLongName = /* @__PURE__ */ new Map();
        this._parameterGroupsByName = /* @__PURE__ */ new Map();
        this._parametersRegistered = false;
        this._parametersProcessed = false;
      }
      /**
       * Returns a collection of the parameters that were defined for this object.
       */
      get parameters() {
        return this._parameters;
      }
      /**
       * Informs the caller if the argparse data has been processed into parameters.
       */
      get parametersProcessed() {
        return this._parametersProcessed;
      }
      /**
       * If {@link CommandLineParameterProvider.defineCommandLineRemainder} was called,
       * this object captures any remaining command line arguments after the recognized portion.
       */
      get remainder() {
        return this._remainder;
      }
      /**
       * Defines a command-line parameter whose value must be a string from a fixed set of
       * allowable choices (similar to an enum).
       *
       * @remarks
       * Example of a choice parameter:
       * ```
       * example-tool --log-level warn
       * ```
       */
      defineChoiceParameter(definition) {
        const parameter = new CommandLineChoiceParameter_1.CommandLineChoiceParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Returns the CommandLineChoiceParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getChoiceParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.Choice, parameterScope);
      }
      /**
       * Defines a command-line parameter whose value must be a string from a fixed set of
       * allowable choices (similar to an enum). The parameter can be specified multiple times to
       * build a list.
       *
       * @remarks
       * Example of a choice list parameter:
       * ```
       * example-tool --allow-color red --allow-color green
       * ```
       */
      defineChoiceListParameter(definition) {
        const parameter = new CommandLineChoiceListParameter_1.CommandLineChoiceListParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Returns the CommandLineChoiceListParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getChoiceListParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.ChoiceList, parameterScope);
      }
      /**
       * Defines a command-line switch whose boolean value is true if the switch is provided,
       * and false otherwise.
       *
       * @remarks
       * Example usage of a flag parameter:
       * ```
       * example-tool --debug
       * ```
       */
      defineFlagParameter(definition) {
        const parameter = new CommandLineFlagParameter_1.CommandLineFlagParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Returns the CommandLineFlagParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getFlagParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.Flag, parameterScope);
      }
      /**
       * Defines a command-line parameter whose argument is an integer.
       *
       * @remarks
       * Example usage of an integer parameter:
       * ```
       * example-tool --max-attempts 5
       * ```
       */
      defineIntegerParameter(definition) {
        const parameter = new CommandLineIntegerParameter_1.CommandLineIntegerParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Returns the CommandLineIntegerParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getIntegerParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.Integer, parameterScope);
      }
      /**
       * Defines a command-line parameter whose argument is an integer. The parameter can be specified
       * multiple times to build a list.
       *
       * @remarks
       * Example usage of an integer list parameter:
       * ```
       * example-tool --avoid 4 --avoid 13
       * ```
       */
      defineIntegerListParameter(definition) {
        const parameter = new CommandLineIntegerListParameter_1.CommandLineIntegerListParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Returns the CommandLineIntegerParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getIntegerListParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.IntegerList, parameterScope);
      }
      /**
       * Defines a command-line parameter whose argument is a single text string.
       *
       * @remarks
       * Example usage of a string parameter:
       * ```
       * example-tool --message "Hello, world!"
       * ```
       */
      defineStringParameter(definition) {
        const parameter = new CommandLineStringParameter_1.CommandLineStringParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Returns the CommandLineStringParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getStringParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.String, parameterScope);
      }
      /**
       * Defines a command-line parameter whose argument is a single text string.  The parameter can be
       * specified multiple times to build a list.
       *
       * @remarks
       * Example usage of a string list parameter:
       * ```
       * example-tool --add file1.txt --add file2.txt --add file3.txt
       * ```
       */
      defineStringListParameter(definition) {
        const parameter = new CommandLineStringListParameter_1.CommandLineStringListParameter(definition);
        this._defineParameter(parameter);
        return parameter;
      }
      /**
       * Defines a rule that captures any remaining command line arguments after the recognized portion.
       *
       * @remarks
       * This feature is useful for commands that pass their arguments along to an external tool, relying on
       * that tool to perform validation.  (It could also be used to parse parameters without any validation
       * or documentation, but that is not recommended.)
       *
       * Example of capturing the remainder after an optional flag parameter.
       * ```
       * example-tool --my-flag this is the remainder
       * ```
       *
       * In the "--help" documentation, the remainder rule will be represented as "...".
       */
      defineCommandLineRemainder(definition) {
        if (this._remainder) {
          throw new Error("defineRemainingArguments() has already been called for this provider");
        }
        this._remainder = new CommandLineRemainder_1.CommandLineRemainder(definition);
        return this._remainder;
      }
      /**
       * Returns the CommandLineStringListParameter with the specified long name.
       * @remarks
       * This method throws an exception if the parameter is not defined.
       */
      getStringListParameter(parameterLongName, parameterScope) {
        return this._getParameter(parameterLongName, BaseClasses_1.CommandLineParameterKind.StringList, parameterScope);
      }
      /**
       * Generates the command-line help text.
       */
      renderHelpText() {
        this._registerDefinedParameters();
        return this._getArgumentParser().formatHelp();
      }
      /**
       * Generates the command-line usage text.
       */
      renderUsageText() {
        this._registerDefinedParameters();
        return this._getArgumentParser().formatUsage();
      }
      /**
       * Returns a object which maps the long name of each parameter in this.parameters
       * to the stringified form of its value. This is useful for logging telemetry, but
       * it is not the proper way of accessing parameters or their values.
       */
      getParameterStringMap() {
        const parameterMap = {};
        for (const parameter of this.parameters) {
          const parameterName = parameter.scopedLongName || parameter.longName;
          switch (parameter.kind) {
            case BaseClasses_1.CommandLineParameterKind.Flag:
            case BaseClasses_1.CommandLineParameterKind.Choice:
            case BaseClasses_1.CommandLineParameterKind.String:
            case BaseClasses_1.CommandLineParameterKind.Integer:
              parameterMap[parameterName] = JSON.stringify(parameter.value);
              break;
            case BaseClasses_1.CommandLineParameterKind.StringList:
            case BaseClasses_1.CommandLineParameterKind.IntegerList:
            case BaseClasses_1.CommandLineParameterKind.ChoiceList:
              const arrayValue = parameter.values;
              parameterMap[parameterName] = arrayValue ? arrayValue.join(",") : "";
              break;
          }
        }
        return parameterMap;
      }
      /**
       * Returns an object with the parsed scope (if present) and the long name of the parameter.
       */
      parseScopedLongName(scopedLongName) {
        const result = POSSIBLY_SCOPED_LONG_NAME_REGEXP.exec(scopedLongName);
        if (!result || !result.groups) {
          throw new Error(`The parameter long name "${scopedLongName}" is not valid.`);
        }
        return {
          longName: `--${result.groups[LONG_NAME_GROUP_NAME]}`,
          scope: result.groups[SCOPE_GROUP_NAME]
        };
      }
      /** @internal */
      _registerDefinedParameters() {
        if (this._parametersRegistered) {
          return;
        }
        this._parametersRegistered = true;
        for (const longNameParameters of this._parametersByLongName.values()) {
          const useScopedLongName = longNameParameters.length > 1;
          for (const parameter of longNameParameters) {
            if (useScopedLongName && !parameter.parameterScope) {
              throw new Error(`The parameter "${parameter.longName}" is defined multiple times with the same long name. Parameters with the same long name must define a scope.`);
            }
            this._registerParameter(parameter, useScopedLongName);
          }
        }
        if (this._remainder) {
          const argparseOptions = {
            help: this._remainder.description,
            nargs: argparse.Const.REMAINDER,
            metavar: '"..."'
          };
          this._getArgumentParser().addArgument(argparse.Const.REMAINDER, argparseOptions);
        }
      }
      /** @internal */
      _processParsedData(parserOptions, data) {
        if (!this._parametersRegistered) {
          throw new Error("Parameters have not been registered");
        }
        if (this._parametersProcessed) {
          throw new Error("Command Line Parser Data was already processed");
        }
        for (const parameter of this._parameters) {
          const value = data[parameter._parserKey];
          parameter._setValue(value);
        }
        if (this.remainder) {
          this.remainder._setValue(data[argparse.Const.REMAINDER]);
        }
        this._parametersProcessed = true;
      }
      /** @internal */
      _defineParameter(parameter) {
        if (this._parametersRegistered) {
          throw new Error("Parameters have already been registered for this provider");
        }
        parameter._parserKey = this._generateKey();
        this._parameters.push(parameter);
        let longNameParameters = this._parametersByLongName.get(parameter.longName);
        if (!longNameParameters) {
          longNameParameters = [];
          this._parametersByLongName.set(parameter.longName, longNameParameters);
        }
        longNameParameters.push(parameter);
      }
      /** @internal */
      _registerParameter(parameter, useScopedLongName) {
        const names = [];
        if (parameter.shortName) {
          names.push(parameter.shortName);
        }
        if (!useScopedLongName) {
          names.push(parameter.longName);
        }
        if (parameter.scopedLongName) {
          names.push(parameter.scopedLongName);
        }
        let finalDescription = parameter.description;
        const supplementaryNotes = [];
        parameter._getSupplementaryNotes(supplementaryNotes);
        if (supplementaryNotes.length > 0) {
          if (finalDescription.match(/[a-z0-9]"?\s*$/i)) {
            finalDescription = finalDescription.trimRight() + ".";
          }
          finalDescription += " " + supplementaryNotes.join(" ");
        }
        const argparseOptions = {
          help: finalDescription,
          dest: parameter._parserKey,
          metavar: parameter.argumentName || void 0,
          required: parameter.required
        };
        switch (parameter.kind) {
          case BaseClasses_1.CommandLineParameterKind.Choice: {
            const choiceParameter = parameter;
            argparseOptions.choices = choiceParameter.alternatives;
            break;
          }
          case BaseClasses_1.CommandLineParameterKind.ChoiceList: {
            const choiceParameter = parameter;
            argparseOptions.choices = choiceParameter.alternatives;
            argparseOptions.action = "append";
            break;
          }
          case BaseClasses_1.CommandLineParameterKind.Flag:
            argparseOptions.action = "storeTrue";
            break;
          case BaseClasses_1.CommandLineParameterKind.Integer:
            argparseOptions.type = "int";
            break;
          case BaseClasses_1.CommandLineParameterKind.IntegerList:
            argparseOptions.type = "int";
            argparseOptions.action = "append";
            break;
          case BaseClasses_1.CommandLineParameterKind.String:
            break;
          case BaseClasses_1.CommandLineParameterKind.StringList:
            argparseOptions.action = "append";
            break;
        }
        let argumentGroup;
        if (parameter.parameterGroup) {
          argumentGroup = this._parameterGroupsByName.get(parameter.parameterGroup);
          if (!argumentGroup) {
            let parameterGroupName;
            if (typeof parameter.parameterGroup === "string") {
              parameterGroupName = parameter.parameterGroup;
            } else if (parameter.parameterGroup === Constants_1.SCOPING_PARAMETER_GROUP) {
              parameterGroupName = "scoping";
            } else {
              throw new Error("Unexpected parameter group: " + parameter.parameterGroup);
            }
            argumentGroup = this._getArgumentParser().addArgumentGroup({
              title: `Optional ${parameterGroupName} arguments`
            });
            this._parameterGroupsByName.set(parameter.parameterGroup, argumentGroup);
          }
        } else {
          argumentGroup = this._getArgumentParser();
        }
        argumentGroup.addArgument(names, Object.assign({}, argparseOptions));
        if (parameter.undocumentedSynonyms && parameter.undocumentedSynonyms.length > 0) {
          argumentGroup.addArgument(parameter.undocumentedSynonyms, Object.assign(Object.assign({}, argparseOptions), { help: argparse.Const.SUPPRESS }));
        }
      }
      _generateKey() {
        return "key_" + (CommandLineParameterProvider._keyCounter++).toString();
      }
      _getParameter(parameterLongName, expectedKind, parameterScope) {
        const { scope, longName } = this.parseScopedLongName(parameterLongName);
        parameterLongName = longName;
        parameterScope = scope || parameterScope;
        const parameters = this._parametersByLongName.get(parameterLongName);
        if (!parameters) {
          throw new Error(`The parameter "${parameterLongName}" is not defined`);
        }
        const parameter = parameters.find((p) => p.parameterScope === parameterScope);
        if (!parameter) {
          throw new Error(`The parameter "${parameterLongName}" with scope "${parameterScope}" is not defined.`);
        }
        if (parameter.kind !== expectedKind) {
          throw new Error(`The parameter "${parameterLongName}" is of type "${BaseClasses_1.CommandLineParameterKind[parameter.kind]}" whereas the caller was expecting "${BaseClasses_1.CommandLineParameterKind[expectedKind]}".`);
        }
        return parameter;
      }
    };
    exports.CommandLineParameterProvider = CommandLineParameterProvider;
    CommandLineParameterProvider._keyCounter = 0;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineAction.js
var require_CommandLineAction = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineAction.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineAction = void 0;
    var CommandLineParameterProvider_1 = require_CommandLineParameterProvider();
    var ACTION_NAME_REGEXP = /^[a-z][a-z0-9]*([-:][a-z0-9]+)*$/;
    var CommandLineAction2 = class extends CommandLineParameterProvider_1.CommandLineParameterProvider {
      constructor(options) {
        super();
        if (!ACTION_NAME_REGEXP.test(options.actionName)) {
          throw new Error(`Invalid action name "${options.actionName}". The name must be comprised of lower-case words optionally separated by hyphens or colons.`);
        }
        this.actionName = options.actionName;
        this.summary = options.summary;
        this.documentation = options.documentation;
        this._argumentParser = void 0;
      }
      /**
       * This is called internally by CommandLineParser.addAction()
       * @internal
       */
      _buildParser(actionsSubParser) {
        var _a;
        this._argumentParser = actionsSubParser.addParser(this.actionName, {
          help: this.summary,
          description: this.documentation
        });
        (_a = this.onDefineParameters) === null || _a === void 0 ? void 0 : _a.call(this);
      }
      /**
       * This is called internally by CommandLineParser.execute()
       * @internal
       */
      _processParsedData(parserOptions, data) {
        super._processParsedData(parserOptions, data);
      }
      /**
       * Invoked by CommandLineParser.onExecute().
       * @internal
       */
      _execute() {
        return this.onExecute();
      }
      /**
       * {@inheritDoc CommandLineParameterProvider._getArgumentParser}
       * @internal
       */
      _getArgumentParser() {
        if (!this._argumentParser) {
          throw new Error("The CommandLineAction must be added to a CommandLineParser before it can be used");
        }
        return this._argumentParser;
      }
    };
    exports.CommandLineAction = CommandLineAction2;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/DynamicCommandLineAction.js
var require_DynamicCommandLineAction = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/DynamicCommandLineAction.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DynamicCommandLineAction = void 0;
    var CommandLineAction_1 = require_CommandLineAction();
    var DynamicCommandLineAction = class extends CommandLineAction_1.CommandLineAction {
      async onExecute() {
      }
    };
    exports.DynamicCommandLineAction = DynamicCommandLineAction;
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/styles.js
var require_styles = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/styles.js"(exports, module) {
    var styles = {};
    module["exports"] = styles;
    var codes = {
      reset: [0, 0],
      bold: [1, 22],
      dim: [2, 22],
      italic: [3, 23],
      underline: [4, 24],
      inverse: [7, 27],
      hidden: [8, 28],
      strikethrough: [9, 29],
      black: [30, 39],
      red: [31, 39],
      green: [32, 39],
      yellow: [33, 39],
      blue: [34, 39],
      magenta: [35, 39],
      cyan: [36, 39],
      white: [37, 39],
      gray: [90, 39],
      grey: [90, 39],
      bgBlack: [40, 49],
      bgRed: [41, 49],
      bgGreen: [42, 49],
      bgYellow: [43, 49],
      bgBlue: [44, 49],
      bgMagenta: [45, 49],
      bgCyan: [46, 49],
      bgWhite: [47, 49],
      // legacy styles for colors pre v1.0.0
      blackBG: [40, 49],
      redBG: [41, 49],
      greenBG: [42, 49],
      yellowBG: [43, 49],
      blueBG: [44, 49],
      magentaBG: [45, 49],
      cyanBG: [46, 49],
      whiteBG: [47, 49]
    };
    Object.keys(codes).forEach(function(key) {
      var val = codes[key];
      var style = styles[key] = [];
      style.open = "\x1B[" + val[0] + "m";
      style.close = "\x1B[" + val[1] + "m";
    });
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/system/has-flag.js
var require_has_flag = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/system/has-flag.js"(exports, module) {
    "use strict";
    module.exports = function(flag, argv) {
      argv = argv || process.argv;
      var terminatorPos = argv.indexOf("--");
      var prefix = /^-{1,2}/.test(flag) ? "" : "--";
      var pos = argv.indexOf(prefix + flag);
      return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/system/supports-colors.js
var require_supports_colors = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/system/supports-colors.js"(exports, module) {
    "use strict";
    var os = __require("os");
    var hasFlag = require_has_flag();
    var env = process.env;
    var forceColor = void 0;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
      forceColor = false;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = true;
    }
    if ("FORCE_COLOR" in env) {
      forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(stream) {
      if (forceColor === false) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (stream && !stream.isTTY && forceColor !== true) {
        return 0;
      }
      var min = forceColor ? 1 : 0;
      if (process.platform === "win32") {
        var osRelease = os.release().split(".");
        if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some(function(sign) {
          return sign in env;
        }) || env.CI_NAME === "codeship") {
          return 1;
        }
        return min;
      }
      if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
      }
      if ("TERM_PROGRAM" in env) {
        var version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Hyper":
            return 3;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env) {
        return 1;
      }
      if (env.TERM === "dumb") {
        return min;
      }
      return min;
    }
    function getSupportLevel(stream) {
      var level = supportsColor(stream);
      return translateLevel(level);
    }
    module.exports = {
      supportsColor: getSupportLevel,
      stdout: getSupportLevel(process.stdout),
      stderr: getSupportLevel(process.stderr)
    };
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/custom/trap.js
var require_trap = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/custom/trap.js"(exports, module) {
    module["exports"] = function runTheTrap(text, options) {
      var result = "";
      text = text || "Run the trap, drop the bass";
      text = text.split("");
      var trap = {
        a: ["@", "\u0104", "\u023A", "\u0245", "\u0394", "\u039B", "\u0414"],
        b: ["\xDF", "\u0181", "\u0243", "\u026E", "\u03B2", "\u0E3F"],
        c: ["\xA9", "\u023B", "\u03FE"],
        d: ["\xD0", "\u018A", "\u0500", "\u0501", "\u0502", "\u0503"],
        e: [
          "\xCB",
          "\u0115",
          "\u018E",
          "\u0258",
          "\u03A3",
          "\u03BE",
          "\u04BC",
          "\u0A6C"
        ],
        f: ["\u04FA"],
        g: ["\u0262"],
        h: ["\u0126", "\u0195", "\u04A2", "\u04BA", "\u04C7", "\u050A"],
        i: ["\u0F0F"],
        j: ["\u0134"],
        k: ["\u0138", "\u04A0", "\u04C3", "\u051E"],
        l: ["\u0139"],
        m: ["\u028D", "\u04CD", "\u04CE", "\u0520", "\u0521", "\u0D69"],
        n: ["\xD1", "\u014B", "\u019D", "\u0376", "\u03A0", "\u048A"],
        o: [
          "\xD8",
          "\xF5",
          "\xF8",
          "\u01FE",
          "\u0298",
          "\u047A",
          "\u05DD",
          "\u06DD",
          "\u0E4F"
        ],
        p: ["\u01F7", "\u048E"],
        q: ["\u09CD"],
        r: ["\xAE", "\u01A6", "\u0210", "\u024C", "\u0280", "\u042F"],
        s: ["\xA7", "\u03DE", "\u03DF", "\u03E8"],
        t: ["\u0141", "\u0166", "\u0373"],
        u: ["\u01B1", "\u054D"],
        v: ["\u05D8"],
        w: ["\u0428", "\u0460", "\u047C", "\u0D70"],
        x: ["\u04B2", "\u04FE", "\u04FC", "\u04FD"],
        y: ["\xA5", "\u04B0", "\u04CB"],
        z: ["\u01B5", "\u0240"]
      };
      text.forEach(function(c) {
        c = c.toLowerCase();
        var chars = trap[c] || [" "];
        var rand = Math.floor(Math.random() * chars.length);
        if (typeof trap[c] !== "undefined") {
          result += trap[c][rand];
        } else {
          result += c;
        }
      });
      return result;
    };
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/custom/zalgo.js
var require_zalgo = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/custom/zalgo.js"(exports, module) {
    module["exports"] = function zalgo(text, options) {
      text = text || "   he is here   ";
      var soul = {
        "up": [
          "\u030D",
          "\u030E",
          "\u0304",
          "\u0305",
          "\u033F",
          "\u0311",
          "\u0306",
          "\u0310",
          "\u0352",
          "\u0357",
          "\u0351",
          "\u0307",
          "\u0308",
          "\u030A",
          "\u0342",
          "\u0313",
          "\u0308",
          "\u034A",
          "\u034B",
          "\u034C",
          "\u0303",
          "\u0302",
          "\u030C",
          "\u0350",
          "\u0300",
          "\u0301",
          "\u030B",
          "\u030F",
          "\u0312",
          "\u0313",
          "\u0314",
          "\u033D",
          "\u0309",
          "\u0363",
          "\u0364",
          "\u0365",
          "\u0366",
          "\u0367",
          "\u0368",
          "\u0369",
          "\u036A",
          "\u036B",
          "\u036C",
          "\u036D",
          "\u036E",
          "\u036F",
          "\u033E",
          "\u035B",
          "\u0346",
          "\u031A"
        ],
        "down": [
          "\u0316",
          "\u0317",
          "\u0318",
          "\u0319",
          "\u031C",
          "\u031D",
          "\u031E",
          "\u031F",
          "\u0320",
          "\u0324",
          "\u0325",
          "\u0326",
          "\u0329",
          "\u032A",
          "\u032B",
          "\u032C",
          "\u032D",
          "\u032E",
          "\u032F",
          "\u0330",
          "\u0331",
          "\u0332",
          "\u0333",
          "\u0339",
          "\u033A",
          "\u033B",
          "\u033C",
          "\u0345",
          "\u0347",
          "\u0348",
          "\u0349",
          "\u034D",
          "\u034E",
          "\u0353",
          "\u0354",
          "\u0355",
          "\u0356",
          "\u0359",
          "\u035A",
          "\u0323"
        ],
        "mid": [
          "\u0315",
          "\u031B",
          "\u0300",
          "\u0301",
          "\u0358",
          "\u0321",
          "\u0322",
          "\u0327",
          "\u0328",
          "\u0334",
          "\u0335",
          "\u0336",
          "\u035C",
          "\u035D",
          "\u035E",
          "\u035F",
          "\u0360",
          "\u0362",
          "\u0338",
          "\u0337",
          "\u0361",
          " \u0489"
        ]
      };
      var all = [].concat(soul.up, soul.down, soul.mid);
      function randomNumber(range) {
        var r = Math.floor(Math.random() * range);
        return r;
      }
      function isChar(character) {
        var bool = false;
        all.filter(function(i) {
          bool = i === character;
        });
        return bool;
      }
      function heComes(text2, options2) {
        var result = "";
        var counts;
        var l;
        options2 = options2 || {};
        options2["up"] = typeof options2["up"] !== "undefined" ? options2["up"] : true;
        options2["mid"] = typeof options2["mid"] !== "undefined" ? options2["mid"] : true;
        options2["down"] = typeof options2["down"] !== "undefined" ? options2["down"] : true;
        options2["size"] = typeof options2["size"] !== "undefined" ? options2["size"] : "maxi";
        text2 = text2.split("");
        for (l in text2) {
          if (isChar(l)) {
            continue;
          }
          result = result + text2[l];
          counts = { "up": 0, "down": 0, "mid": 0 };
          switch (options2.size) {
            case "mini":
              counts.up = randomNumber(8);
              counts.mid = randomNumber(2);
              counts.down = randomNumber(8);
              break;
            case "maxi":
              counts.up = randomNumber(16) + 3;
              counts.mid = randomNumber(4) + 1;
              counts.down = randomNumber(64) + 3;
              break;
            default:
              counts.up = randomNumber(8) + 1;
              counts.mid = randomNumber(6) / 2;
              counts.down = randomNumber(8) + 1;
              break;
          }
          var arr = ["up", "mid", "down"];
          for (var d in arr) {
            var index = arr[d];
            for (var i = 0; i <= counts[index]; i++) {
              if (options2[index]) {
                result = result + soul[index][randomNumber(soul[index].length)];
              }
            }
          }
        }
        return result;
      }
      return heComes(text, options);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/america.js
var require_america = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/america.js"(exports, module) {
    var colors = require_colors();
    module["exports"] = function() {
      return function(letter, i, exploded) {
        if (letter === " ")
          return letter;
        switch (i % 3) {
          case 0:
            return colors.red(letter);
          case 1:
            return colors.white(letter);
          case 2:
            return colors.blue(letter);
        }
      };
    }();
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/zebra.js
var require_zebra = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/zebra.js"(exports, module) {
    var colors = require_colors();
    module["exports"] = function(letter, i, exploded) {
      return i % 2 === 0 ? letter : colors.inverse(letter);
    };
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/rainbow.js
var require_rainbow = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/rainbow.js"(exports, module) {
    var colors = require_colors();
    module["exports"] = function() {
      var rainbowColors = ["red", "yellow", "green", "blue", "magenta"];
      return function(letter, i, exploded) {
        if (letter === " ") {
          return letter;
        } else {
          return colors[rainbowColors[i++ % rainbowColors.length]](letter);
        }
      };
    }();
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/random.js
var require_random = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/maps/random.js"(exports, module) {
    var colors = require_colors();
    module["exports"] = function() {
      var available = [
        "underline",
        "inverse",
        "grey",
        "yellow",
        "red",
        "green",
        "blue",
        "white",
        "cyan",
        "magenta"
      ];
      return function(letter, i, exploded) {
        return letter === " " ? letter : colors[available[Math.round(Math.random() * (available.length - 2))]](letter);
      };
    }();
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/colors.js
var require_colors = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/colors.js"(exports, module) {
    var colors = {};
    module["exports"] = colors;
    colors.themes = {};
    var util = __require("util");
    var ansiStyles = colors.styles = require_styles();
    var defineProps = Object.defineProperties;
    var newLineRegex = new RegExp(/[\r\n]+/g);
    colors.supportsColor = require_supports_colors().supportsColor;
    if (typeof colors.enabled === "undefined") {
      colors.enabled = colors.supportsColor() !== false;
    }
    colors.enable = function() {
      colors.enabled = true;
    };
    colors.disable = function() {
      colors.enabled = false;
    };
    colors.stripColors = colors.strip = function(str) {
      return ("" + str).replace(/\x1B\[\d+m/g, "");
    };
    var stylize = colors.stylize = function stylize2(str, style) {
      if (!colors.enabled) {
        return str + "";
      }
      return ansiStyles[style].open + str + ansiStyles[style].close;
    };
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    var escapeStringRegexp = function(str) {
      if (typeof str !== "string") {
        throw new TypeError("Expected a string");
      }
      return str.replace(matchOperatorsRe, "\\$&");
    };
    function build(_styles) {
      var builder = function builder2() {
        return applyStyle.apply(builder2, arguments);
      };
      builder._styles = _styles;
      builder.__proto__ = proto;
      return builder;
    }
    var styles = function() {
      var ret = {};
      ansiStyles.grey = ansiStyles.gray;
      Object.keys(ansiStyles).forEach(function(key) {
        ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
        ret[key] = {
          get: function() {
            return build(this._styles.concat(key));
          }
        };
      });
      return ret;
    }();
    var proto = defineProps(function colors2() {
    }, styles);
    function applyStyle() {
      var args = Array.prototype.slice.call(arguments);
      var str = args.map(function(arg) {
        if (arg !== void 0 && arg.constructor === String) {
          return arg;
        } else {
          return util.inspect(arg);
        }
      }).join(" ");
      if (!colors.enabled || !str) {
        return str;
      }
      var newLinesPresent = str.indexOf("\n") != -1;
      var nestedStyles = this._styles;
      var i = nestedStyles.length;
      while (i--) {
        var code = ansiStyles[nestedStyles[i]];
        str = code.open + str.replace(code.closeRe, code.open) + code.close;
        if (newLinesPresent) {
          str = str.replace(newLineRegex, code.close + "\n" + code.open);
        }
      }
      return str;
    }
    colors.setTheme = function(theme) {
      if (typeof theme === "string") {
        console.log("colors.setTheme now only accepts an object, not a string.  If you are trying to set a theme from a file, it is now your (the caller's) responsibility to require the file.  The old syntax looked like colors.setTheme(__dirname + '/../themes/generic-logging.js'); The new syntax looks like colors.setTheme(require(__dirname + '/../themes/generic-logging.js'));");
        return;
      }
      for (var style in theme) {
        (function(style2) {
          colors[style2] = function(str) {
            if (typeof theme[style2] === "object") {
              var out = str;
              for (var i in theme[style2]) {
                out = colors[theme[style2][i]](out);
              }
              return out;
            }
            return colors[theme[style2]](str);
          };
        })(style);
      }
    };
    function init() {
      var ret = {};
      Object.keys(styles).forEach(function(name) {
        ret[name] = {
          get: function() {
            return build([name]);
          }
        };
      });
      return ret;
    }
    var sequencer = function sequencer2(map2, str) {
      var exploded = str.split("");
      exploded = exploded.map(map2);
      return exploded.join("");
    };
    colors.trap = require_trap();
    colors.zalgo = require_zalgo();
    colors.maps = {};
    colors.maps.america = require_america();
    colors.maps.zebra = require_zebra();
    colors.maps.rainbow = require_rainbow();
    colors.maps.random = require_random();
    for (map in colors.maps) {
      (function(map2) {
        colors[map2] = function(str) {
          return sequencer(colors.maps[map2], str);
        };
      })(map);
    }
    var map;
    defineProps(colors, init());
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/extendStringPrototype.js
var require_extendStringPrototype = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/extendStringPrototype.js"(exports, module) {
    var colors = require_colors();
    module["exports"] = function() {
      var addProperty = function(color, func) {
        String.prototype.__defineGetter__(color, func);
      };
      addProperty("strip", function() {
        return colors.strip(this);
      });
      addProperty("stripColors", function() {
        return colors.strip(this);
      });
      addProperty("trap", function() {
        return colors.trap(this);
      });
      addProperty("zalgo", function() {
        return colors.zalgo(this);
      });
      addProperty("zebra", function() {
        return colors.zebra(this);
      });
      addProperty("rainbow", function() {
        return colors.rainbow(this);
      });
      addProperty("random", function() {
        return colors.random(this);
      });
      addProperty("america", function() {
        return colors.america(this);
      });
      var x = Object.keys(colors.styles);
      x.forEach(function(style) {
        addProperty(style, function() {
          return colors.stylize(this, style);
        });
      });
      function applyTheme(theme) {
        var stringPrototypeBlacklist = [
          "__defineGetter__",
          "__defineSetter__",
          "__lookupGetter__",
          "__lookupSetter__",
          "charAt",
          "constructor",
          "hasOwnProperty",
          "isPrototypeOf",
          "propertyIsEnumerable",
          "toLocaleString",
          "toString",
          "valueOf",
          "charCodeAt",
          "indexOf",
          "lastIndexOf",
          "length",
          "localeCompare",
          "match",
          "repeat",
          "replace",
          "search",
          "slice",
          "split",
          "substring",
          "toLocaleLowerCase",
          "toLocaleUpperCase",
          "toLowerCase",
          "toUpperCase",
          "trim",
          "trimLeft",
          "trimRight"
        ];
        Object.keys(theme).forEach(function(prop) {
          if (stringPrototypeBlacklist.indexOf(prop) !== -1) {
            console.log("warn: ".red + ("String.prototype" + prop).magenta + " is probably something you don't want to override.  Ignoring style name");
          } else {
            if (typeof theme[prop] === "string") {
              colors[prop] = colors[theme[prop]];
              addProperty(prop, function() {
                return colors[theme[prop]](this);
              });
            } else {
              addProperty(prop, function() {
                var ret = this;
                for (var t = 0; t < theme[prop].length; t++) {
                  ret = colors[theme[prop][t]](ret);
                }
                return ret;
              });
            }
          }
        });
      }
      colors.setTheme = function(theme) {
        if (typeof theme === "string") {
          try {
            colors.themes[theme] = __require(theme);
            applyTheme(colors.themes[theme]);
            return colors.themes[theme];
          } catch (err) {
            console.log(err);
            return err;
          }
        } else {
          applyTheme(theme);
        }
      };
    };
  }
});

// ../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/index.js
var require_lib = __commonJS({
  "../../common/temp/node_modules/.pnpm/colors@1.2.5/node_modules/colors/lib/index.js"(exports, module) {
    var colors = require_colors();
    module["exports"] = colors;
    require_extendStringPrototype()();
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineParserExitError.js
var require_CommandLineParserExitError = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineParserExitError.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CustomArgumentParser = exports.CommandLineParserExitError = void 0;
    var argparse = __importStar(require_argparse2());
    var CommandLineParserExitError = class extends Error {
      constructor(exitCode, message) {
        super(message);
        this.__proto__ = CommandLineParserExitError.prototype;
        this.exitCode = exitCode;
      }
    };
    exports.CommandLineParserExitError = CommandLineParserExitError;
    var CustomArgumentParser = class extends argparse.ArgumentParser {
      exit(status, message) {
        throw new CommandLineParserExitError(status, message);
      }
      error(err) {
        if (err instanceof CommandLineParserExitError) {
          throw err;
        }
        super.error(err);
      }
    };
    exports.CustomArgumentParser = CustomArgumentParser;
  }
});

// ../../common/temp/node_modules/.pnpm/string-argv@0.3.1/node_modules/string-argv/index.js
var require_string_argv = __commonJS({
  "../../common/temp/node_modules/.pnpm/string-argv@0.3.1/node_modules/string-argv/index.js"(exports) {
    "use strict";
    exports.__esModule = true;
    function parseArgsStringToArgv(value, env, file) {
      var myRegexp = /([^\s'"]([^\s'"]*(['"])([^\3]*?)\3)+[^\s'"]*)|[^\s'"]+|(['"])([^\5]*?)\5/gi;
      var myString = value;
      var myArray = [];
      if (env) {
        myArray.push(env);
      }
      if (file) {
        myArray.push(file);
      }
      var match;
      do {
        match = myRegexp.exec(myString);
        if (match !== null) {
          myArray.push(firstString(match[1], match[6], match[0]));
        }
      } while (match !== null);
      return myArray;
    }
    exports["default"] = parseArgsStringToArgv;
    exports.parseArgsStringToArgv = parseArgsStringToArgv;
    function firstString() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      for (var i = 0; i < args.length; i++) {
        var arg = args[i];
        if (typeof arg === "string") {
          return arg;
        }
      }
    }
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/TabCompletionAction.js
var require_TabCompletionAction = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/TabCompletionAction.js"(exports) {
    "use strict";
    var __asyncValues = exports && exports.__asyncValues || function(o) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var m = o[Symbol.asyncIterator], i;
      return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
        return this;
      }, i);
      function verb(n) {
        i[n] = o[n] && function(v) {
          return new Promise(function(resolve, reject) {
            v = o[n](v), settle(resolve, reject, v.done, v.value);
          });
        };
      }
      function settle(resolve, reject, d, v) {
        Promise.resolve(v).then(function(v2) {
          resolve({ value: v2, done: d });
        }, reject);
      }
    };
    var __await = exports && exports.__await || function(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
    };
    var __asyncDelegator = exports && exports.__asyncDelegator || function(o) {
      var i, p;
      return i = {}, verb("next"), verb("throw", function(e) {
        throw e;
      }), verb("return"), i[Symbol.iterator] = function() {
        return this;
      }, i;
      function verb(n, f) {
        i[n] = o[n] ? function(v) {
          return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v;
        } : f;
      }
    };
    var __asyncGenerator = exports && exports.__asyncGenerator || function(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i, q = [];
      return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
        return this;
      }, i;
      function verb(n) {
        if (g[n])
          i[n] = function(v) {
            return new Promise(function(a, b) {
              q.push([n, v, a, b]) > 1 || resume(n, v);
            });
          };
      }
      function resume(n, v) {
        try {
          step(g[n](v));
        } catch (e) {
          settle(q[0][3], e);
        }
      }
      function step(r) {
        r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
      }
      function fulfill(value) {
        resume("next", value);
      }
      function reject(value) {
        resume("throw", value);
      }
      function settle(f, v) {
        if (f(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]);
      }
    };
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TabCompleteAction = void 0;
    var string_argv_1 = __importDefault(require_string_argv());
    var BaseClasses_1 = require_BaseClasses();
    var CommandLineChoiceParameter_1 = require_CommandLineChoiceParameter();
    var CommandLineAction_1 = require_CommandLineAction();
    var DEFAULT_WORD_TO_AUTOCOMPLETE = "";
    var DEFAULT_POSITION = 0;
    var TabCompleteAction = class extends CommandLineAction_1.CommandLineAction {
      constructor(actions, globalParameters) {
        super({
          actionName: "tab-complete",
          summary: "Provides tab completion.",
          documentation: "Provides tab completion."
        });
        this._actions = /* @__PURE__ */ new Map();
        for (const action of actions) {
          const parameterNameToParameterInfoMap = /* @__PURE__ */ new Map();
          for (const parameter of action.parameters) {
            parameterNameToParameterInfoMap.set(parameter.longName, parameter);
            if (parameter.shortName) {
              parameterNameToParameterInfoMap.set(parameter.shortName, parameter);
            }
          }
          this._actions.set(action.actionName, parameterNameToParameterInfoMap);
        }
        this._globalParameters = /* @__PURE__ */ new Map();
        for (const parameter of globalParameters) {
          this._globalParameters.set(parameter.longName, parameter);
          if (parameter.shortName) {
            this._globalParameters.set(parameter.shortName, parameter);
          }
        }
        this._wordToCompleteParameter = this.defineStringParameter({
          parameterLongName: "--word",
          argumentName: "WORD",
          description: `The word to complete.`,
          defaultValue: DEFAULT_WORD_TO_AUTOCOMPLETE
        });
        this._positionParameter = this.defineIntegerParameter({
          parameterLongName: "--position",
          argumentName: "INDEX",
          description: `The position in the word to be completed.`,
          defaultValue: DEFAULT_POSITION
        });
      }
      async onExecute() {
        var e_1, _a;
        const commandLine2 = this._wordToCompleteParameter.value || "";
        const caretPosition = this._positionParameter.value || commandLine2 && commandLine2.length || 0;
        try {
          for (var _b = __asyncValues(this.getCompletions(commandLine2, caretPosition)), _c; _c = await _b.next(), !_c.done; ) {
            const value = _c.value;
            console.log(value);
          }
        } catch (e_1_1) {
          e_1 = { error: e_1_1 };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return))
              await _a.call(_b);
          } finally {
            if (e_1)
              throw e_1.error;
          }
        }
      }
      getCompletions(commandLine2, caretPosition = commandLine2.length) {
        return __asyncGenerator(this, arguments, function* getCompletions_1() {
          const actions = this._actions;
          if (!commandLine2 || !caretPosition) {
            yield __await(yield* __asyncDelegator(__asyncValues(this._getAllActions())));
            return yield __await(void 0);
          }
          const tokens = Array.from(this.tokenizeCommandLine(commandLine2));
          const globalParameterOffset = this._getGlobalParameterOffset(tokens);
          if (tokens.length < 2 + globalParameterOffset) {
            yield __await(yield* __asyncDelegator(__asyncValues(this._getAllActions())));
            return yield __await(void 0);
          }
          const lastToken = tokens[tokens.length - 1];
          const secondLastToken = tokens[tokens.length - 2];
          const completePartialWord = caretPosition === commandLine2.length;
          if (completePartialWord && tokens.length === 2 + globalParameterOffset) {
            for (const actionName of actions.keys()) {
              if (actionName.indexOf(tokens[1 + globalParameterOffset]) === 0) {
                yield yield __await(actionName);
              }
            }
          } else {
            for (const actionName of actions.keys()) {
              if (actionName === tokens[1 + globalParameterOffset]) {
                const parameterNameMap = actions.get(actionName);
                const parameterNames = Array.from(parameterNameMap.keys());
                if (completePartialWord) {
                  for (const parameterName of parameterNames) {
                    if (parameterName === secondLastToken) {
                      const values = yield __await(this._getParameterValueCompletions(parameterNameMap.get(parameterName)));
                      if (values.length > 0) {
                        yield __await(yield* __asyncDelegator(__asyncValues(this._completeParameterValues(values, lastToken))));
                        return yield __await(void 0);
                      }
                    }
                  }
                  yield __await(yield* __asyncDelegator(__asyncValues(this._completeParameterValues(parameterNames, lastToken))));
                } else {
                  for (const parameterName of parameterNames) {
                    if (parameterName === lastToken) {
                      const values = yield __await(this._getParameterValueCompletions(parameterNameMap.get(parameterName)));
                      if (values.length > 0) {
                        yield __await(yield* __asyncDelegator(__asyncValues(values)));
                        return yield __await(void 0);
                      }
                    }
                  }
                  for (const parameterName of parameterNames) {
                    if (parameterName === lastToken && parameterNameMap.get(parameterName).kind !== BaseClasses_1.CommandLineParameterKind.Flag) {
                      return yield __await(void 0);
                    }
                  }
                  yield __await(yield* __asyncDelegator(__asyncValues(parameterNames)));
                }
                break;
              }
            }
          }
        });
      }
      *_getAllActions() {
        yield* this._actions.keys();
        yield* this._globalParameters.keys();
      }
      tokenizeCommandLine(commandLine2) {
        return (0, string_argv_1.default)(commandLine2);
      }
      async _getParameterValueCompletions(parameter) {
        let choiceParameterValues = [];
        if (parameter.kind === BaseClasses_1.CommandLineParameterKind.Choice) {
          choiceParameterValues = parameter.alternatives;
        } else if (parameter.kind !== BaseClasses_1.CommandLineParameterKind.Flag) {
          let parameterWithArgumentOrChoices = void 0;
          if (parameter instanceof BaseClasses_1.CommandLineParameterWithArgument) {
            parameterWithArgumentOrChoices = parameter;
          } else if (parameter instanceof CommandLineChoiceParameter_1.CommandLineChoiceParameter) {
            parameterWithArgumentOrChoices = parameter;
          }
          if (parameterWithArgumentOrChoices && parameterWithArgumentOrChoices.completions) {
            choiceParameterValues = await parameterWithArgumentOrChoices.completions();
          }
        }
        return choiceParameterValues;
      }
      _getGlobalParameterOffset(tokens) {
        const globalParameters = this._globalParameters;
        let count = 0;
        outer:
          for (let i = 1; i < tokens.length; i++) {
            for (const globalParameter of globalParameters.values()) {
              if (tokens[i] !== globalParameter.longName && tokens[i] !== globalParameter.shortName) {
                break outer;
              }
            }
            count++;
          }
        return count;
      }
      *_completeParameterValues(choiceParameterValues, lastToken) {
        for (const choiceParameterValue of choiceParameterValues) {
          if (choiceParameterValue.indexOf(lastToken) === 0) {
            yield choiceParameterValue;
          }
        }
      }
    };
    exports.TabCompleteAction = TabCompleteAction;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineParser.js
var require_CommandLineParser = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/CommandLineParser.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineParser = void 0;
    var colors_1 = __importDefault(require_lib());
    var CommandLineParameterProvider_1 = require_CommandLineParameterProvider();
    var CommandLineParserExitError_1 = require_CommandLineParserExitError();
    var TabCompletionAction_1 = require_TabCompletionAction();
    var CommandLineParser2 = class extends CommandLineParameterProvider_1.CommandLineParameterProvider {
      constructor(options) {
        var _a, _b;
        super();
        this._executed = false;
        this._tabCompleteActionWasAdded = false;
        this._options = options;
        this._actions = [];
        this._actionsByName = /* @__PURE__ */ new Map();
        this._argumentParser = new CommandLineParserExitError_1.CustomArgumentParser({
          addHelp: true,
          prog: this._options.toolFilename,
          description: this._options.toolDescription,
          epilog: colors_1.default.bold((_a = this._options.toolEpilog) !== null && _a !== void 0 ? _a : `For detailed help about a specific command, use: ${this._options.toolFilename} <command> -h`)
        });
        (_b = this.onDefineParameters) === null || _b === void 0 ? void 0 : _b.call(this);
      }
      /**
       * Returns the list of actions that were defined for this CommandLineParser object.
       */
      get actions() {
        return this._actions;
      }
      /**
       * Defines a new action that can be used with the CommandLineParser instance.
       */
      addAction(action) {
        if (!this._actionsSubParser) {
          this._actionsSubParser = this._argumentParser.addSubparsers({
            metavar: "<command>",
            dest: "action"
          });
        }
        action._buildParser(this._actionsSubParser);
        this._actions.push(action);
        this._actionsByName.set(action.actionName, action);
      }
      /**
       * Retrieves the action with the specified name.  If no matching action is found,
       * an exception is thrown.
       */
      getAction(actionName) {
        const action = this.tryGetAction(actionName);
        if (!action) {
          throw new Error(`The action "${actionName}" was not defined`);
        }
        return action;
      }
      /**
       * Retrieves the action with the specified name.  If no matching action is found,
       * undefined is returned.
       */
      tryGetAction(actionName) {
        return this._actionsByName.get(actionName);
      }
      /**
       * The program entry point will call this method to begin parsing command-line arguments
       * and executing the corresponding action.
       *
       * @remarks
       * The returned promise will never reject:  If an error occurs, it will be printed
       * to stderr, process.exitCode will be set to 1, and the promise will resolve to false.
       * This simplifies the most common usage scenario where the program entry point doesn't
       * want to be involved with the command-line logic, and will discard the promise without
       * a then() or catch() block.
       *
       * If your caller wants to trap and handle errors, use {@link CommandLineParser.executeWithoutErrorHandling}
       * instead.
       *
       * @param args - the command-line arguments to be parsed; if omitted, then
       *               the process.argv will be used
       */
      async execute(args) {
        if (this._options.enableTabCompletionAction && !this._tabCompleteActionWasAdded) {
          this.addAction(new TabCompletionAction_1.TabCompleteAction(this.actions, this.parameters));
          this._tabCompleteActionWasAdded = true;
        }
        try {
          await this.executeWithoutErrorHandling(args);
          return true;
        } catch (err) {
          if (err instanceof CommandLineParserExitError_1.CommandLineParserExitError) {
            if (err.message) {
              console.error(err.message);
            }
            if (!process.exitCode) {
              process.exitCode = err.exitCode;
            }
          } else {
            let message = (err.message || "An unknown error occurred").trim();
            if (!/^(error|internal error|warning)\b/i.test(message)) {
              message = "Error: " + message;
            }
            console.error();
            console.error(colors_1.default.red(message));
            if (!process.exitCode) {
              process.exitCode = 1;
            }
          }
          return false;
        }
      }
      /**
       * This is similar to {@link CommandLineParser.execute}, except that execution errors
       * simply cause the promise to reject.  It is the caller's responsibility to trap
       */
      async executeWithoutErrorHandling(args) {
        try {
          if (this._executed) {
            throw new Error("execute() was already called for this parser instance");
          }
          this._executed = true;
          this._validateDefinitions();
          this._registerDefinedParameters();
          if (!args) {
            args = process.argv.slice(2);
          }
          if (this.actions.length > 0 && args.length === 0) {
            this._argumentParser.printHelp();
            return;
          }
          const data = this._argumentParser.parseArgs(args);
          this._processParsedData(this._options, data);
          for (const action of this._actions) {
            if (action.actionName === data.action) {
              this.selectedAction = action;
              action._processParsedData(this._options, data);
              break;
            }
          }
          if (this.actions.length > 0 && !this.selectedAction) {
            const actions = this.actions.map((x) => x.actionName);
            throw new Error(`An action must be specified (${actions.join(", ")})`);
          }
          return this.onExecute();
        } catch (err) {
          if (err instanceof CommandLineParserExitError_1.CommandLineParserExitError) {
            if (!err.exitCode) {
              if (err.message) {
                console.log(err.message);
              }
              return;
            }
          }
          throw err;
        }
      }
      /** @internal */
      _registerDefinedParameters() {
        super._registerDefinedParameters();
        for (const action of this._actions) {
          action._registerDefinedParameters();
        }
      }
      _validateDefinitions() {
        if (this.remainder && this.actions.length > 0) {
          throw new Error("defineCommandLineRemainder() cannot be called for a CommandLineParser with actions");
        }
      }
      /**
       * {@inheritDoc CommandLineParameterProvider._getArgumentParser}
       * @internal
       */
      _getArgumentParser() {
        return this._argumentParser;
      }
      /**
       * This hook allows the subclass to perform additional operations before or after
       * the chosen action is executed.
       */
      async onExecute() {
        if (this.selectedAction) {
          await this.selectedAction._execute();
        }
      }
    };
    exports.CommandLineParser = CommandLineParser2;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/ScopedCommandLineAction.js
var require_ScopedCommandLineAction = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/ScopedCommandLineAction.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ScopedCommandLineAction = void 0;
    var Constants_1 = require_Constants();
    var CommandLineAction_1 = require_CommandLineAction();
    var CommandLineParser_1 = require_CommandLineParser();
    var CommandLineParserExitError_1 = require_CommandLineParserExitError();
    var InternalScopedCommandLineParser = class extends CommandLineParser_1.CommandLineParser {
      constructor(options) {
        const scopingArgs = [];
        for (const parameter of options.unscopedActionParameters) {
          parameter.appendToArgList(scopingArgs);
        }
        const unscopedToolName = `${options.toolFilename} ${options.actionOptions.actionName}`;
        const scopedCommandLineParserOptions = {
          toolFilename: `${unscopedToolName}${scopingArgs.length ? " " + scopingArgs.join(" ") : ""} --`,
          toolDescription: options.actionOptions.documentation,
          toolEpilog: `For more information on available unscoped parameters, use "${unscopedToolName} --help"`,
          enableTabCompletionAction: false
        };
        super(scopedCommandLineParserOptions);
        this._canExecute = false;
        this._internalOptions = options;
        this._internalOptions.onDefineScopedParameters(this);
      }
      get canExecute() {
        return this._canExecute;
      }
      async onExecute() {
        this._canExecute = true;
      }
    };
    var ScopedCommandLineAction = class extends CommandLineAction_1.CommandLineAction {
      constructor(options) {
        super(options);
        this._options = options;
        this._scopingParameters = [];
      }
      /**
       * {@inheritDoc CommandLineParameterProvider.parameters}
       */
      get parameters() {
        if (this._scopedCommandLineParser) {
          return [...super.parameters, ...this._scopedCommandLineParser.parameters];
        } else {
          return super.parameters;
        }
      }
      /**
       * {@inheritdoc CommandLineAction._processParsedData}
       * @internal
       */
      _processParsedData(parserOptions, data) {
        super._processParsedData(parserOptions, data);
        this._unscopedParserOptions = parserOptions;
        this._scopedCommandLineParser = new InternalScopedCommandLineParser(Object.assign(Object.assign({}, parserOptions), { actionOptions: this._options, unscopedActionParameters: this.parameters, onDefineScopedParameters: this.onDefineScopedParameters.bind(this) }));
      }
      /**
       * {@inheritdoc CommandLineAction._execute}
       * @internal
       */
      async _execute() {
        if (!this._unscopedParserOptions || !this._scopedCommandLineParser) {
          throw new Error("The CommandLineAction parameters must be processed before execution.");
        }
        if (!this.remainder) {
          throw new Error("CommandLineAction.onDefineParameters must be called before execution.");
        }
        const scopedArgs = [];
        if (this.remainder.values.length) {
          if (this.remainder.values[0] !== "--") {
            console.log(this.renderUsageText());
            throw new CommandLineParserExitError_1.CommandLineParserExitError(
              // argparse sets exit code 2 for invalid arguments
              2,
              // model the message off of the built-in "unrecognized arguments" message
              `${this._unscopedParserOptions.toolFilename} ${this.actionName}: error: Unrecognized arguments: ${this.remainder.values[0]}.`
            );
          }
          scopedArgs.push(...this.remainder.values.slice(1));
        }
        await this._scopedCommandLineParser.executeWithoutErrorHandling(scopedArgs);
        if (this._scopedCommandLineParser.canExecute) {
          await super._execute();
        }
        return;
      }
      /**
       * {@inheritdoc CommandLineParameterProvider.onDefineParameters}
       */
      onDefineParameters() {
        var _a;
        (_a = this.onDefineUnscopedParameters) === null || _a === void 0 ? void 0 : _a.call(this);
        if (!this._scopingParameters.length) {
          throw new Error("No scoping parameters defined. At least one scoping parameter must be defined. Scoping parameters are defined by setting the parameterGroupName to ScopedCommandLineAction.ScopingParameterGroupName.");
        }
        if (this.remainder) {
          throw new Error("Unscoped remainder parameters are not allowed. Remainder parameters can only be defined on the scoped parameter provider in onDefineScopedParameters().");
        }
        this.defineCommandLineRemainder({
          description: 'Scoped parameters.  Must be prefixed with "--", ex. "-- --scopedParameter foo --scopedFlag".  For more information on available scoped parameters, use "-- --help".'
        });
      }
      /**
       * Retrieves the scoped CommandLineParser, which is populated after the ScopedCommandLineAction is executed.
       * @internal
       */
      _getScopedCommandLineParser() {
        if (!this._scopedCommandLineParser) {
          throw new Error("The scoped CommandLineParser is only populated after the action is executed.");
        }
        return this._scopedCommandLineParser;
      }
      /** @internal */
      _defineParameter(parameter) {
        super._defineParameter(parameter);
        if (parameter.parameterGroup === ScopedCommandLineAction.ScopingParameterGroup) {
          this._scopingParameters.push(parameter);
        }
      }
    };
    exports.ScopedCommandLineAction = ScopedCommandLineAction;
    ScopedCommandLineAction.ScopingParameterGroup = Constants_1.SCOPING_PARAMETER_GROUP;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/DynamicCommandLineParser.js
var require_DynamicCommandLineParser = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/providers/DynamicCommandLineParser.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DynamicCommandLineParser = void 0;
    var CommandLineParser_1 = require_CommandLineParser();
    var DynamicCommandLineParser = class extends CommandLineParser_1.CommandLineParser {
    };
    exports.DynamicCommandLineParser = DynamicCommandLineParser;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/CommandLineHelper.js
var require_CommandLineHelper = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/CommandLineHelper.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineHelper = void 0;
    var CommandLineHelper = class {
      /**
       * Returns true if the current command line action is tab-complete.
       *
       * @public
       */
      static isTabCompletionActionRequest(argv) {
        return argv && argv.length > 2 && argv[2] === "tab-complete";
      }
    };
    exports.CommandLineHelper = CommandLineHelper;
  }
});

// ../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/index.js
var require_lib2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/@rushstack+ts-command-line@4.13.2/node_modules/@rushstack/ts-command-line/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CommandLineHelper = exports.DynamicCommandLineParser = exports.CommandLineParser = exports.CommandLineParameterProvider = exports.CommandLineRemainder = exports.CommandLineChoiceListParameter = exports.CommandLineChoiceParameter = exports.CommandLineIntegerListParameter = exports.CommandLineIntegerParameter = exports.CommandLineStringListParameter = exports.CommandLineStringParameter = exports.CommandLineFlagParameter = exports.CommandLineParameterWithArgument = exports.CommandLineParameter = exports.CommandLineParameterKind = exports.ScopedCommandLineAction = exports.DynamicCommandLineAction = exports.CommandLineAction = void 0;
    var CommandLineAction_1 = require_CommandLineAction();
    Object.defineProperty(exports, "CommandLineAction", { enumerable: true, get: function() {
      return CommandLineAction_1.CommandLineAction;
    } });
    var DynamicCommandLineAction_1 = require_DynamicCommandLineAction();
    Object.defineProperty(exports, "DynamicCommandLineAction", { enumerable: true, get: function() {
      return DynamicCommandLineAction_1.DynamicCommandLineAction;
    } });
    var ScopedCommandLineAction_1 = require_ScopedCommandLineAction();
    Object.defineProperty(exports, "ScopedCommandLineAction", { enumerable: true, get: function() {
      return ScopedCommandLineAction_1.ScopedCommandLineAction;
    } });
    var BaseClasses_1 = require_BaseClasses();
    Object.defineProperty(exports, "CommandLineParameterKind", { enumerable: true, get: function() {
      return BaseClasses_1.CommandLineParameterKind;
    } });
    Object.defineProperty(exports, "CommandLineParameter", { enumerable: true, get: function() {
      return BaseClasses_1.CommandLineParameter;
    } });
    Object.defineProperty(exports, "CommandLineParameterWithArgument", { enumerable: true, get: function() {
      return BaseClasses_1.CommandLineParameterWithArgument;
    } });
    var CommandLineFlagParameter_1 = require_CommandLineFlagParameter();
    Object.defineProperty(exports, "CommandLineFlagParameter", { enumerable: true, get: function() {
      return CommandLineFlagParameter_1.CommandLineFlagParameter;
    } });
    var CommandLineStringParameter_1 = require_CommandLineStringParameter();
    Object.defineProperty(exports, "CommandLineStringParameter", { enumerable: true, get: function() {
      return CommandLineStringParameter_1.CommandLineStringParameter;
    } });
    var CommandLineStringListParameter_1 = require_CommandLineStringListParameter();
    Object.defineProperty(exports, "CommandLineStringListParameter", { enumerable: true, get: function() {
      return CommandLineStringListParameter_1.CommandLineStringListParameter;
    } });
    var CommandLineIntegerParameter_1 = require_CommandLineIntegerParameter();
    Object.defineProperty(exports, "CommandLineIntegerParameter", { enumerable: true, get: function() {
      return CommandLineIntegerParameter_1.CommandLineIntegerParameter;
    } });
    var CommandLineIntegerListParameter_1 = require_CommandLineIntegerListParameter();
    Object.defineProperty(exports, "CommandLineIntegerListParameter", { enumerable: true, get: function() {
      return CommandLineIntegerListParameter_1.CommandLineIntegerListParameter;
    } });
    var CommandLineChoiceParameter_1 = require_CommandLineChoiceParameter();
    Object.defineProperty(exports, "CommandLineChoiceParameter", { enumerable: true, get: function() {
      return CommandLineChoiceParameter_1.CommandLineChoiceParameter;
    } });
    var CommandLineChoiceListParameter_1 = require_CommandLineChoiceListParameter();
    Object.defineProperty(exports, "CommandLineChoiceListParameter", { enumerable: true, get: function() {
      return CommandLineChoiceListParameter_1.CommandLineChoiceListParameter;
    } });
    var CommandLineRemainder_1 = require_CommandLineRemainder();
    Object.defineProperty(exports, "CommandLineRemainder", { enumerable: true, get: function() {
      return CommandLineRemainder_1.CommandLineRemainder;
    } });
    var CommandLineParameterProvider_1 = require_CommandLineParameterProvider();
    Object.defineProperty(exports, "CommandLineParameterProvider", { enumerable: true, get: function() {
      return CommandLineParameterProvider_1.CommandLineParameterProvider;
    } });
    var CommandLineParser_1 = require_CommandLineParser();
    Object.defineProperty(exports, "CommandLineParser", { enumerable: true, get: function() {
      return CommandLineParser_1.CommandLineParser;
    } });
    var DynamicCommandLineParser_1 = require_DynamicCommandLineParser();
    Object.defineProperty(exports, "DynamicCommandLineParser", { enumerable: true, get: function() {
      return DynamicCommandLineParser_1.DynamicCommandLineParser;
    } });
    var CommandLineHelper_1 = require_CommandLineHelper();
    Object.defineProperty(exports, "CommandLineHelper", { enumerable: true, get: function() {
      return CommandLineHelper_1.CommandLineHelper;
    } });
  }
});

// ../../common/temp/node_modules/.pnpm/ms@2.0.0/node_modules/ms/index.js
var require_ms = __commonJS({
  "../../common/temp/node_modules/.pnpm/ms@2.0.0/node_modules/ms/index.js"(exports, module) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var y = d * 365.25;
    module.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse(val);
      } else if (type === "number" && isNaN(val) === false) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error(
        "val is not a non-empty string or a valid number. val=" + JSON.stringify(val)
      );
    };
    function parse(str) {
      str = String(str);
      if (str.length > 100) {
        return;
      }
      var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(
        str
      );
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "days":
        case "day":
        case "d":
          return n * d;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      if (ms >= d) {
        return Math.round(ms / d) + "d";
      }
      if (ms >= h) {
        return Math.round(ms / h) + "h";
      }
      if (ms >= m) {
        return Math.round(ms / m) + "m";
      }
      if (ms >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      return plural(ms, d, "day") || plural(ms, h, "hour") || plural(ms, m, "minute") || plural(ms, s, "second") || ms + " ms";
    }
    function plural(ms, n, name) {
      if (ms < n) {
        return;
      }
      if (ms < n * 1.5) {
        return Math.floor(ms / n) + " " + name;
      }
      return Math.ceil(ms / n) + " " + name + "s";
    }
  }
});

// ../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/debug.js
var require_debug = __commonJS({
  "../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/debug.js"(exports, module) {
    exports = module.exports = createDebug.debug = createDebug["default"] = createDebug;
    exports.coerce = coerce;
    exports.disable = disable;
    exports.enable = enable;
    exports.enabled = enabled;
    exports.humanize = require_ms();
    exports.names = [];
    exports.skips = [];
    exports.formatters = {};
    var prevTime;
    function selectColor(namespace) {
      var hash = 0, i;
      for (i in namespace) {
        hash = (hash << 5) - hash + namespace.charCodeAt(i);
        hash |= 0;
      }
      return exports.colors[Math.abs(hash) % exports.colors.length];
    }
    function createDebug(namespace) {
      function debug() {
        if (!debug.enabled)
          return;
        var self = debug;
        var curr = +/* @__PURE__ */ new Date();
        var ms = curr - (prevTime || curr);
        self.diff = ms;
        self.prev = prevTime;
        self.curr = curr;
        prevTime = curr;
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        args[0] = exports.coerce(args[0]);
        if ("string" !== typeof args[0]) {
          args.unshift("%O");
        }
        var index = 0;
        args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
          if (match === "%%")
            return match;
          index++;
          var formatter = exports.formatters[format];
          if ("function" === typeof formatter) {
            var val = args[index];
            match = formatter.call(self, val);
            args.splice(index, 1);
            index--;
          }
          return match;
        });
        exports.formatArgs.call(self, args);
        var logFn = debug.log || exports.log || console.log.bind(console);
        logFn.apply(self, args);
      }
      debug.namespace = namespace;
      debug.enabled = exports.enabled(namespace);
      debug.useColors = exports.useColors();
      debug.color = selectColor(namespace);
      if ("function" === typeof exports.init) {
        exports.init(debug);
      }
      return debug;
    }
    function enable(namespaces) {
      exports.save(namespaces);
      exports.names = [];
      exports.skips = [];
      var split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
      var len = split.length;
      for (var i = 0; i < len; i++) {
        if (!split[i])
          continue;
        namespaces = split[i].replace(/\*/g, ".*?");
        if (namespaces[0] === "-") {
          exports.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
        } else {
          exports.names.push(new RegExp("^" + namespaces + "$"));
        }
      }
    }
    function disable() {
      exports.enable("");
    }
    function enabled(name) {
      var i, len;
      for (i = 0, len = exports.skips.length; i < len; i++) {
        if (exports.skips[i].test(name)) {
          return false;
        }
      }
      for (i = 0, len = exports.names.length; i < len; i++) {
        if (exports.names[i].test(name)) {
          return true;
        }
      }
      return false;
    }
    function coerce(val) {
      if (val instanceof Error)
        return val.stack || val.message;
      return val;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/browser.js
var require_browser = __commonJS({
  "../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/browser.js"(exports, module) {
    exports = module.exports = require_debug();
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = "undefined" != typeof chrome && "undefined" != typeof chrome.storage ? chrome.storage.local : localstorage();
    exports.colors = [
      "lightseagreen",
      "forestgreen",
      "goldenrod",
      "dodgerblue",
      "darkorchid",
      "crimson"
    ];
    function useColors() {
      if (typeof window !== "undefined" && window.process && window.process.type === "renderer") {
        return true;
      }
      return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || // is firebug? http://stackoverflow.com/a/398120/376773
      typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || // is firefox >= v31?
      // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
      typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || // double check webkit in userAgent just in case we are in a worker
      typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    exports.formatters.j = function(v) {
      try {
        return JSON.stringify(v);
      } catch (err) {
        return "[UnexpectedJSONParseError]: " + err.message;
      }
    };
    function formatArgs(args) {
      var useColors2 = this.useColors;
      args[0] = (useColors2 ? "%c" : "") + this.namespace + (useColors2 ? " %c" : " ") + args[0] + (useColors2 ? "%c " : " ") + "+" + exports.humanize(this.diff);
      if (!useColors2)
        return;
      var c = "color: " + this.color;
      args.splice(1, 0, c, "color: inherit");
      var index = 0;
      var lastC = 0;
      args[0].replace(/%[a-zA-Z%]/g, function(match) {
        if ("%%" === match)
          return;
        index++;
        if ("%c" === match) {
          lastC = index;
        }
      });
      args.splice(lastC, 0, c);
    }
    function log() {
      return "object" === typeof console && console.log && Function.prototype.apply.call(console.log, console, arguments);
    }
    function save(namespaces) {
      try {
        if (null == namespaces) {
          exports.storage.removeItem("debug");
        } else {
          exports.storage.debug = namespaces;
        }
      } catch (e) {
      }
    }
    function load() {
      var r;
      try {
        r = exports.storage.debug;
      } catch (e) {
      }
      if (!r && typeof process !== "undefined" && "env" in process) {
        r = process.env.DEBUG;
      }
      return r;
    }
    exports.enable(load());
    function localstorage() {
      try {
        return window.localStorage;
      } catch (e) {
      }
    }
  }
});

// ../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/node.js
var require_node = __commonJS({
  "../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/node.js"(exports, module) {
    var tty = __require("tty");
    var util = __require("util");
    exports = module.exports = require_debug();
    exports.init = init;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.colors = [6, 2, 3, 4, 5, 1];
    exports.inspectOpts = Object.keys(process.env).filter(function(key) {
      return /^debug_/i.test(key);
    }).reduce(function(obj, key) {
      var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, function(_, k) {
        return k.toUpperCase();
      });
      var val = process.env[key];
      if (/^(yes|on|true|enabled)$/i.test(val))
        val = true;
      else if (/^(no|off|false|disabled)$/i.test(val))
        val = false;
      else if (val === "null")
        val = null;
      else
        val = Number(val);
      obj[prop] = val;
      return obj;
    }, {});
    var fd = parseInt(process.env.DEBUG_FD, 10) || 2;
    if (1 !== fd && 2 !== fd) {
      util.deprecate(function() {
      }, "except for stderr(2) and stdout(1), any other usage of DEBUG_FD is deprecated. Override debug.log if you want to use a different log function (https://git.io/debug_fd)")();
    }
    var stream = 1 === fd ? process.stdout : 2 === fd ? process.stderr : createWritableStdioStream(fd);
    function useColors() {
      return "colors" in exports.inspectOpts ? Boolean(exports.inspectOpts.colors) : tty.isatty(fd);
    }
    exports.formatters.o = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts).split("\n").map(function(str) {
        return str.trim();
      }).join(" ");
    };
    exports.formatters.O = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts);
    };
    function formatArgs(args) {
      var name = this.namespace;
      var useColors2 = this.useColors;
      if (useColors2) {
        var c = this.color;
        var prefix = "  \x1B[3" + c + ";1m" + name + " \x1B[0m";
        args[0] = prefix + args[0].split("\n").join("\n" + prefix);
        args.push("\x1B[3" + c + "m+" + exports.humanize(this.diff) + "\x1B[0m");
      } else {
        args[0] = (/* @__PURE__ */ new Date()).toUTCString() + " " + name + " " + args[0];
      }
    }
    function log() {
      return stream.write(util.format.apply(util, arguments) + "\n");
    }
    function save(namespaces) {
      if (null == namespaces) {
        delete process.env.DEBUG;
      } else {
        process.env.DEBUG = namespaces;
      }
    }
    function load() {
      return process.env.DEBUG;
    }
    function createWritableStdioStream(fd2) {
      var stream2;
      var tty_wrap = process.binding("tty_wrap");
      switch (tty_wrap.guessHandleType(fd2)) {
        case "TTY":
          stream2 = new tty.WriteStream(fd2);
          stream2._type = "tty";
          if (stream2._handle && stream2._handle.unref) {
            stream2._handle.unref();
          }
          break;
        case "FILE":
          var fs = __require("fs");
          stream2 = new fs.SyncWriteStream(fd2, { autoClose: false });
          stream2._type = "fs";
          break;
        case "PIPE":
        case "TCP":
          var net = __require("net");
          stream2 = new net.Socket({
            fd: fd2,
            readable: false,
            writable: true
          });
          stream2.readable = false;
          stream2.read = null;
          stream2._type = "pipe";
          if (stream2._handle && stream2._handle.unref) {
            stream2._handle.unref();
          }
          break;
        default:
          throw new Error("Implement me. Unknown stream file type!");
      }
      stream2.fd = fd2;
      stream2._isStdio = true;
      return stream2;
    }
    function init(debug) {
      debug.inspectOpts = {};
      var keys = Object.keys(exports.inspectOpts);
      for (var i = 0; i < keys.length; i++) {
        debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
      }
    }
    exports.enable(load());
  }
});

// ../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/index.js
var require_src = __commonJS({
  "../../common/temp/node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/index.js"(exports, module) {
    if (typeof process !== "undefined" && process.type === "renderer") {
      module.exports = require_browser();
    } else {
      module.exports = require_node();
    }
  }
});

// ../../common/temp/node_modules/.pnpm/encodeurl@1.0.2/node_modules/encodeurl/index.js
var require_encodeurl = __commonJS({
  "../../common/temp/node_modules/.pnpm/encodeurl@1.0.2/node_modules/encodeurl/index.js"(exports, module) {
    "use strict";
    module.exports = encodeUrl;
    var ENCODE_CHARS_REGEXP = /(?:[^\x21\x25\x26-\x3B\x3D\x3F-\x5B\x5D\x5F\x61-\x7A\x7E]|%(?:[^0-9A-Fa-f]|[0-9A-Fa-f][^0-9A-Fa-f]|$))+/g;
    var UNMATCHED_SURROGATE_PAIR_REGEXP = /(^|[^\uD800-\uDBFF])[\uDC00-\uDFFF]|[\uD800-\uDBFF]([^\uDC00-\uDFFF]|$)/g;
    var UNMATCHED_SURROGATE_PAIR_REPLACE = "$1\uFFFD$2";
    function encodeUrl(url) {
      return String(url).replace(UNMATCHED_SURROGATE_PAIR_REGEXP, UNMATCHED_SURROGATE_PAIR_REPLACE).replace(ENCODE_CHARS_REGEXP, encodeURI);
    }
  }
});

// ../../common/temp/node_modules/.pnpm/escape-html@1.0.3/node_modules/escape-html/index.js
var require_escape_html = __commonJS({
  "../../common/temp/node_modules/.pnpm/escape-html@1.0.3/node_modules/escape-html/index.js"(exports, module) {
    "use strict";
    var matchHtmlRegExp = /["'&<>]/;
    module.exports = escapeHtml;
    function escapeHtml(string) {
      var str = "" + string;
      var match = matchHtmlRegExp.exec(str);
      if (!match) {
        return str;
      }
      var escape;
      var html = "";
      var index = 0;
      var lastIndex = 0;
      for (index = match.index; index < str.length; index++) {
        switch (str.charCodeAt(index)) {
          case 34:
            escape = "&quot;";
            break;
          case 38:
            escape = "&amp;";
            break;
          case 39:
            escape = "&#39;";
            break;
          case 60:
            escape = "&lt;";
            break;
          case 62:
            escape = "&gt;";
            break;
          default:
            continue;
        }
        if (lastIndex !== index) {
          html += str.substring(lastIndex, index);
        }
        lastIndex = index + 1;
        html += escape;
      }
      return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/ee-first@1.1.1/node_modules/ee-first/index.js
var require_ee_first = __commonJS({
  "../../common/temp/node_modules/.pnpm/ee-first@1.1.1/node_modules/ee-first/index.js"(exports, module) {
    "use strict";
    module.exports = first;
    function first(stuff, done) {
      if (!Array.isArray(stuff))
        throw new TypeError("arg must be an array of [ee, events...] arrays");
      var cleanups = [];
      for (var i = 0; i < stuff.length; i++) {
        var arr = stuff[i];
        if (!Array.isArray(arr) || arr.length < 2)
          throw new TypeError("each array member must be [ee, events...]");
        var ee = arr[0];
        for (var j = 1; j < arr.length; j++) {
          var event = arr[j];
          var fn = listener(event, callback);
          ee.on(event, fn);
          cleanups.push({
            ee,
            event,
            fn
          });
        }
      }
      function callback() {
        cleanup();
        done.apply(null, arguments);
      }
      function cleanup() {
        var x;
        for (var i2 = 0; i2 < cleanups.length; i2++) {
          x = cleanups[i2];
          x.ee.removeListener(x.event, x.fn);
        }
      }
      function thunk(fn2) {
        done = fn2;
      }
      thunk.cancel = cleanup;
      return thunk;
    }
    function listener(event, done) {
      return function onevent(arg1) {
        var args = new Array(arguments.length);
        var ee = this;
        var err = event === "error" ? arg1 : null;
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        done(err, ee, event, args);
      };
    }
  }
});

// ../../common/temp/node_modules/.pnpm/on-finished@2.3.0/node_modules/on-finished/index.js
var require_on_finished = __commonJS({
  "../../common/temp/node_modules/.pnpm/on-finished@2.3.0/node_modules/on-finished/index.js"(exports, module) {
    "use strict";
    module.exports = onFinished;
    module.exports.isFinished = isFinished;
    var first = require_ee_first();
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn) {
      process.nextTick(fn.bind.apply(fn, arguments));
    };
    function onFinished(msg, listener) {
      if (isFinished(msg) !== false) {
        defer(listener, null, msg);
        return msg;
      }
      attachListener(msg, listener);
      return msg;
    }
    function isFinished(msg) {
      var socket = msg.socket;
      if (typeof msg.finished === "boolean") {
        return Boolean(msg.finished || socket && !socket.writable);
      }
      if (typeof msg.complete === "boolean") {
        return Boolean(msg.upgrade || !socket || !socket.readable || msg.complete && !msg.readable);
      }
      return void 0;
    }
    function attachFinishedListener(msg, callback) {
      var eeMsg;
      var eeSocket;
      var finished = false;
      function onFinish(error) {
        eeMsg.cancel();
        eeSocket.cancel();
        finished = true;
        callback(error);
      }
      eeMsg = eeSocket = first([[msg, "end", "finish"]], onFinish);
      function onSocket(socket) {
        msg.removeListener("socket", onSocket);
        if (finished)
          return;
        if (eeMsg !== eeSocket)
          return;
        eeSocket = first([[socket, "error", "close"]], onFinish);
      }
      if (msg.socket) {
        onSocket(msg.socket);
        return;
      }
      msg.on("socket", onSocket);
      if (msg.socket === void 0) {
        patchAssignSocket(msg, onSocket);
      }
    }
    function attachListener(msg, listener) {
      var attached = msg.__onFinished;
      if (!attached || !attached.queue) {
        attached = msg.__onFinished = createListener(msg);
        attachFinishedListener(msg, attached);
      }
      attached.queue.push(listener);
    }
    function createListener(msg) {
      function listener(err) {
        if (msg.__onFinished === listener)
          msg.__onFinished = null;
        if (!listener.queue)
          return;
        var queue = listener.queue;
        listener.queue = null;
        for (var i = 0; i < queue.length; i++) {
          queue[i](err, msg);
        }
      }
      listener.queue = [];
      return listener;
    }
    function patchAssignSocket(res, callback) {
      var assignSocket = res.assignSocket;
      if (typeof assignSocket !== "function")
        return;
      res.assignSocket = function _assignSocket(socket) {
        assignSocket.call(this, socket);
        callback(socket);
      };
    }
  }
});

// ../../common/temp/node_modules/.pnpm/parseurl@1.3.3/node_modules/parseurl/index.js
var require_parseurl = __commonJS({
  "../../common/temp/node_modules/.pnpm/parseurl@1.3.3/node_modules/parseurl/index.js"(exports, module) {
    "use strict";
    var url = __require("url");
    var parse = url.parse;
    var Url = url.Url;
    module.exports = parseurl;
    module.exports.original = originalurl;
    function parseurl(req) {
      var url2 = req.url;
      if (url2 === void 0) {
        return void 0;
      }
      var parsed = req._parsedUrl;
      if (fresh(url2, parsed)) {
        return parsed;
      }
      parsed = fastparse(url2);
      parsed._raw = url2;
      return req._parsedUrl = parsed;
    }
    function originalurl(req) {
      var url2 = req.originalUrl;
      if (typeof url2 !== "string") {
        return parseurl(req);
      }
      var parsed = req._parsedOriginalUrl;
      if (fresh(url2, parsed)) {
        return parsed;
      }
      parsed = fastparse(url2);
      parsed._raw = url2;
      return req._parsedOriginalUrl = parsed;
    }
    function fastparse(str) {
      if (typeof str !== "string" || str.charCodeAt(0) !== 47) {
        return parse(str);
      }
      var pathname = str;
      var query = null;
      var search = null;
      for (var i = 1; i < str.length; i++) {
        switch (str.charCodeAt(i)) {
          case 63:
            if (search === null) {
              pathname = str.substring(0, i);
              query = str.substring(i + 1);
              search = str.substring(i);
            }
            break;
          case 9:
          case 10:
          case 12:
          case 13:
          case 32:
          case 35:
          case 160:
          case 65279:
            return parse(str);
        }
      }
      var url2 = Url !== void 0 ? new Url() : {};
      url2.path = str;
      url2.href = str;
      url2.pathname = pathname;
      if (search !== null) {
        url2.query = query;
        url2.search = search;
      }
      return url2;
    }
    function fresh(url2, parsedUrl) {
      return typeof parsedUrl === "object" && parsedUrl !== null && (Url === void 0 || parsedUrl instanceof Url) && parsedUrl._raw === url2;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/statuses@1.5.0/node_modules/statuses/codes.json
var require_codes = __commonJS({
  "../../common/temp/node_modules/.pnpm/statuses@1.5.0/node_modules/statuses/codes.json"(exports, module) {
    module.exports = {
      "100": "Continue",
      "101": "Switching Protocols",
      "102": "Processing",
      "103": "Early Hints",
      "200": "OK",
      "201": "Created",
      "202": "Accepted",
      "203": "Non-Authoritative Information",
      "204": "No Content",
      "205": "Reset Content",
      "206": "Partial Content",
      "207": "Multi-Status",
      "208": "Already Reported",
      "226": "IM Used",
      "300": "Multiple Choices",
      "301": "Moved Permanently",
      "302": "Found",
      "303": "See Other",
      "304": "Not Modified",
      "305": "Use Proxy",
      "306": "(Unused)",
      "307": "Temporary Redirect",
      "308": "Permanent Redirect",
      "400": "Bad Request",
      "401": "Unauthorized",
      "402": "Payment Required",
      "403": "Forbidden",
      "404": "Not Found",
      "405": "Method Not Allowed",
      "406": "Not Acceptable",
      "407": "Proxy Authentication Required",
      "408": "Request Timeout",
      "409": "Conflict",
      "410": "Gone",
      "411": "Length Required",
      "412": "Precondition Failed",
      "413": "Payload Too Large",
      "414": "URI Too Long",
      "415": "Unsupported Media Type",
      "416": "Range Not Satisfiable",
      "417": "Expectation Failed",
      "418": "I'm a teapot",
      "421": "Misdirected Request",
      "422": "Unprocessable Entity",
      "423": "Locked",
      "424": "Failed Dependency",
      "425": "Unordered Collection",
      "426": "Upgrade Required",
      "428": "Precondition Required",
      "429": "Too Many Requests",
      "431": "Request Header Fields Too Large",
      "451": "Unavailable For Legal Reasons",
      "500": "Internal Server Error",
      "501": "Not Implemented",
      "502": "Bad Gateway",
      "503": "Service Unavailable",
      "504": "Gateway Timeout",
      "505": "HTTP Version Not Supported",
      "506": "Variant Also Negotiates",
      "507": "Insufficient Storage",
      "508": "Loop Detected",
      "509": "Bandwidth Limit Exceeded",
      "510": "Not Extended",
      "511": "Network Authentication Required"
    };
  }
});

// ../../common/temp/node_modules/.pnpm/statuses@1.5.0/node_modules/statuses/index.js
var require_statuses = __commonJS({
  "../../common/temp/node_modules/.pnpm/statuses@1.5.0/node_modules/statuses/index.js"(exports, module) {
    "use strict";
    var codes = require_codes();
    module.exports = status;
    status.STATUS_CODES = codes;
    status.codes = populateStatusesMap(status, codes);
    status.redirect = {
      300: true,
      301: true,
      302: true,
      303: true,
      305: true,
      307: true,
      308: true
    };
    status.empty = {
      204: true,
      205: true,
      304: true
    };
    status.retry = {
      502: true,
      503: true,
      504: true
    };
    function populateStatusesMap(statuses, codes2) {
      var arr = [];
      Object.keys(codes2).forEach(function forEachCode(code) {
        var message = codes2[code];
        var status2 = Number(code);
        statuses[status2] = message;
        statuses[message] = status2;
        statuses[message.toLowerCase()] = status2;
        arr.push(status2);
      });
      return arr;
    }
    function status(code) {
      if (typeof code === "number") {
        if (!status[code])
          throw new Error("invalid status code: " + code);
        return code;
      }
      if (typeof code !== "string") {
        throw new TypeError("code must be a number or string");
      }
      var n = parseInt(code, 10);
      if (!isNaN(n)) {
        if (!status[n])
          throw new Error("invalid status code: " + n);
        return n;
      }
      n = status[code.toLowerCase()];
      if (!n)
        throw new Error('invalid status message: "' + code + '"');
      return n;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/unpipe@1.0.0/node_modules/unpipe/index.js
var require_unpipe = __commonJS({
  "../../common/temp/node_modules/.pnpm/unpipe@1.0.0/node_modules/unpipe/index.js"(exports, module) {
    "use strict";
    module.exports = unpipe;
    function hasPipeDataListeners(stream) {
      var listeners = stream.listeners("data");
      for (var i = 0; i < listeners.length; i++) {
        if (listeners[i].name === "ondata") {
          return true;
        }
      }
      return false;
    }
    function unpipe(stream) {
      if (!stream) {
        throw new TypeError("argument stream is required");
      }
      if (typeof stream.unpipe === "function") {
        stream.unpipe();
        return;
      }
      if (!hasPipeDataListeners(stream)) {
        return;
      }
      var listener;
      var listeners = stream.listeners("close");
      for (var i = 0; i < listeners.length; i++) {
        listener = listeners[i];
        if (listener.name !== "cleanup" && listener.name !== "onclose") {
          continue;
        }
        listener.call(stream);
      }
    }
  }
});

// ../../common/temp/node_modules/.pnpm/finalhandler@1.1.2/node_modules/finalhandler/index.js
var require_finalhandler = __commonJS({
  "../../common/temp/node_modules/.pnpm/finalhandler@1.1.2/node_modules/finalhandler/index.js"(exports, module) {
    "use strict";
    var debug = require_src()("finalhandler");
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var onFinished = require_on_finished();
    var parseUrl = require_parseurl();
    var statuses = require_statuses();
    var unpipe = require_unpipe();
    var DOUBLE_SPACE_REGEXP = /\x20{2}/g;
    var NEWLINE_REGEXP = /\n/g;
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn) {
      process.nextTick(fn.bind.apply(fn, arguments));
    };
    var isFinished = onFinished.isFinished;
    function createHtmlDocument(message) {
      var body = escapeHtml(message).replace(NEWLINE_REGEXP, "<br>").replace(DOUBLE_SPACE_REGEXP, " &nbsp;");
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>Error</title>\n</head>\n<body>\n<pre>' + body + "</pre>\n</body>\n</html>\n";
    }
    module.exports = finalhandler;
    function finalhandler(req, res, options) {
      var opts = options || {};
      var env = opts.env || process.env.NODE_ENV || "development";
      var onerror = opts.onerror;
      return function(err) {
        var headers;
        var msg;
        var status;
        if (!err && headersSent(res)) {
          debug("cannot 404 after headers sent");
          return;
        }
        if (err) {
          status = getErrorStatusCode(err);
          if (status === void 0) {
            status = getResponseStatusCode(res);
          } else {
            headers = getErrorHeaders(err);
          }
          msg = getErrorMessage(err, status, env);
        } else {
          status = 404;
          msg = "Cannot " + req.method + " " + encodeUrl(getResourceName(req));
        }
        debug("default %s", status);
        if (err && onerror) {
          defer(onerror, err, req, res);
        }
        if (headersSent(res)) {
          debug("cannot %d after headers sent", status);
          req.socket.destroy();
          return;
        }
        send(req, res, status, headers, msg);
      };
    }
    function getErrorHeaders(err) {
      if (!err.headers || typeof err.headers !== "object") {
        return void 0;
      }
      var headers = /* @__PURE__ */ Object.create(null);
      var keys = Object.keys(err.headers);
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        headers[key] = err.headers[key];
      }
      return headers;
    }
    function getErrorMessage(err, status, env) {
      var msg;
      if (env !== "production") {
        msg = err.stack;
        if (!msg && typeof err.toString === "function") {
          msg = err.toString();
        }
      }
      return msg || statuses[status];
    }
    function getErrorStatusCode(err) {
      if (typeof err.status === "number" && err.status >= 400 && err.status < 600) {
        return err.status;
      }
      if (typeof err.statusCode === "number" && err.statusCode >= 400 && err.statusCode < 600) {
        return err.statusCode;
      }
      return void 0;
    }
    function getResourceName(req) {
      try {
        return parseUrl.original(req).pathname;
      } catch (e) {
        return "resource";
      }
    }
    function getResponseStatusCode(res) {
      var status = res.statusCode;
      if (typeof status !== "number" || status < 400 || status > 599) {
        status = 500;
      }
      return status;
    }
    function headersSent(res) {
      return typeof res.headersSent !== "boolean" ? Boolean(res._header) : res.headersSent;
    }
    function send(req, res, status, headers, message) {
      function write() {
        var body = createHtmlDocument(message);
        res.statusCode = status;
        res.statusMessage = statuses[status];
        setHeaders(res, headers);
        res.setHeader("Content-Security-Policy", "default-src 'none'");
        res.setHeader("X-Content-Type-Options", "nosniff");
        res.setHeader("Content-Type", "text/html; charset=utf-8");
        res.setHeader("Content-Length", Buffer.byteLength(body, "utf8"));
        if (req.method === "HEAD") {
          res.end();
          return;
        }
        res.end(body, "utf8");
      }
      if (isFinished(req)) {
        write();
        return;
      }
      unpipe(req);
      onFinished(req, write);
      req.resume();
    }
    function setHeaders(res, headers) {
      if (!headers) {
        return;
      }
      var keys = Object.keys(headers);
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// ../../common/temp/node_modules/.pnpm/utils-merge@1.0.1/node_modules/utils-merge/index.js
var require_utils_merge = __commonJS({
  "../../common/temp/node_modules/.pnpm/utils-merge@1.0.1/node_modules/utils-merge/index.js"(exports, module) {
    exports = module.exports = function(a, b) {
      if (a && b) {
        for (var key in b) {
          a[key] = b[key];
        }
      }
      return a;
    };
  }
});

// ../../common/temp/node_modules/.pnpm/connect@3.7.0/node_modules/connect/index.js
var require_connect = __commonJS({
  "../../common/temp/node_modules/.pnpm/connect@3.7.0/node_modules/connect/index.js"(exports, module) {
    "use strict";
    var debug = require_src()("connect:dispatcher");
    var EventEmitter = __require("events").EventEmitter;
    var finalhandler = require_finalhandler();
    var http = __require("http");
    var merge = require_utils_merge();
    var parseUrl = require_parseurl();
    module.exports = createServer;
    var env = process.env.NODE_ENV || "development";
    var proto = {};
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn) {
      process.nextTick(fn.bind.apply(fn, arguments));
    };
    function createServer() {
      function app(req, res, next) {
        app.handle(req, res, next);
      }
      merge(app, proto);
      merge(app, EventEmitter.prototype);
      app.route = "/";
      app.stack = [];
      return app;
    }
    proto.use = function use(route, fn) {
      var handle = fn;
      var path = route;
      if (typeof route !== "string") {
        handle = route;
        path = "/";
      }
      if (typeof handle.handle === "function") {
        var server = handle;
        server.route = path;
        handle = function(req, res, next) {
          server.handle(req, res, next);
        };
      }
      if (handle instanceof http.Server) {
        handle = handle.listeners("request")[0];
      }
      if (path[path.length - 1] === "/") {
        path = path.slice(0, -1);
      }
      debug("use %s %s", path || "/", handle.name || "anonymous");
      this.stack.push({ route: path, handle });
      return this;
    };
    proto.handle = function handle(req, res, out) {
      var index = 0;
      var protohost = getProtohost(req.url) || "";
      var removed = "";
      var slashAdded = false;
      var stack = this.stack;
      var done = out || finalhandler(req, res, {
        env,
        onerror: logerror
      });
      req.originalUrl = req.originalUrl || req.url;
      function next(err) {
        if (slashAdded) {
          req.url = req.url.substr(1);
          slashAdded = false;
        }
        if (removed.length !== 0) {
          req.url = protohost + removed + req.url.substr(protohost.length);
          removed = "";
        }
        var layer = stack[index++];
        if (!layer) {
          defer(done, err);
          return;
        }
        var path = parseUrl(req).pathname || "/";
        var route = layer.route;
        if (path.toLowerCase().substr(0, route.length) !== route.toLowerCase()) {
          return next(err);
        }
        var c = path.length > route.length && path[route.length];
        if (c && c !== "/" && c !== ".") {
          return next(err);
        }
        if (route.length !== 0 && route !== "/") {
          removed = route;
          req.url = protohost + req.url.substr(protohost.length + removed.length);
          if (!protohost && req.url[0] !== "/") {
            req.url = "/" + req.url;
            slashAdded = true;
          }
        }
        call(layer.handle, route, err, req, res, next);
      }
      next();
    };
    proto.listen = function listen() {
      var server = http.createServer(this);
      return server.listen.apply(server, arguments);
    };
    function call(handle, route, err, req, res, next) {
      var arity = handle.length;
      var error = err;
      var hasError = Boolean(err);
      debug("%s %s : %s", handle.name || "<anonymous>", route, req.originalUrl);
      try {
        if (hasError && arity === 4) {
          handle(err, req, res, next);
          return;
        } else if (!hasError && arity < 4) {
          handle(req, res, next);
          return;
        }
      } catch (e) {
        error = e;
      }
      next(error);
    }
    function logerror(err) {
      if (env !== "test")
        console.error(err.stack || err.toString());
    }
    function getProtohost(url) {
      if (url.length === 0 || url[0] === "/") {
        return void 0;
      }
      var fqdnIndex = url.indexOf("://");
      return fqdnIndex !== -1 && url.lastIndexOf("?", fqdnIndex) === -1 ? url.substr(0, url.indexOf("/", 3 + fqdnIndex)) : void 0;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/depd@2.0.0/node_modules/depd/index.js
var require_depd = __commonJS({
  "../../common/temp/node_modules/.pnpm/depd@2.0.0/node_modules/depd/index.js"(exports, module) {
    var relative = __require("path").relative;
    module.exports = depd;
    var basePath = process.cwd();
    function containsNamespace(str, namespace) {
      var vals = str.split(/[ ,]+/);
      var ns = String(namespace).toLowerCase();
      for (var i = 0; i < vals.length; i++) {
        var val = vals[i];
        if (val && (val === "*" || val.toLowerCase() === ns)) {
          return true;
        }
      }
      return false;
    }
    function convertDataDescriptorToAccessor(obj, prop, message) {
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      var value = descriptor.value;
      descriptor.get = function getter() {
        return value;
      };
      if (descriptor.writable) {
        descriptor.set = function setter(val) {
          return value = val;
        };
      }
      delete descriptor.value;
      delete descriptor.writable;
      Object.defineProperty(obj, prop, descriptor);
      return descriptor;
    }
    function createArgumentsString(arity) {
      var str = "";
      for (var i = 0; i < arity; i++) {
        str += ", arg" + i;
      }
      return str.substr(2);
    }
    function createStackString(stack) {
      var str = this.name + ": " + this.namespace;
      if (this.message) {
        str += " deprecated " + this.message;
      }
      for (var i = 0; i < stack.length; i++) {
        str += "\n    at " + stack[i].toString();
      }
      return str;
    }
    function depd(namespace) {
      if (!namespace) {
        throw new TypeError("argument namespace is required");
      }
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      var file = site[0];
      function deprecate(message) {
        log.call(deprecate, message);
      }
      deprecate._file = file;
      deprecate._ignored = isignored(namespace);
      deprecate._namespace = namespace;
      deprecate._traced = istraced(namespace);
      deprecate._warned = /* @__PURE__ */ Object.create(null);
      deprecate.function = wrapfunction;
      deprecate.property = wrapproperty;
      return deprecate;
    }
    function eehaslisteners(emitter, type) {
      var count = typeof emitter.listenerCount !== "function" ? emitter.listeners(type).length : emitter.listenerCount(type);
      return count > 0;
    }
    function isignored(namespace) {
      if (process.noDeprecation) {
        return true;
      }
      var str = process.env.NO_DEPRECATION || "";
      return containsNamespace(str, namespace);
    }
    function istraced(namespace) {
      if (process.traceDeprecation) {
        return true;
      }
      var str = process.env.TRACE_DEPRECATION || "";
      return containsNamespace(str, namespace);
    }
    function log(message, site) {
      var haslisteners = eehaslisteners(process, "deprecation");
      if (!haslisteners && this._ignored) {
        return;
      }
      var caller;
      var callFile;
      var callSite;
      var depSite;
      var i = 0;
      var seen = false;
      var stack = getStack();
      var file = this._file;
      if (site) {
        depSite = site;
        callSite = callSiteLocation(stack[1]);
        callSite.name = depSite.name;
        file = callSite[0];
      } else {
        i = 2;
        depSite = callSiteLocation(stack[i]);
        callSite = depSite;
      }
      for (; i < stack.length; i++) {
        caller = callSiteLocation(stack[i]);
        callFile = caller[0];
        if (callFile === file) {
          seen = true;
        } else if (callFile === this._file) {
          file = this._file;
        } else if (seen) {
          break;
        }
      }
      var key = caller ? depSite.join(":") + "__" + caller.join(":") : void 0;
      if (key !== void 0 && key in this._warned) {
        return;
      }
      this._warned[key] = true;
      var msg = message;
      if (!msg) {
        msg = callSite === depSite || !callSite.name ? defaultMessage(depSite) : defaultMessage(callSite);
      }
      if (haslisteners) {
        var err = DeprecationError(this._namespace, msg, stack.slice(i));
        process.emit("deprecation", err);
        return;
      }
      var format = process.stderr.isTTY ? formatColor : formatPlain;
      var output = format.call(this, msg, caller, stack.slice(i));
      process.stderr.write(output + "\n", "utf8");
    }
    function callSiteLocation(callSite) {
      var file = callSite.getFileName() || "<anonymous>";
      var line = callSite.getLineNumber();
      var colm = callSite.getColumnNumber();
      if (callSite.isEval()) {
        file = callSite.getEvalOrigin() + ", " + file;
      }
      var site = [file, line, colm];
      site.callSite = callSite;
      site.name = callSite.getFunctionName();
      return site;
    }
    function defaultMessage(site) {
      var callSite = site.callSite;
      var funcName = site.name;
      if (!funcName) {
        funcName = "<anonymous@" + formatLocation(site) + ">";
      }
      var context = callSite.getThis();
      var typeName = context && callSite.getTypeName();
      if (typeName === "Object") {
        typeName = void 0;
      }
      if (typeName === "Function") {
        typeName = context.name || typeName;
      }
      return typeName && callSite.getMethodName() ? typeName + "." + funcName : funcName;
    }
    function formatPlain(msg, caller, stack) {
      var timestamp = (/* @__PURE__ */ new Date()).toUTCString();
      var formatted = timestamp + " " + this._namespace + " deprecated " + msg;
      if (this._traced) {
        for (var i = 0; i < stack.length; i++) {
          formatted += "\n    at " + stack[i].toString();
        }
        return formatted;
      }
      if (caller) {
        formatted += " at " + formatLocation(caller);
      }
      return formatted;
    }
    function formatColor(msg, caller, stack) {
      var formatted = "\x1B[36;1m" + this._namespace + "\x1B[22;39m \x1B[33;1mdeprecated\x1B[22;39m \x1B[0m" + msg + "\x1B[39m";
      if (this._traced) {
        for (var i = 0; i < stack.length; i++) {
          formatted += "\n    \x1B[36mat " + stack[i].toString() + "\x1B[39m";
        }
        return formatted;
      }
      if (caller) {
        formatted += " \x1B[36m" + formatLocation(caller) + "\x1B[39m";
      }
      return formatted;
    }
    function formatLocation(callSite) {
      return relative(basePath, callSite[0]) + ":" + callSite[1] + ":" + callSite[2];
    }
    function getStack() {
      var limit = Error.stackTraceLimit;
      var obj = {};
      var prep = Error.prepareStackTrace;
      Error.prepareStackTrace = prepareObjectStackTrace;
      Error.stackTraceLimit = Math.max(10, limit);
      Error.captureStackTrace(obj);
      var stack = obj.stack.slice(1);
      Error.prepareStackTrace = prep;
      Error.stackTraceLimit = limit;
      return stack;
    }
    function prepareObjectStackTrace(obj, stack) {
      return stack;
    }
    function wrapfunction(fn, message) {
      if (typeof fn !== "function") {
        throw new TypeError("argument fn must be a function");
      }
      var args = createArgumentsString(fn.length);
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      site.name = fn.name;
      var deprecatedfn = new Function(
        "fn",
        "log",
        "deprecate",
        "message",
        "site",
        '"use strict"\nreturn function (' + args + ") {log.call(deprecate, message, site)\nreturn fn.apply(this, arguments)\n}"
      )(fn, log, this, message, site);
      return deprecatedfn;
    }
    function wrapproperty(obj, prop, message) {
      if (!obj || typeof obj !== "object" && typeof obj !== "function") {
        throw new TypeError("argument obj must be object");
      }
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      if (!descriptor) {
        throw new TypeError("must call property on owner object");
      }
      if (!descriptor.configurable) {
        throw new TypeError("property must be configurable");
      }
      var deprecate = this;
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      site.name = prop;
      if ("value" in descriptor) {
        descriptor = convertDataDescriptorToAccessor(obj, prop, message);
      }
      var get = descriptor.get;
      var set = descriptor.set;
      if (typeof get === "function") {
        descriptor.get = function getter() {
          log.call(deprecate, message, site);
          return get.apply(this, arguments);
        };
      }
      if (typeof set === "function") {
        descriptor.set = function setter() {
          log.call(deprecate, message, site);
          return set.apply(this, arguments);
        };
      }
      Object.defineProperty(obj, prop, descriptor);
    }
    function DeprecationError(namespace, message, stack) {
      var error = new Error();
      var stackString;
      Object.defineProperty(error, "constructor", {
        value: DeprecationError
      });
      Object.defineProperty(error, "message", {
        configurable: true,
        enumerable: false,
        value: message,
        writable: true
      });
      Object.defineProperty(error, "name", {
        enumerable: false,
        configurable: true,
        value: "DeprecationError",
        writable: true
      });
      Object.defineProperty(error, "namespace", {
        configurable: true,
        enumerable: false,
        value: namespace,
        writable: true
      });
      Object.defineProperty(error, "stack", {
        configurable: true,
        enumerable: false,
        get: function() {
          if (stackString !== void 0) {
            return stackString;
          }
          return stackString = createStackString.call(this, stack);
        },
        set: function setter(val) {
          stackString = val;
        }
      });
      return error;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/setprototypeof@1.2.0/node_modules/setprototypeof/index.js
var require_setprototypeof = __commonJS({
  "../../common/temp/node_modules/.pnpm/setprototypeof@1.2.0/node_modules/setprototypeof/index.js"(exports, module) {
    "use strict";
    module.exports = Object.setPrototypeOf || ({ __proto__: [] } instanceof Array ? setProtoOf : mixinProperties);
    function setProtoOf(obj, proto) {
      obj.__proto__ = proto;
      return obj;
    }
    function mixinProperties(obj, proto) {
      for (var prop in proto) {
        if (!Object.prototype.hasOwnProperty.call(obj, prop)) {
          obj[prop] = proto[prop];
        }
      }
      return obj;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/codes.json
var require_codes2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/codes.json"(exports, module) {
    module.exports = {
      "100": "Continue",
      "101": "Switching Protocols",
      "102": "Processing",
      "103": "Early Hints",
      "200": "OK",
      "201": "Created",
      "202": "Accepted",
      "203": "Non-Authoritative Information",
      "204": "No Content",
      "205": "Reset Content",
      "206": "Partial Content",
      "207": "Multi-Status",
      "208": "Already Reported",
      "226": "IM Used",
      "300": "Multiple Choices",
      "301": "Moved Permanently",
      "302": "Found",
      "303": "See Other",
      "304": "Not Modified",
      "305": "Use Proxy",
      "307": "Temporary Redirect",
      "308": "Permanent Redirect",
      "400": "Bad Request",
      "401": "Unauthorized",
      "402": "Payment Required",
      "403": "Forbidden",
      "404": "Not Found",
      "405": "Method Not Allowed",
      "406": "Not Acceptable",
      "407": "Proxy Authentication Required",
      "408": "Request Timeout",
      "409": "Conflict",
      "410": "Gone",
      "411": "Length Required",
      "412": "Precondition Failed",
      "413": "Payload Too Large",
      "414": "URI Too Long",
      "415": "Unsupported Media Type",
      "416": "Range Not Satisfiable",
      "417": "Expectation Failed",
      "418": "I'm a Teapot",
      "421": "Misdirected Request",
      "422": "Unprocessable Entity",
      "423": "Locked",
      "424": "Failed Dependency",
      "425": "Too Early",
      "426": "Upgrade Required",
      "428": "Precondition Required",
      "429": "Too Many Requests",
      "431": "Request Header Fields Too Large",
      "451": "Unavailable For Legal Reasons",
      "500": "Internal Server Error",
      "501": "Not Implemented",
      "502": "Bad Gateway",
      "503": "Service Unavailable",
      "504": "Gateway Timeout",
      "505": "HTTP Version Not Supported",
      "506": "Variant Also Negotiates",
      "507": "Insufficient Storage",
      "508": "Loop Detected",
      "509": "Bandwidth Limit Exceeded",
      "510": "Not Extended",
      "511": "Network Authentication Required"
    };
  }
});

// ../../common/temp/node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/index.js
var require_statuses2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/index.js"(exports, module) {
    "use strict";
    var codes = require_codes2();
    module.exports = status;
    status.message = codes;
    status.code = createMessageToStatusCodeMap(codes);
    status.codes = createStatusCodeList(codes);
    status.redirect = {
      300: true,
      301: true,
      302: true,
      303: true,
      305: true,
      307: true,
      308: true
    };
    status.empty = {
      204: true,
      205: true,
      304: true
    };
    status.retry = {
      502: true,
      503: true,
      504: true
    };
    function createMessageToStatusCodeMap(codes2) {
      var map = {};
      Object.keys(codes2).forEach(function forEachCode(code) {
        var message = codes2[code];
        var status2 = Number(code);
        map[message.toLowerCase()] = status2;
      });
      return map;
    }
    function createStatusCodeList(codes2) {
      return Object.keys(codes2).map(function mapCode(code) {
        return Number(code);
      });
    }
    function getStatusCode(message) {
      var msg = message.toLowerCase();
      if (!Object.prototype.hasOwnProperty.call(status.code, msg)) {
        throw new Error('invalid status message: "' + message + '"');
      }
      return status.code[msg];
    }
    function getStatusMessage(code) {
      if (!Object.prototype.hasOwnProperty.call(status.message, code)) {
        throw new Error("invalid status code: " + code);
      }
      return status.message[code];
    }
    function status(code) {
      if (typeof code === "number") {
        return getStatusMessage(code);
      }
      if (typeof code !== "string") {
        throw new TypeError("code must be a number or string");
      }
      var n = parseInt(code, 10);
      if (!isNaN(n)) {
        return getStatusMessage(n);
      }
      return getStatusCode(code);
    }
  }
});

// ../../common/temp/node_modules/.pnpm/inherits@2.0.4/node_modules/inherits/inherits_browser.js
var require_inherits_browser = __commonJS({
  "../../common/temp/node_modules/.pnpm/inherits@2.0.4/node_modules/inherits/inherits_browser.js"(exports, module) {
    if (typeof Object.create === "function") {
      module.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          ctor.prototype = Object.create(superCtor.prototype, {
            constructor: {
              value: ctor,
              enumerable: false,
              writable: true,
              configurable: true
            }
          });
        }
      };
    } else {
      module.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          var TempCtor = function() {
          };
          TempCtor.prototype = superCtor.prototype;
          ctor.prototype = new TempCtor();
          ctor.prototype.constructor = ctor;
        }
      };
    }
  }
});

// ../../common/temp/node_modules/.pnpm/inherits@2.0.4/node_modules/inherits/inherits.js
var require_inherits = __commonJS({
  "../../common/temp/node_modules/.pnpm/inherits@2.0.4/node_modules/inherits/inherits.js"(exports, module) {
    try {
      util = __require("util");
      if (typeof util.inherits !== "function")
        throw "";
      module.exports = util.inherits;
    } catch (e) {
      module.exports = require_inherits_browser();
    }
    var util;
  }
});

// ../../common/temp/node_modules/.pnpm/toidentifier@1.0.1/node_modules/toidentifier/index.js
var require_toidentifier = __commonJS({
  "../../common/temp/node_modules/.pnpm/toidentifier@1.0.1/node_modules/toidentifier/index.js"(exports, module) {
    "use strict";
    module.exports = toIdentifier;
    function toIdentifier(str) {
      return str.split(" ").map(function(token) {
        return token.slice(0, 1).toUpperCase() + token.slice(1);
      }).join("").replace(/[^ _0-9a-z]/gi, "");
    }
  }
});

// ../../common/temp/node_modules/.pnpm/http-errors@2.0.0/node_modules/http-errors/index.js
var require_http_errors = __commonJS({
  "../../common/temp/node_modules/.pnpm/http-errors@2.0.0/node_modules/http-errors/index.js"(exports, module) {
    "use strict";
    var deprecate = require_depd()("http-errors");
    var setPrototypeOf = require_setprototypeof();
    var statuses = require_statuses2();
    var inherits = require_inherits();
    var toIdentifier = require_toidentifier();
    module.exports = createError;
    module.exports.HttpError = createHttpErrorConstructor();
    module.exports.isHttpError = createIsHttpErrorFunction(module.exports.HttpError);
    populateConstructorExports(module.exports, statuses.codes, module.exports.HttpError);
    function codeClass(status) {
      return Number(String(status).charAt(0) + "00");
    }
    function createError() {
      var err;
      var msg;
      var status = 500;
      var props = {};
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        var type = typeof arg;
        if (type === "object" && arg instanceof Error) {
          err = arg;
          status = err.status || err.statusCode || status;
        } else if (type === "number" && i === 0) {
          status = arg;
        } else if (type === "string") {
          msg = arg;
        } else if (type === "object") {
          props = arg;
        } else {
          throw new TypeError("argument #" + (i + 1) + " unsupported type " + type);
        }
      }
      if (typeof status === "number" && (status < 400 || status >= 600)) {
        deprecate("non-error status code; use only 4xx or 5xx status codes");
      }
      if (typeof status !== "number" || !statuses.message[status] && (status < 400 || status >= 600)) {
        status = 500;
      }
      var HttpError = createError[status] || createError[codeClass(status)];
      if (!err) {
        err = HttpError ? new HttpError(msg) : new Error(msg || statuses.message[status]);
        Error.captureStackTrace(err, createError);
      }
      if (!HttpError || !(err instanceof HttpError) || err.status !== status) {
        err.expose = status < 500;
        err.status = err.statusCode = status;
      }
      for (var key in props) {
        if (key !== "status" && key !== "statusCode") {
          err[key] = props[key];
        }
      }
      return err;
    }
    function createHttpErrorConstructor() {
      function HttpError() {
        throw new TypeError("cannot construct abstract class");
      }
      inherits(HttpError, Error);
      return HttpError;
    }
    function createClientErrorConstructor(HttpError, name, code) {
      var className = toClassName(name);
      function ClientError(message) {
        var msg = message != null ? message : statuses.message[code];
        var err = new Error(msg);
        Error.captureStackTrace(err, ClientError);
        setPrototypeOf(err, ClientError.prototype);
        Object.defineProperty(err, "message", {
          enumerable: true,
          configurable: true,
          value: msg,
          writable: true
        });
        Object.defineProperty(err, "name", {
          enumerable: false,
          configurable: true,
          value: className,
          writable: true
        });
        return err;
      }
      inherits(ClientError, HttpError);
      nameFunc(ClientError, className);
      ClientError.prototype.status = code;
      ClientError.prototype.statusCode = code;
      ClientError.prototype.expose = true;
      return ClientError;
    }
    function createIsHttpErrorFunction(HttpError) {
      return function isHttpError(val) {
        if (!val || typeof val !== "object") {
          return false;
        }
        if (val instanceof HttpError) {
          return true;
        }
        return val instanceof Error && typeof val.expose === "boolean" && typeof val.statusCode === "number" && val.status === val.statusCode;
      };
    }
    function createServerErrorConstructor(HttpError, name, code) {
      var className = toClassName(name);
      function ServerError(message) {
        var msg = message != null ? message : statuses.message[code];
        var err = new Error(msg);
        Error.captureStackTrace(err, ServerError);
        setPrototypeOf(err, ServerError.prototype);
        Object.defineProperty(err, "message", {
          enumerable: true,
          configurable: true,
          value: msg,
          writable: true
        });
        Object.defineProperty(err, "name", {
          enumerable: false,
          configurable: true,
          value: className,
          writable: true
        });
        return err;
      }
      inherits(ServerError, HttpError);
      nameFunc(ServerError, className);
      ServerError.prototype.status = code;
      ServerError.prototype.statusCode = code;
      ServerError.prototype.expose = false;
      return ServerError;
    }
    function nameFunc(func, name) {
      var desc = Object.getOwnPropertyDescriptor(func, "name");
      if (desc && desc.configurable) {
        desc.value = name;
        Object.defineProperty(func, "name", desc);
      }
    }
    function populateConstructorExports(exports2, codes, HttpError) {
      codes.forEach(function forEachCode(code) {
        var CodeError;
        var name = toIdentifier(statuses.message[code]);
        switch (codeClass(code)) {
          case 400:
            CodeError = createClientErrorConstructor(HttpError, name, code);
            break;
          case 500:
            CodeError = createServerErrorConstructor(HttpError, name, code);
            break;
        }
        if (CodeError) {
          exports2[code] = CodeError;
          exports2[name] = CodeError;
        }
      });
    }
    function toClassName(name) {
      return name.substr(-5) !== "Error" ? name + "Error" : name;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/destroy@1.2.0/node_modules/destroy/index.js
var require_destroy = __commonJS({
  "../../common/temp/node_modules/.pnpm/destroy@1.2.0/node_modules/destroy/index.js"(exports, module) {
    "use strict";
    var EventEmitter = __require("events").EventEmitter;
    var ReadStream = __require("fs").ReadStream;
    var Stream = __require("stream");
    var Zlib = __require("zlib");
    module.exports = destroy;
    function destroy(stream, suppress) {
      if (isFsReadStream(stream)) {
        destroyReadStream(stream);
      } else if (isZlibStream(stream)) {
        destroyZlibStream(stream);
      } else if (hasDestroy(stream)) {
        stream.destroy();
      }
      if (isEventEmitter(stream) && suppress) {
        stream.removeAllListeners("error");
        stream.addListener("error", noop);
      }
      return stream;
    }
    function destroyReadStream(stream) {
      stream.destroy();
      if (typeof stream.close === "function") {
        stream.on("open", onOpenClose);
      }
    }
    function closeZlibStream(stream) {
      if (stream._hadError === true) {
        var prop = stream._binding === null ? "_binding" : "_handle";
        stream[prop] = {
          close: function() {
            this[prop] = null;
          }
        };
      }
      stream.close();
    }
    function destroyZlibStream(stream) {
      if (typeof stream.destroy === "function") {
        if (stream._binding) {
          stream.destroy();
          if (stream._processing) {
            stream._needDrain = true;
            stream.once("drain", onDrainClearBinding);
          } else {
            stream._binding.clear();
          }
        } else if (stream._destroy && stream._destroy !== Stream.Transform.prototype._destroy) {
          stream.destroy();
        } else if (stream._destroy && typeof stream.close === "function") {
          stream.destroyed = true;
          stream.close();
        } else {
          stream.destroy();
        }
      } else if (typeof stream.close === "function") {
        closeZlibStream(stream);
      }
    }
    function hasDestroy(stream) {
      return stream instanceof Stream && typeof stream.destroy === "function";
    }
    function isEventEmitter(val) {
      return val instanceof EventEmitter;
    }
    function isFsReadStream(stream) {
      return stream instanceof ReadStream;
    }
    function isZlibStream(stream) {
      return stream instanceof Zlib.Gzip || stream instanceof Zlib.Gunzip || stream instanceof Zlib.Deflate || stream instanceof Zlib.DeflateRaw || stream instanceof Zlib.Inflate || stream instanceof Zlib.InflateRaw || stream instanceof Zlib.Unzip;
    }
    function noop() {
    }
    function onDrainClearBinding() {
      this._binding.clear();
    }
    function onOpenClose() {
      if (typeof this.fd === "number") {
        this.close();
      }
    }
  }
});

// ../../common/temp/node_modules/.pnpm/etag@1.8.1/node_modules/etag/index.js
var require_etag = __commonJS({
  "../../common/temp/node_modules/.pnpm/etag@1.8.1/node_modules/etag/index.js"(exports, module) {
    "use strict";
    module.exports = etag;
    var crypto = __require("crypto");
    var Stats = __require("fs").Stats;
    var toString = Object.prototype.toString;
    function entitytag(entity) {
      if (entity.length === 0) {
        return '"0-2jmj7l5rSw0yVb/vlWAYkK/YBwk"';
      }
      var hash = crypto.createHash("sha1").update(entity, "utf8").digest("base64").substring(0, 27);
      var len = typeof entity === "string" ? Buffer.byteLength(entity, "utf8") : entity.length;
      return '"' + len.toString(16) + "-" + hash + '"';
    }
    function etag(entity, options) {
      if (entity == null) {
        throw new TypeError("argument entity is required");
      }
      var isStats = isstats(entity);
      var weak = options && typeof options.weak === "boolean" ? options.weak : isStats;
      if (!isStats && typeof entity !== "string" && !Buffer.isBuffer(entity)) {
        throw new TypeError("argument entity must be string, Buffer, or fs.Stats");
      }
      var tag = isStats ? stattag(entity) : entitytag(entity);
      return weak ? "W/" + tag : tag;
    }
    function isstats(obj) {
      if (typeof Stats === "function" && obj instanceof Stats) {
        return true;
      }
      return obj && typeof obj === "object" && "ctime" in obj && toString.call(obj.ctime) === "[object Date]" && "mtime" in obj && toString.call(obj.mtime) === "[object Date]" && "ino" in obj && typeof obj.ino === "number" && "size" in obj && typeof obj.size === "number";
    }
    function stattag(stat) {
      var mtime = stat.mtime.getTime().toString(16);
      var size = stat.size.toString(16);
      return '"' + size + "-" + mtime + '"';
    }
  }
});

// ../../common/temp/node_modules/.pnpm/fresh@0.5.2/node_modules/fresh/index.js
var require_fresh = __commonJS({
  "../../common/temp/node_modules/.pnpm/fresh@0.5.2/node_modules/fresh/index.js"(exports, module) {
    "use strict";
    var CACHE_CONTROL_NO_CACHE_REGEXP = /(?:^|,)\s*?no-cache\s*?(?:,|$)/;
    module.exports = fresh;
    function fresh(reqHeaders, resHeaders) {
      var modifiedSince = reqHeaders["if-modified-since"];
      var noneMatch = reqHeaders["if-none-match"];
      if (!modifiedSince && !noneMatch) {
        return false;
      }
      var cacheControl = reqHeaders["cache-control"];
      if (cacheControl && CACHE_CONTROL_NO_CACHE_REGEXP.test(cacheControl)) {
        return false;
      }
      if (noneMatch && noneMatch !== "*") {
        var etag = resHeaders["etag"];
        if (!etag) {
          return false;
        }
        var etagStale = true;
        var matches = parseTokenList(noneMatch);
        for (var i = 0; i < matches.length; i++) {
          var match = matches[i];
          if (match === etag || match === "W/" + etag || "W/" + match === etag) {
            etagStale = false;
            break;
          }
        }
        if (etagStale) {
          return false;
        }
      }
      if (modifiedSince) {
        var lastModified = resHeaders["last-modified"];
        var modifiedStale = !lastModified || !(parseHttpDate(lastModified) <= parseHttpDate(modifiedSince));
        if (modifiedStale) {
          return false;
        }
      }
      return true;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp === "number" ? timestamp : NaN;
    }
    function parseTokenList(str) {
      var end = 0;
      var list = [];
      var start = 0;
      for (var i = 0, len = str.length; i < len; i++) {
        switch (str.charCodeAt(i)) {
          case 32:
            if (start === end) {
              start = end = i + 1;
            }
            break;
          case 44:
            list.push(str.substring(start, end));
            start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      }
      list.push(str.substring(start, end));
      return list;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/mime@1.6.0/node_modules/mime/types.json
var require_types = __commonJS({
  "../../common/temp/node_modules/.pnpm/mime@1.6.0/node_modules/mime/types.json"(exports, module) {
    module.exports = { "application/andrew-inset": ["ez"], "application/applixware": ["aw"], "application/atom+xml": ["atom"], "application/atomcat+xml": ["atomcat"], "application/atomsvc+xml": ["atomsvc"], "application/bdoc": ["bdoc"], "application/ccxml+xml": ["ccxml"], "application/cdmi-capability": ["cdmia"], "application/cdmi-container": ["cdmic"], "application/cdmi-domain": ["cdmid"], "application/cdmi-object": ["cdmio"], "application/cdmi-queue": ["cdmiq"], "application/cu-seeme": ["cu"], "application/dash+xml": ["mpd"], "application/davmount+xml": ["davmount"], "application/docbook+xml": ["dbk"], "application/dssc+der": ["dssc"], "application/dssc+xml": ["xdssc"], "application/ecmascript": ["ecma"], "application/emma+xml": ["emma"], "application/epub+zip": ["epub"], "application/exi": ["exi"], "application/font-tdpfr": ["pfr"], "application/font-woff": [], "application/font-woff2": [], "application/geo+json": ["geojson"], "application/gml+xml": ["gml"], "application/gpx+xml": ["gpx"], "application/gxf": ["gxf"], "application/gzip": ["gz"], "application/hyperstudio": ["stk"], "application/inkml+xml": ["ink", "inkml"], "application/ipfix": ["ipfix"], "application/java-archive": ["jar", "war", "ear"], "application/java-serialized-object": ["ser"], "application/java-vm": ["class"], "application/javascript": ["js", "mjs"], "application/json": ["json", "map"], "application/json5": ["json5"], "application/jsonml+json": ["jsonml"], "application/ld+json": ["jsonld"], "application/lost+xml": ["lostxml"], "application/mac-binhex40": ["hqx"], "application/mac-compactpro": ["cpt"], "application/mads+xml": ["mads"], "application/manifest+json": ["webmanifest"], "application/marc": ["mrc"], "application/marcxml+xml": ["mrcx"], "application/mathematica": ["ma", "nb", "mb"], "application/mathml+xml": ["mathml"], "application/mbox": ["mbox"], "application/mediaservercontrol+xml": ["mscml"], "application/metalink+xml": ["metalink"], "application/metalink4+xml": ["meta4"], "application/mets+xml": ["mets"], "application/mods+xml": ["mods"], "application/mp21": ["m21", "mp21"], "application/mp4": ["mp4s", "m4p"], "application/msword": ["doc", "dot"], "application/mxf": ["mxf"], "application/octet-stream": ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"], "application/oda": ["oda"], "application/oebps-package+xml": ["opf"], "application/ogg": ["ogx"], "application/omdoc+xml": ["omdoc"], "application/onenote": ["onetoc", "onetoc2", "onetmp", "onepkg"], "application/oxps": ["oxps"], "application/patch-ops-error+xml": ["xer"], "application/pdf": ["pdf"], "application/pgp-encrypted": ["pgp"], "application/pgp-signature": ["asc", "sig"], "application/pics-rules": ["prf"], "application/pkcs10": ["p10"], "application/pkcs7-mime": ["p7m", "p7c"], "application/pkcs7-signature": ["p7s"], "application/pkcs8": ["p8"], "application/pkix-attr-cert": ["ac"], "application/pkix-cert": ["cer"], "application/pkix-crl": ["crl"], "application/pkix-pkipath": ["pkipath"], "application/pkixcmp": ["pki"], "application/pls+xml": ["pls"], "application/postscript": ["ai", "eps", "ps"], "application/prs.cww": ["cww"], "application/pskc+xml": ["pskcxml"], "application/raml+yaml": ["raml"], "application/rdf+xml": ["rdf"], "application/reginfo+xml": ["rif"], "application/relax-ng-compact-syntax": ["rnc"], "application/resource-lists+xml": ["rl"], "application/resource-lists-diff+xml": ["rld"], "application/rls-services+xml": ["rs"], "application/rpki-ghostbusters": ["gbr"], "application/rpki-manifest": ["mft"], "application/rpki-roa": ["roa"], "application/rsd+xml": ["rsd"], "application/rss+xml": ["rss"], "application/rtf": ["rtf"], "application/sbml+xml": ["sbml"], "application/scvp-cv-request": ["scq"], "application/scvp-cv-response": ["scs"], "application/scvp-vp-request": ["spq"], "application/scvp-vp-response": ["spp"], "application/sdp": ["sdp"], "application/set-payment-initiation": ["setpay"], "application/set-registration-initiation": ["setreg"], "application/shf+xml": ["shf"], "application/smil+xml": ["smi", "smil"], "application/sparql-query": ["rq"], "application/sparql-results+xml": ["srx"], "application/srgs": ["gram"], "application/srgs+xml": ["grxml"], "application/sru+xml": ["sru"], "application/ssdl+xml": ["ssdl"], "application/ssml+xml": ["ssml"], "application/tei+xml": ["tei", "teicorpus"], "application/thraud+xml": ["tfi"], "application/timestamped-data": ["tsd"], "application/vnd.3gpp.pic-bw-large": ["plb"], "application/vnd.3gpp.pic-bw-small": ["psb"], "application/vnd.3gpp.pic-bw-var": ["pvb"], "application/vnd.3gpp2.tcap": ["tcap"], "application/vnd.3m.post-it-notes": ["pwn"], "application/vnd.accpac.simply.aso": ["aso"], "application/vnd.accpac.simply.imp": ["imp"], "application/vnd.acucobol": ["acu"], "application/vnd.acucorp": ["atc", "acutc"], "application/vnd.adobe.air-application-installer-package+zip": ["air"], "application/vnd.adobe.formscentral.fcdt": ["fcdt"], "application/vnd.adobe.fxp": ["fxp", "fxpl"], "application/vnd.adobe.xdp+xml": ["xdp"], "application/vnd.adobe.xfdf": ["xfdf"], "application/vnd.ahead.space": ["ahead"], "application/vnd.airzip.filesecure.azf": ["azf"], "application/vnd.airzip.filesecure.azs": ["azs"], "application/vnd.amazon.ebook": ["azw"], "application/vnd.americandynamics.acc": ["acc"], "application/vnd.amiga.ami": ["ami"], "application/vnd.android.package-archive": ["apk"], "application/vnd.anser-web-certificate-issue-initiation": ["cii"], "application/vnd.anser-web-funds-transfer-initiation": ["fti"], "application/vnd.antix.game-component": ["atx"], "application/vnd.apple.installer+xml": ["mpkg"], "application/vnd.apple.mpegurl": ["m3u8"], "application/vnd.apple.pkpass": ["pkpass"], "application/vnd.aristanetworks.swi": ["swi"], "application/vnd.astraea-software.iota": ["iota"], "application/vnd.audiograph": ["aep"], "application/vnd.blueice.multipass": ["mpm"], "application/vnd.bmi": ["bmi"], "application/vnd.businessobjects": ["rep"], "application/vnd.chemdraw+xml": ["cdxml"], "application/vnd.chipnuts.karaoke-mmd": ["mmd"], "application/vnd.cinderella": ["cdy"], "application/vnd.claymore": ["cla"], "application/vnd.cloanto.rp9": ["rp9"], "application/vnd.clonk.c4group": ["c4g", "c4d", "c4f", "c4p", "c4u"], "application/vnd.cluetrust.cartomobile-config": ["c11amc"], "application/vnd.cluetrust.cartomobile-config-pkg": ["c11amz"], "application/vnd.commonspace": ["csp"], "application/vnd.contact.cmsg": ["cdbcmsg"], "application/vnd.cosmocaller": ["cmc"], "application/vnd.crick.clicker": ["clkx"], "application/vnd.crick.clicker.keyboard": ["clkk"], "application/vnd.crick.clicker.palette": ["clkp"], "application/vnd.crick.clicker.template": ["clkt"], "application/vnd.crick.clicker.wordbank": ["clkw"], "application/vnd.criticaltools.wbs+xml": ["wbs"], "application/vnd.ctc-posml": ["pml"], "application/vnd.cups-ppd": ["ppd"], "application/vnd.curl.car": ["car"], "application/vnd.curl.pcurl": ["pcurl"], "application/vnd.dart": ["dart"], "application/vnd.data-vision.rdz": ["rdz"], "application/vnd.dece.data": ["uvf", "uvvf", "uvd", "uvvd"], "application/vnd.dece.ttml+xml": ["uvt", "uvvt"], "application/vnd.dece.unspecified": ["uvx", "uvvx"], "application/vnd.dece.zip": ["uvz", "uvvz"], "application/vnd.denovo.fcselayout-link": ["fe_launch"], "application/vnd.dna": ["dna"], "application/vnd.dolby.mlp": ["mlp"], "application/vnd.dpgraph": ["dpg"], "application/vnd.dreamfactory": ["dfac"], "application/vnd.ds-keypoint": ["kpxx"], "application/vnd.dvb.ait": ["ait"], "application/vnd.dvb.service": ["svc"], "application/vnd.dynageo": ["geo"], "application/vnd.ecowin.chart": ["mag"], "application/vnd.enliven": ["nml"], "application/vnd.epson.esf": ["esf"], "application/vnd.epson.msf": ["msf"], "application/vnd.epson.quickanime": ["qam"], "application/vnd.epson.salt": ["slt"], "application/vnd.epson.ssf": ["ssf"], "application/vnd.eszigno3+xml": ["es3", "et3"], "application/vnd.ezpix-album": ["ez2"], "application/vnd.ezpix-package": ["ez3"], "application/vnd.fdf": ["fdf"], "application/vnd.fdsn.mseed": ["mseed"], "application/vnd.fdsn.seed": ["seed", "dataless"], "application/vnd.flographit": ["gph"], "application/vnd.fluxtime.clip": ["ftc"], "application/vnd.framemaker": ["fm", "frame", "maker", "book"], "application/vnd.frogans.fnc": ["fnc"], "application/vnd.frogans.ltf": ["ltf"], "application/vnd.fsc.weblaunch": ["fsc"], "application/vnd.fujitsu.oasys": ["oas"], "application/vnd.fujitsu.oasys2": ["oa2"], "application/vnd.fujitsu.oasys3": ["oa3"], "application/vnd.fujitsu.oasysgp": ["fg5"], "application/vnd.fujitsu.oasysprs": ["bh2"], "application/vnd.fujixerox.ddd": ["ddd"], "application/vnd.fujixerox.docuworks": ["xdw"], "application/vnd.fujixerox.docuworks.binder": ["xbd"], "application/vnd.fuzzysheet": ["fzs"], "application/vnd.genomatix.tuxedo": ["txd"], "application/vnd.geogebra.file": ["ggb"], "application/vnd.geogebra.tool": ["ggt"], "application/vnd.geometry-explorer": ["gex", "gre"], "application/vnd.geonext": ["gxt"], "application/vnd.geoplan": ["g2w"], "application/vnd.geospace": ["g3w"], "application/vnd.gmx": ["gmx"], "application/vnd.google-apps.document": ["gdoc"], "application/vnd.google-apps.presentation": ["gslides"], "application/vnd.google-apps.spreadsheet": ["gsheet"], "application/vnd.google-earth.kml+xml": ["kml"], "application/vnd.google-earth.kmz": ["kmz"], "application/vnd.grafeq": ["gqf", "gqs"], "application/vnd.groove-account": ["gac"], "application/vnd.groove-help": ["ghf"], "application/vnd.groove-identity-message": ["gim"], "application/vnd.groove-injector": ["grv"], "application/vnd.groove-tool-message": ["gtm"], "application/vnd.groove-tool-template": ["tpl"], "application/vnd.groove-vcard": ["vcg"], "application/vnd.hal+xml": ["hal"], "application/vnd.handheld-entertainment+xml": ["zmm"], "application/vnd.hbci": ["hbci"], "application/vnd.hhe.lesson-player": ["les"], "application/vnd.hp-hpgl": ["hpgl"], "application/vnd.hp-hpid": ["hpid"], "application/vnd.hp-hps": ["hps"], "application/vnd.hp-jlyt": ["jlt"], "application/vnd.hp-pcl": ["pcl"], "application/vnd.hp-pclxl": ["pclxl"], "application/vnd.hydrostatix.sof-data": ["sfd-hdstx"], "application/vnd.ibm.minipay": ["mpy"], "application/vnd.ibm.modcap": ["afp", "listafp", "list3820"], "application/vnd.ibm.rights-management": ["irm"], "application/vnd.ibm.secure-container": ["sc"], "application/vnd.iccprofile": ["icc", "icm"], "application/vnd.igloader": ["igl"], "application/vnd.immervision-ivp": ["ivp"], "application/vnd.immervision-ivu": ["ivu"], "application/vnd.insors.igm": ["igm"], "application/vnd.intercon.formnet": ["xpw", "xpx"], "application/vnd.intergeo": ["i2g"], "application/vnd.intu.qbo": ["qbo"], "application/vnd.intu.qfx": ["qfx"], "application/vnd.ipunplugged.rcprofile": ["rcprofile"], "application/vnd.irepository.package+xml": ["irp"], "application/vnd.is-xpr": ["xpr"], "application/vnd.isac.fcs": ["fcs"], "application/vnd.jam": ["jam"], "application/vnd.jcp.javame.midlet-rms": ["rms"], "application/vnd.jisp": ["jisp"], "application/vnd.joost.joda-archive": ["joda"], "application/vnd.kahootz": ["ktz", "ktr"], "application/vnd.kde.karbon": ["karbon"], "application/vnd.kde.kchart": ["chrt"], "application/vnd.kde.kformula": ["kfo"], "application/vnd.kde.kivio": ["flw"], "application/vnd.kde.kontour": ["kon"], "application/vnd.kde.kpresenter": ["kpr", "kpt"], "application/vnd.kde.kspread": ["ksp"], "application/vnd.kde.kword": ["kwd", "kwt"], "application/vnd.kenameaapp": ["htke"], "application/vnd.kidspiration": ["kia"], "application/vnd.kinar": ["kne", "knp"], "application/vnd.koan": ["skp", "skd", "skt", "skm"], "application/vnd.kodak-descriptor": ["sse"], "application/vnd.las.las+xml": ["lasxml"], "application/vnd.llamagraphics.life-balance.desktop": ["lbd"], "application/vnd.llamagraphics.life-balance.exchange+xml": ["lbe"], "application/vnd.lotus-1-2-3": ["123"], "application/vnd.lotus-approach": ["apr"], "application/vnd.lotus-freelance": ["pre"], "application/vnd.lotus-notes": ["nsf"], "application/vnd.lotus-organizer": ["org"], "application/vnd.lotus-screencam": ["scm"], "application/vnd.lotus-wordpro": ["lwp"], "application/vnd.macports.portpkg": ["portpkg"], "application/vnd.mcd": ["mcd"], "application/vnd.medcalcdata": ["mc1"], "application/vnd.mediastation.cdkey": ["cdkey"], "application/vnd.mfer": ["mwf"], "application/vnd.mfmp": ["mfm"], "application/vnd.micrografx.flo": ["flo"], "application/vnd.micrografx.igx": ["igx"], "application/vnd.mif": ["mif"], "application/vnd.mobius.daf": ["daf"], "application/vnd.mobius.dis": ["dis"], "application/vnd.mobius.mbk": ["mbk"], "application/vnd.mobius.mqy": ["mqy"], "application/vnd.mobius.msl": ["msl"], "application/vnd.mobius.plc": ["plc"], "application/vnd.mobius.txf": ["txf"], "application/vnd.mophun.application": ["mpn"], "application/vnd.mophun.certificate": ["mpc"], "application/vnd.mozilla.xul+xml": ["xul"], "application/vnd.ms-artgalry": ["cil"], "application/vnd.ms-cab-compressed": ["cab"], "application/vnd.ms-excel": ["xls", "xlm", "xla", "xlc", "xlt", "xlw"], "application/vnd.ms-excel.addin.macroenabled.12": ["xlam"], "application/vnd.ms-excel.sheet.binary.macroenabled.12": ["xlsb"], "application/vnd.ms-excel.sheet.macroenabled.12": ["xlsm"], "application/vnd.ms-excel.template.macroenabled.12": ["xltm"], "application/vnd.ms-fontobject": ["eot"], "application/vnd.ms-htmlhelp": ["chm"], "application/vnd.ms-ims": ["ims"], "application/vnd.ms-lrm": ["lrm"], "application/vnd.ms-officetheme": ["thmx"], "application/vnd.ms-outlook": ["msg"], "application/vnd.ms-pki.seccat": ["cat"], "application/vnd.ms-pki.stl": ["stl"], "application/vnd.ms-powerpoint": ["ppt", "pps", "pot"], "application/vnd.ms-powerpoint.addin.macroenabled.12": ["ppam"], "application/vnd.ms-powerpoint.presentation.macroenabled.12": ["pptm"], "application/vnd.ms-powerpoint.slide.macroenabled.12": ["sldm"], "application/vnd.ms-powerpoint.slideshow.macroenabled.12": ["ppsm"], "application/vnd.ms-powerpoint.template.macroenabled.12": ["potm"], "application/vnd.ms-project": ["mpp", "mpt"], "application/vnd.ms-word.document.macroenabled.12": ["docm"], "application/vnd.ms-word.template.macroenabled.12": ["dotm"], "application/vnd.ms-works": ["wps", "wks", "wcm", "wdb"], "application/vnd.ms-wpl": ["wpl"], "application/vnd.ms-xpsdocument": ["xps"], "application/vnd.mseq": ["mseq"], "application/vnd.musician": ["mus"], "application/vnd.muvee.style": ["msty"], "application/vnd.mynfc": ["taglet"], "application/vnd.neurolanguage.nlu": ["nlu"], "application/vnd.nitf": ["ntf", "nitf"], "application/vnd.noblenet-directory": ["nnd"], "application/vnd.noblenet-sealer": ["nns"], "application/vnd.noblenet-web": ["nnw"], "application/vnd.nokia.n-gage.data": ["ngdat"], "application/vnd.nokia.n-gage.symbian.install": ["n-gage"], "application/vnd.nokia.radio-preset": ["rpst"], "application/vnd.nokia.radio-presets": ["rpss"], "application/vnd.novadigm.edm": ["edm"], "application/vnd.novadigm.edx": ["edx"], "application/vnd.novadigm.ext": ["ext"], "application/vnd.oasis.opendocument.chart": ["odc"], "application/vnd.oasis.opendocument.chart-template": ["otc"], "application/vnd.oasis.opendocument.database": ["odb"], "application/vnd.oasis.opendocument.formula": ["odf"], "application/vnd.oasis.opendocument.formula-template": ["odft"], "application/vnd.oasis.opendocument.graphics": ["odg"], "application/vnd.oasis.opendocument.graphics-template": ["otg"], "application/vnd.oasis.opendocument.image": ["odi"], "application/vnd.oasis.opendocument.image-template": ["oti"], "application/vnd.oasis.opendocument.presentation": ["odp"], "application/vnd.oasis.opendocument.presentation-template": ["otp"], "application/vnd.oasis.opendocument.spreadsheet": ["ods"], "application/vnd.oasis.opendocument.spreadsheet-template": ["ots"], "application/vnd.oasis.opendocument.text": ["odt"], "application/vnd.oasis.opendocument.text-master": ["odm"], "application/vnd.oasis.opendocument.text-template": ["ott"], "application/vnd.oasis.opendocument.text-web": ["oth"], "application/vnd.olpc-sugar": ["xo"], "application/vnd.oma.dd2+xml": ["dd2"], "application/vnd.openofficeorg.extension": ["oxt"], "application/vnd.openxmlformats-officedocument.presentationml.presentation": ["pptx"], "application/vnd.openxmlformats-officedocument.presentationml.slide": ["sldx"], "application/vnd.openxmlformats-officedocument.presentationml.slideshow": ["ppsx"], "application/vnd.openxmlformats-officedocument.presentationml.template": ["potx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": ["xlsx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.template": ["xltx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.document": ["docx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.template": ["dotx"], "application/vnd.osgeo.mapguide.package": ["mgp"], "application/vnd.osgi.dp": ["dp"], "application/vnd.osgi.subsystem": ["esa"], "application/vnd.palm": ["pdb", "pqa", "oprc"], "application/vnd.pawaafile": ["paw"], "application/vnd.pg.format": ["str"], "application/vnd.pg.osasli": ["ei6"], "application/vnd.picsel": ["efif"], "application/vnd.pmi.widget": ["wg"], "application/vnd.pocketlearn": ["plf"], "application/vnd.powerbuilder6": ["pbd"], "application/vnd.previewsystems.box": ["box"], "application/vnd.proteus.magazine": ["mgz"], "application/vnd.publishare-delta-tree": ["qps"], "application/vnd.pvi.ptid1": ["ptid"], "application/vnd.quark.quarkxpress": ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"], "application/vnd.realvnc.bed": ["bed"], "application/vnd.recordare.musicxml": ["mxl"], "application/vnd.recordare.musicxml+xml": ["musicxml"], "application/vnd.rig.cryptonote": ["cryptonote"], "application/vnd.rim.cod": ["cod"], "application/vnd.rn-realmedia": ["rm"], "application/vnd.rn-realmedia-vbr": ["rmvb"], "application/vnd.route66.link66+xml": ["link66"], "application/vnd.sailingtracker.track": ["st"], "application/vnd.seemail": ["see"], "application/vnd.sema": ["sema"], "application/vnd.semd": ["semd"], "application/vnd.semf": ["semf"], "application/vnd.shana.informed.formdata": ["ifm"], "application/vnd.shana.informed.formtemplate": ["itp"], "application/vnd.shana.informed.interchange": ["iif"], "application/vnd.shana.informed.package": ["ipk"], "application/vnd.simtech-mindmapper": ["twd", "twds"], "application/vnd.smaf": ["mmf"], "application/vnd.smart.teacher": ["teacher"], "application/vnd.solent.sdkm+xml": ["sdkm", "sdkd"], "application/vnd.spotfire.dxp": ["dxp"], "application/vnd.spotfire.sfs": ["sfs"], "application/vnd.stardivision.calc": ["sdc"], "application/vnd.stardivision.draw": ["sda"], "application/vnd.stardivision.impress": ["sdd"], "application/vnd.stardivision.math": ["smf"], "application/vnd.stardivision.writer": ["sdw", "vor"], "application/vnd.stardivision.writer-global": ["sgl"], "application/vnd.stepmania.package": ["smzip"], "application/vnd.stepmania.stepchart": ["sm"], "application/vnd.sun.wadl+xml": ["wadl"], "application/vnd.sun.xml.calc": ["sxc"], "application/vnd.sun.xml.calc.template": ["stc"], "application/vnd.sun.xml.draw": ["sxd"], "application/vnd.sun.xml.draw.template": ["std"], "application/vnd.sun.xml.impress": ["sxi"], "application/vnd.sun.xml.impress.template": ["sti"], "application/vnd.sun.xml.math": ["sxm"], "application/vnd.sun.xml.writer": ["sxw"], "application/vnd.sun.xml.writer.global": ["sxg"], "application/vnd.sun.xml.writer.template": ["stw"], "application/vnd.sus-calendar": ["sus", "susp"], "application/vnd.svd": ["svd"], "application/vnd.symbian.install": ["sis", "sisx"], "application/vnd.syncml+xml": ["xsm"], "application/vnd.syncml.dm+wbxml": ["bdm"], "application/vnd.syncml.dm+xml": ["xdm"], "application/vnd.tao.intent-module-archive": ["tao"], "application/vnd.tcpdump.pcap": ["pcap", "cap", "dmp"], "application/vnd.tmobile-livetv": ["tmo"], "application/vnd.trid.tpt": ["tpt"], "application/vnd.triscape.mxs": ["mxs"], "application/vnd.trueapp": ["tra"], "application/vnd.ufdl": ["ufd", "ufdl"], "application/vnd.uiq.theme": ["utz"], "application/vnd.umajin": ["umj"], "application/vnd.unity": ["unityweb"], "application/vnd.uoml+xml": ["uoml"], "application/vnd.vcx": ["vcx"], "application/vnd.visio": ["vsd", "vst", "vss", "vsw"], "application/vnd.visionary": ["vis"], "application/vnd.vsf": ["vsf"], "application/vnd.wap.wbxml": ["wbxml"], "application/vnd.wap.wmlc": ["wmlc"], "application/vnd.wap.wmlscriptc": ["wmlsc"], "application/vnd.webturbo": ["wtb"], "application/vnd.wolfram.player": ["nbp"], "application/vnd.wordperfect": ["wpd"], "application/vnd.wqd": ["wqd"], "application/vnd.wt.stf": ["stf"], "application/vnd.xara": ["xar"], "application/vnd.xfdl": ["xfdl"], "application/vnd.yamaha.hv-dic": ["hvd"], "application/vnd.yamaha.hv-script": ["hvs"], "application/vnd.yamaha.hv-voice": ["hvp"], "application/vnd.yamaha.openscoreformat": ["osf"], "application/vnd.yamaha.openscoreformat.osfpvg+xml": ["osfpvg"], "application/vnd.yamaha.smaf-audio": ["saf"], "application/vnd.yamaha.smaf-phrase": ["spf"], "application/vnd.yellowriver-custom-menu": ["cmp"], "application/vnd.zul": ["zir", "zirz"], "application/vnd.zzazz.deck+xml": ["zaz"], "application/voicexml+xml": ["vxml"], "application/wasm": ["wasm"], "application/widget": ["wgt"], "application/winhlp": ["hlp"], "application/wsdl+xml": ["wsdl"], "application/wspolicy+xml": ["wspolicy"], "application/x-7z-compressed": ["7z"], "application/x-abiword": ["abw"], "application/x-ace-compressed": ["ace"], "application/x-apple-diskimage": [], "application/x-arj": ["arj"], "application/x-authorware-bin": ["aab", "x32", "u32", "vox"], "application/x-authorware-map": ["aam"], "application/x-authorware-seg": ["aas"], "application/x-bcpio": ["bcpio"], "application/x-bdoc": [], "application/x-bittorrent": ["torrent"], "application/x-blorb": ["blb", "blorb"], "application/x-bzip": ["bz"], "application/x-bzip2": ["bz2", "boz"], "application/x-cbr": ["cbr", "cba", "cbt", "cbz", "cb7"], "application/x-cdlink": ["vcd"], "application/x-cfs-compressed": ["cfs"], "application/x-chat": ["chat"], "application/x-chess-pgn": ["pgn"], "application/x-chrome-extension": ["crx"], "application/x-cocoa": ["cco"], "application/x-conference": ["nsc"], "application/x-cpio": ["cpio"], "application/x-csh": ["csh"], "application/x-debian-package": ["udeb"], "application/x-dgc-compressed": ["dgc"], "application/x-director": ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"], "application/x-doom": ["wad"], "application/x-dtbncx+xml": ["ncx"], "application/x-dtbook+xml": ["dtb"], "application/x-dtbresource+xml": ["res"], "application/x-dvi": ["dvi"], "application/x-envoy": ["evy"], "application/x-eva": ["eva"], "application/x-font-bdf": ["bdf"], "application/x-font-ghostscript": ["gsf"], "application/x-font-linux-psf": ["psf"], "application/x-font-pcf": ["pcf"], "application/x-font-snf": ["snf"], "application/x-font-type1": ["pfa", "pfb", "pfm", "afm"], "application/x-freearc": ["arc"], "application/x-futuresplash": ["spl"], "application/x-gca-compressed": ["gca"], "application/x-glulx": ["ulx"], "application/x-gnumeric": ["gnumeric"], "application/x-gramps-xml": ["gramps"], "application/x-gtar": ["gtar"], "application/x-hdf": ["hdf"], "application/x-httpd-php": ["php"], "application/x-install-instructions": ["install"], "application/x-iso9660-image": [], "application/x-java-archive-diff": ["jardiff"], "application/x-java-jnlp-file": ["jnlp"], "application/x-latex": ["latex"], "application/x-lua-bytecode": ["luac"], "application/x-lzh-compressed": ["lzh", "lha"], "application/x-makeself": ["run"], "application/x-mie": ["mie"], "application/x-mobipocket-ebook": ["prc", "mobi"], "application/x-ms-application": ["application"], "application/x-ms-shortcut": ["lnk"], "application/x-ms-wmd": ["wmd"], "application/x-ms-wmz": ["wmz"], "application/x-ms-xbap": ["xbap"], "application/x-msaccess": ["mdb"], "application/x-msbinder": ["obd"], "application/x-mscardfile": ["crd"], "application/x-msclip": ["clp"], "application/x-msdos-program": [], "application/x-msdownload": ["com", "bat"], "application/x-msmediaview": ["mvb", "m13", "m14"], "application/x-msmetafile": ["wmf", "emf", "emz"], "application/x-msmoney": ["mny"], "application/x-mspublisher": ["pub"], "application/x-msschedule": ["scd"], "application/x-msterminal": ["trm"], "application/x-mswrite": ["wri"], "application/x-netcdf": ["nc", "cdf"], "application/x-ns-proxy-autoconfig": ["pac"], "application/x-nzb": ["nzb"], "application/x-perl": ["pl", "pm"], "application/x-pilot": [], "application/x-pkcs12": ["p12", "pfx"], "application/x-pkcs7-certificates": ["p7b", "spc"], "application/x-pkcs7-certreqresp": ["p7r"], "application/x-rar-compressed": ["rar"], "application/x-redhat-package-manager": ["rpm"], "application/x-research-info-systems": ["ris"], "application/x-sea": ["sea"], "application/x-sh": ["sh"], "application/x-shar": ["shar"], "application/x-shockwave-flash": ["swf"], "application/x-silverlight-app": ["xap"], "application/x-sql": ["sql"], "application/x-stuffit": ["sit"], "application/x-stuffitx": ["sitx"], "application/x-subrip": ["srt"], "application/x-sv4cpio": ["sv4cpio"], "application/x-sv4crc": ["sv4crc"], "application/x-t3vm-image": ["t3"], "application/x-tads": ["gam"], "application/x-tar": ["tar"], "application/x-tcl": ["tcl", "tk"], "application/x-tex": ["tex"], "application/x-tex-tfm": ["tfm"], "application/x-texinfo": ["texinfo", "texi"], "application/x-tgif": ["obj"], "application/x-ustar": ["ustar"], "application/x-virtualbox-hdd": ["hdd"], "application/x-virtualbox-ova": ["ova"], "application/x-virtualbox-ovf": ["ovf"], "application/x-virtualbox-vbox": ["vbox"], "application/x-virtualbox-vbox-extpack": ["vbox-extpack"], "application/x-virtualbox-vdi": ["vdi"], "application/x-virtualbox-vhd": ["vhd"], "application/x-virtualbox-vmdk": ["vmdk"], "application/x-wais-source": ["src"], "application/x-web-app-manifest+json": ["webapp"], "application/x-x509-ca-cert": ["der", "crt", "pem"], "application/x-xfig": ["fig"], "application/x-xliff+xml": ["xlf"], "application/x-xpinstall": ["xpi"], "application/x-xz": ["xz"], "application/x-zmachine": ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"], "application/xaml+xml": ["xaml"], "application/xcap-diff+xml": ["xdf"], "application/xenc+xml": ["xenc"], "application/xhtml+xml": ["xhtml", "xht"], "application/xml": ["xml", "xsl", "xsd", "rng"], "application/xml-dtd": ["dtd"], "application/xop+xml": ["xop"], "application/xproc+xml": ["xpl"], "application/xslt+xml": ["xslt"], "application/xspf+xml": ["xspf"], "application/xv+xml": ["mxml", "xhvml", "xvml", "xvm"], "application/yang": ["yang"], "application/yin+xml": ["yin"], "application/zip": ["zip"], "audio/3gpp": [], "audio/adpcm": ["adp"], "audio/basic": ["au", "snd"], "audio/midi": ["mid", "midi", "kar", "rmi"], "audio/mp3": [], "audio/mp4": ["m4a", "mp4a"], "audio/mpeg": ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"], "audio/ogg": ["oga", "ogg", "spx"], "audio/s3m": ["s3m"], "audio/silk": ["sil"], "audio/vnd.dece.audio": ["uva", "uvva"], "audio/vnd.digital-winds": ["eol"], "audio/vnd.dra": ["dra"], "audio/vnd.dts": ["dts"], "audio/vnd.dts.hd": ["dtshd"], "audio/vnd.lucent.voice": ["lvp"], "audio/vnd.ms-playready.media.pya": ["pya"], "audio/vnd.nuera.ecelp4800": ["ecelp4800"], "audio/vnd.nuera.ecelp7470": ["ecelp7470"], "audio/vnd.nuera.ecelp9600": ["ecelp9600"], "audio/vnd.rip": ["rip"], "audio/wav": ["wav"], "audio/wave": [], "audio/webm": ["weba"], "audio/x-aac": ["aac"], "audio/x-aiff": ["aif", "aiff", "aifc"], "audio/x-caf": ["caf"], "audio/x-flac": ["flac"], "audio/x-m4a": [], "audio/x-matroska": ["mka"], "audio/x-mpegurl": ["m3u"], "audio/x-ms-wax": ["wax"], "audio/x-ms-wma": ["wma"], "audio/x-pn-realaudio": ["ram", "ra"], "audio/x-pn-realaudio-plugin": ["rmp"], "audio/x-realaudio": [], "audio/x-wav": [], "audio/xm": ["xm"], "chemical/x-cdx": ["cdx"], "chemical/x-cif": ["cif"], "chemical/x-cmdf": ["cmdf"], "chemical/x-cml": ["cml"], "chemical/x-csml": ["csml"], "chemical/x-xyz": ["xyz"], "font/collection": ["ttc"], "font/otf": ["otf"], "font/ttf": ["ttf"], "font/woff": ["woff"], "font/woff2": ["woff2"], "image/apng": ["apng"], "image/bmp": ["bmp"], "image/cgm": ["cgm"], "image/g3fax": ["g3"], "image/gif": ["gif"], "image/ief": ["ief"], "image/jp2": ["jp2", "jpg2"], "image/jpeg": ["jpeg", "jpg", "jpe"], "image/jpm": ["jpm"], "image/jpx": ["jpx", "jpf"], "image/ktx": ["ktx"], "image/png": ["png"], "image/prs.btif": ["btif"], "image/sgi": ["sgi"], "image/svg+xml": ["svg", "svgz"], "image/tiff": ["tiff", "tif"], "image/vnd.adobe.photoshop": ["psd"], "image/vnd.dece.graphic": ["uvi", "uvvi", "uvg", "uvvg"], "image/vnd.djvu": ["djvu", "djv"], "image/vnd.dvb.subtitle": [], "image/vnd.dwg": ["dwg"], "image/vnd.dxf": ["dxf"], "image/vnd.fastbidsheet": ["fbs"], "image/vnd.fpx": ["fpx"], "image/vnd.fst": ["fst"], "image/vnd.fujixerox.edmics-mmr": ["mmr"], "image/vnd.fujixerox.edmics-rlc": ["rlc"], "image/vnd.ms-modi": ["mdi"], "image/vnd.ms-photo": ["wdp"], "image/vnd.net-fpx": ["npx"], "image/vnd.wap.wbmp": ["wbmp"], "image/vnd.xiff": ["xif"], "image/webp": ["webp"], "image/x-3ds": ["3ds"], "image/x-cmu-raster": ["ras"], "image/x-cmx": ["cmx"], "image/x-freehand": ["fh", "fhc", "fh4", "fh5", "fh7"], "image/x-icon": ["ico"], "image/x-jng": ["jng"], "image/x-mrsid-image": ["sid"], "image/x-ms-bmp": [], "image/x-pcx": ["pcx"], "image/x-pict": ["pic", "pct"], "image/x-portable-anymap": ["pnm"], "image/x-portable-bitmap": ["pbm"], "image/x-portable-graymap": ["pgm"], "image/x-portable-pixmap": ["ppm"], "image/x-rgb": ["rgb"], "image/x-tga": ["tga"], "image/x-xbitmap": ["xbm"], "image/x-xpixmap": ["xpm"], "image/x-xwindowdump": ["xwd"], "message/rfc822": ["eml", "mime"], "model/gltf+json": ["gltf"], "model/gltf-binary": ["glb"], "model/iges": ["igs", "iges"], "model/mesh": ["msh", "mesh", "silo"], "model/vnd.collada+xml": ["dae"], "model/vnd.dwf": ["dwf"], "model/vnd.gdl": ["gdl"], "model/vnd.gtw": ["gtw"], "model/vnd.mts": ["mts"], "model/vnd.vtu": ["vtu"], "model/vrml": ["wrl", "vrml"], "model/x3d+binary": ["x3db", "x3dbz"], "model/x3d+vrml": ["x3dv", "x3dvz"], "model/x3d+xml": ["x3d", "x3dz"], "text/cache-manifest": ["appcache", "manifest"], "text/calendar": ["ics", "ifb"], "text/coffeescript": ["coffee", "litcoffee"], "text/css": ["css"], "text/csv": ["csv"], "text/hjson": ["hjson"], "text/html": ["html", "htm", "shtml"], "text/jade": ["jade"], "text/jsx": ["jsx"], "text/less": ["less"], "text/markdown": ["markdown", "md"], "text/mathml": ["mml"], "text/n3": ["n3"], "text/plain": ["txt", "text", "conf", "def", "list", "log", "in", "ini"], "text/prs.lines.tag": ["dsc"], "text/richtext": ["rtx"], "text/rtf": [], "text/sgml": ["sgml", "sgm"], "text/slim": ["slim", "slm"], "text/stylus": ["stylus", "styl"], "text/tab-separated-values": ["tsv"], "text/troff": ["t", "tr", "roff", "man", "me", "ms"], "text/turtle": ["ttl"], "text/uri-list": ["uri", "uris", "urls"], "text/vcard": ["vcard"], "text/vnd.curl": ["curl"], "text/vnd.curl.dcurl": ["dcurl"], "text/vnd.curl.mcurl": ["mcurl"], "text/vnd.curl.scurl": ["scurl"], "text/vnd.dvb.subtitle": ["sub"], "text/vnd.fly": ["fly"], "text/vnd.fmi.flexstor": ["flx"], "text/vnd.graphviz": ["gv"], "text/vnd.in3d.3dml": ["3dml"], "text/vnd.in3d.spot": ["spot"], "text/vnd.sun.j2me.app-descriptor": ["jad"], "text/vnd.wap.wml": ["wml"], "text/vnd.wap.wmlscript": ["wmls"], "text/vtt": ["vtt"], "text/x-asm": ["s", "asm"], "text/x-c": ["c", "cc", "cxx", "cpp", "h", "hh", "dic"], "text/x-component": ["htc"], "text/x-fortran": ["f", "for", "f77", "f90"], "text/x-handlebars-template": ["hbs"], "text/x-java-source": ["java"], "text/x-lua": ["lua"], "text/x-markdown": ["mkd"], "text/x-nfo": ["nfo"], "text/x-opml": ["opml"], "text/x-org": [], "text/x-pascal": ["p", "pas"], "text/x-processing": ["pde"], "text/x-sass": ["sass"], "text/x-scss": ["scss"], "text/x-setext": ["etx"], "text/x-sfv": ["sfv"], "text/x-suse-ymp": ["ymp"], "text/x-uuencode": ["uu"], "text/x-vcalendar": ["vcs"], "text/x-vcard": ["vcf"], "text/xml": [], "text/yaml": ["yaml", "yml"], "video/3gpp": ["3gp", "3gpp"], "video/3gpp2": ["3g2"], "video/h261": ["h261"], "video/h263": ["h263"], "video/h264": ["h264"], "video/jpeg": ["jpgv"], "video/jpm": ["jpgm"], "video/mj2": ["mj2", "mjp2"], "video/mp2t": ["ts"], "video/mp4": ["mp4", "mp4v", "mpg4"], "video/mpeg": ["mpeg", "mpg", "mpe", "m1v", "m2v"], "video/ogg": ["ogv"], "video/quicktime": ["qt", "mov"], "video/vnd.dece.hd": ["uvh", "uvvh"], "video/vnd.dece.mobile": ["uvm", "uvvm"], "video/vnd.dece.pd": ["uvp", "uvvp"], "video/vnd.dece.sd": ["uvs", "uvvs"], "video/vnd.dece.video": ["uvv", "uvvv"], "video/vnd.dvb.file": ["dvb"], "video/vnd.fvt": ["fvt"], "video/vnd.mpegurl": ["mxu", "m4u"], "video/vnd.ms-playready.media.pyv": ["pyv"], "video/vnd.uvvu.mp4": ["uvu", "uvvu"], "video/vnd.vivo": ["viv"], "video/webm": ["webm"], "video/x-f4v": ["f4v"], "video/x-fli": ["fli"], "video/x-flv": ["flv"], "video/x-m4v": ["m4v"], "video/x-matroska": ["mkv", "mk3d", "mks"], "video/x-mng": ["mng"], "video/x-ms-asf": ["asf", "asx"], "video/x-ms-vob": ["vob"], "video/x-ms-wm": ["wm"], "video/x-ms-wmv": ["wmv"], "video/x-ms-wmx": ["wmx"], "video/x-ms-wvx": ["wvx"], "video/x-msvideo": ["avi"], "video/x-sgi-movie": ["movie"], "video/x-smv": ["smv"], "x-conference/x-cooltalk": ["ice"] };
  }
});

// ../../common/temp/node_modules/.pnpm/mime@1.6.0/node_modules/mime/mime.js
var require_mime = __commonJS({
  "../../common/temp/node_modules/.pnpm/mime@1.6.0/node_modules/mime/mime.js"(exports, module) {
    var path = __require("path");
    var fs = __require("fs");
    function Mime() {
      this.types = /* @__PURE__ */ Object.create(null);
      this.extensions = /* @__PURE__ */ Object.create(null);
    }
    Mime.prototype.define = function(map) {
      for (var type in map) {
        var exts = map[type];
        for (var i = 0; i < exts.length; i++) {
          if (process.env.DEBUG_MIME && this.types[exts[i]]) {
            console.warn((this._loading || "define()").replace(/.*\//, ""), 'changes "' + exts[i] + '" extension type from ' + this.types[exts[i]] + " to " + type);
          }
          this.types[exts[i]] = type;
        }
        if (!this.extensions[type]) {
          this.extensions[type] = exts[0];
        }
      }
    };
    Mime.prototype.load = function(file) {
      this._loading = file;
      var map = {}, content = fs.readFileSync(file, "ascii"), lines = content.split(/[\r\n]+/);
      lines.forEach(function(line) {
        var fields = line.replace(/\s*#.*|^\s*|\s*$/g, "").split(/\s+/);
        map[fields.shift()] = fields;
      });
      this.define(map);
      this._loading = null;
    };
    Mime.prototype.lookup = function(path2, fallback) {
      var ext = path2.replace(/^.*[\.\/\\]/, "").toLowerCase();
      return this.types[ext] || fallback || this.default_type;
    };
    Mime.prototype.extension = function(mimeType) {
      var type = mimeType.match(/^\s*([^;\s]*)(?:;|\s|$)/)[1].toLowerCase();
      return this.extensions[type];
    };
    var mime = new Mime();
    mime.define(require_types());
    mime.default_type = mime.lookup("bin");
    mime.Mime = Mime;
    mime.charsets = {
      lookup: function(mimeType, fallback) {
        return /^text\/|^application\/(javascript|json)/.test(mimeType) ? "UTF-8" : fallback;
      }
    };
    module.exports = mime;
  }
});

// ../../common/temp/node_modules/.pnpm/ms@2.1.3/node_modules/ms/index.js
var require_ms2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/ms@2.1.3/node_modules/ms/index.js"(exports, module) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var w = d * 7;
    var y = d * 365.25;
    module.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse(val);
      } else if (type === "number" && isFinite(val)) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error(
        "val is not a non-empty string or a valid number. val=" + JSON.stringify(val)
      );
    };
    function parse(str) {
      str = String(str);
      if (str.length > 100) {
        return;
      }
      var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
        str
      );
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "weeks":
        case "week":
        case "w":
          return n * w;
        case "days":
        case "day":
        case "d":
          return n * d;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d) {
        return Math.round(ms / d) + "d";
      }
      if (msAbs >= h) {
        return Math.round(ms / h) + "h";
      }
      if (msAbs >= m) {
        return Math.round(ms / m) + "m";
      }
      if (msAbs >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d) {
        return plural(ms, msAbs, d, "day");
      }
      if (msAbs >= h) {
        return plural(ms, msAbs, h, "hour");
      }
      if (msAbs >= m) {
        return plural(ms, msAbs, m, "minute");
      }
      if (msAbs >= s) {
        return plural(ms, msAbs, s, "second");
      }
      return ms + " ms";
    }
    function plural(ms, msAbs, n, name) {
      var isPlural = msAbs >= n * 1.5;
      return Math.round(ms / n) + " " + name + (isPlural ? "s" : "");
    }
  }
});

// ../../common/temp/node_modules/.pnpm/on-finished@2.4.1/node_modules/on-finished/index.js
var require_on_finished2 = __commonJS({
  "../../common/temp/node_modules/.pnpm/on-finished@2.4.1/node_modules/on-finished/index.js"(exports, module) {
    "use strict";
    module.exports = onFinished;
    module.exports.isFinished = isFinished;
    var asyncHooks = tryRequireAsyncHooks();
    var first = require_ee_first();
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn) {
      process.nextTick(fn.bind.apply(fn, arguments));
    };
    function onFinished(msg, listener) {
      if (isFinished(msg) !== false) {
        defer(listener, null, msg);
        return msg;
      }
      attachListener(msg, wrap(listener));
      return msg;
    }
    function isFinished(msg) {
      var socket = msg.socket;
      if (typeof msg.finished === "boolean") {
        return Boolean(msg.finished || socket && !socket.writable);
      }
      if (typeof msg.complete === "boolean") {
        return Boolean(msg.upgrade || !socket || !socket.readable || msg.complete && !msg.readable);
      }
      return void 0;
    }
    function attachFinishedListener(msg, callback) {
      var eeMsg;
      var eeSocket;
      var finished = false;
      function onFinish(error) {
        eeMsg.cancel();
        eeSocket.cancel();
        finished = true;
        callback(error);
      }
      eeMsg = eeSocket = first([[msg, "end", "finish"]], onFinish);
      function onSocket(socket) {
        msg.removeListener("socket", onSocket);
        if (finished)
          return;
        if (eeMsg !== eeSocket)
          return;
        eeSocket = first([[socket, "error", "close"]], onFinish);
      }
      if (msg.socket) {
        onSocket(msg.socket);
        return;
      }
      msg.on("socket", onSocket);
      if (msg.socket === void 0) {
        patchAssignSocket(msg, onSocket);
      }
    }
    function attachListener(msg, listener) {
      var attached = msg.__onFinished;
      if (!attached || !attached.queue) {
        attached = msg.__onFinished = createListener(msg);
        attachFinishedListener(msg, attached);
      }
      attached.queue.push(listener);
    }
    function createListener(msg) {
      function listener(err) {
        if (msg.__onFinished === listener)
          msg.__onFinished = null;
        if (!listener.queue)
          return;
        var queue = listener.queue;
        listener.queue = null;
        for (var i = 0; i < queue.length; i++) {
          queue[i](err, msg);
        }
      }
      listener.queue = [];
      return listener;
    }
    function patchAssignSocket(res, callback) {
      var assignSocket = res.assignSocket;
      if (typeof assignSocket !== "function")
        return;
      res.assignSocket = function _assignSocket(socket) {
        assignSocket.call(this, socket);
        callback(socket);
      };
    }
    function tryRequireAsyncHooks() {
      try {
        return __require("async_hooks");
      } catch (e) {
        return {};
      }
    }
    function wrap(fn) {
      var res;
      if (asyncHooks.AsyncResource) {
        res = new asyncHooks.AsyncResource(fn.name || "bound-anonymous-fn");
      }
      if (!res || !res.runInAsyncScope) {
        return fn;
      }
      return res.runInAsyncScope.bind(res, fn, null);
    }
  }
});

// ../../common/temp/node_modules/.pnpm/range-parser@1.2.1/node_modules/range-parser/index.js
var require_range_parser = __commonJS({
  "../../common/temp/node_modules/.pnpm/range-parser@1.2.1/node_modules/range-parser/index.js"(exports, module) {
    "use strict";
    module.exports = rangeParser;
    function rangeParser(size, str, options) {
      if (typeof str !== "string") {
        throw new TypeError("argument str must be a string");
      }
      var index = str.indexOf("=");
      if (index === -1) {
        return -2;
      }
      var arr = str.slice(index + 1).split(",");
      var ranges = [];
      ranges.type = str.slice(0, index);
      for (var i = 0; i < arr.length; i++) {
        var range = arr[i].split("-");
        var start = parseInt(range[0], 10);
        var end = parseInt(range[1], 10);
        if (isNaN(start)) {
          start = size - end;
          end = size - 1;
        } else if (isNaN(end)) {
          end = size - 1;
        }
        if (end > size - 1) {
          end = size - 1;
        }
        if (isNaN(start) || isNaN(end) || start > end || start < 0) {
          continue;
        }
        ranges.push({
          start,
          end
        });
      }
      if (ranges.length < 1) {
        return -1;
      }
      return options && options.combine ? combineRanges(ranges) : ranges;
    }
    function combineRanges(ranges) {
      var ordered = ranges.map(mapWithIndex).sort(sortByRangeStart);
      for (var j = 0, i = 1; i < ordered.length; i++) {
        var range = ordered[i];
        var current = ordered[j];
        if (range.start > current.end + 1) {
          ordered[++j] = range;
        } else if (range.end > current.end) {
          current.end = range.end;
          current.index = Math.min(current.index, range.index);
        }
      }
      ordered.length = j + 1;
      var combined = ordered.sort(sortByRangeIndex).map(mapWithoutIndex);
      combined.type = ranges.type;
      return combined;
    }
    function mapWithIndex(range, index) {
      return {
        start: range.start,
        end: range.end,
        index
      };
    }
    function mapWithoutIndex(range) {
      return {
        start: range.start,
        end: range.end
      };
    }
    function sortByRangeIndex(a, b) {
      return a.index - b.index;
    }
    function sortByRangeStart(a, b) {
      return a.start - b.start;
    }
  }
});

// ../../common/temp/node_modules/.pnpm/send@0.18.0/node_modules/send/index.js
var require_send = __commonJS({
  "../../common/temp/node_modules/.pnpm/send@0.18.0/node_modules/send/index.js"(exports, module) {
    "use strict";
    var createError = require_http_errors();
    var debug = require_src()("send");
    var deprecate = require_depd()("send");
    var destroy = require_destroy();
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var etag = require_etag();
    var fresh = require_fresh();
    var fs = __require("fs");
    var mime = require_mime();
    var ms = require_ms2();
    var onFinished = require_on_finished2();
    var parseRange = require_range_parser();
    var path = __require("path");
    var statuses = require_statuses2();
    var Stream = __require("stream");
    var util = __require("util");
    var extname = path.extname;
    var join2 = path.join;
    var normalize = path.normalize;
    var resolve = path.resolve;
    var sep = path.sep;
    var BYTES_RANGE_REGEXP = /^ *bytes=/;
    var MAX_MAXAGE = 60 * 60 * 24 * 365 * 1e3;
    var UP_PATH_REGEXP = /(?:^|[\\/])\.\.(?:[\\/]|$)/;
    module.exports = send;
    module.exports.mime = mime;
    function send(req, path2, options) {
      return new SendStream(req, path2, options);
    }
    function SendStream(req, path2, options) {
      Stream.call(this);
      var opts = options || {};
      this.options = opts;
      this.path = path2;
      this.req = req;
      this._acceptRanges = opts.acceptRanges !== void 0 ? Boolean(opts.acceptRanges) : true;
      this._cacheControl = opts.cacheControl !== void 0 ? Boolean(opts.cacheControl) : true;
      this._etag = opts.etag !== void 0 ? Boolean(opts.etag) : true;
      this._dotfiles = opts.dotfiles !== void 0 ? opts.dotfiles : "ignore";
      if (this._dotfiles !== "ignore" && this._dotfiles !== "allow" && this._dotfiles !== "deny") {
        throw new TypeError('dotfiles option must be "allow", "deny", or "ignore"');
      }
      this._hidden = Boolean(opts.hidden);
      if (opts.hidden !== void 0) {
        deprecate("hidden: use dotfiles: '" + (this._hidden ? "allow" : "ignore") + "' instead");
      }
      if (opts.dotfiles === void 0) {
        this._dotfiles = void 0;
      }
      this._extensions = opts.extensions !== void 0 ? normalizeList(opts.extensions, "extensions option") : [];
      this._immutable = opts.immutable !== void 0 ? Boolean(opts.immutable) : false;
      this._index = opts.index !== void 0 ? normalizeList(opts.index, "index option") : ["index.html"];
      this._lastModified = opts.lastModified !== void 0 ? Boolean(opts.lastModified) : true;
      this._maxage = opts.maxAge || opts.maxage;
      this._maxage = typeof this._maxage === "string" ? ms(this._maxage) : Number(this._maxage);
      this._maxage = !isNaN(this._maxage) ? Math.min(Math.max(0, this._maxage), MAX_MAXAGE) : 0;
      this._root = opts.root ? resolve(opts.root) : null;
      if (!this._root && opts.from) {
        this.from(opts.from);
      }
    }
    util.inherits(SendStream, Stream);
    SendStream.prototype.etag = deprecate.function(function etag2(val) {
      this._etag = Boolean(val);
      debug("etag %s", this._etag);
      return this;
    }, "send.etag: pass etag as option");
    SendStream.prototype.hidden = deprecate.function(function hidden(val) {
      this._hidden = Boolean(val);
      this._dotfiles = void 0;
      debug("hidden %s", this._hidden);
      return this;
    }, "send.hidden: use dotfiles option");
    SendStream.prototype.index = deprecate.function(function index(paths) {
      var index2 = !paths ? [] : normalizeList(paths, "paths argument");
      debug("index %o", paths);
      this._index = index2;
      return this;
    }, "send.index: pass index as option");
    SendStream.prototype.root = function root(path2) {
      this._root = resolve(String(path2));
      debug("root %s", this._root);
      return this;
    };
    SendStream.prototype.from = deprecate.function(
      SendStream.prototype.root,
      "send.from: pass root as option"
    );
    SendStream.prototype.root = deprecate.function(
      SendStream.prototype.root,
      "send.root: pass root as option"
    );
    SendStream.prototype.maxage = deprecate.function(function maxage(maxAge) {
      this._maxage = typeof maxAge === "string" ? ms(maxAge) : Number(maxAge);
      this._maxage = !isNaN(this._maxage) ? Math.min(Math.max(0, this._maxage), MAX_MAXAGE) : 0;
      debug("max-age %d", this._maxage);
      return this;
    }, "send.maxage: pass maxAge as option");
    SendStream.prototype.error = function error(status, err) {
      if (hasListeners(this, "error")) {
        return this.emit("error", createHttpError(status, err));
      }
      var res = this.res;
      var msg = statuses.message[status] || String(status);
      var doc = createHtmlDocument("Error", escapeHtml(msg));
      clearHeaders(res);
      if (err && err.headers) {
        setHeaders(res, err.headers);
      }
      res.statusCode = status;
      res.setHeader("Content-Type", "text/html; charset=UTF-8");
      res.setHeader("Content-Length", Buffer.byteLength(doc));
      res.setHeader("Content-Security-Policy", "default-src 'none'");
      res.setHeader("X-Content-Type-Options", "nosniff");
      res.end(doc);
    };
    SendStream.prototype.hasTrailingSlash = function hasTrailingSlash() {
      return this.path[this.path.length - 1] === "/";
    };
    SendStream.prototype.isConditionalGET = function isConditionalGET() {
      return this.req.headers["if-match"] || this.req.headers["if-unmodified-since"] || this.req.headers["if-none-match"] || this.req.headers["if-modified-since"];
    };
    SendStream.prototype.isPreconditionFailure = function isPreconditionFailure() {
      var req = this.req;
      var res = this.res;
      var match = req.headers["if-match"];
      if (match) {
        var etag2 = res.getHeader("ETag");
        return !etag2 || match !== "*" && parseTokenList(match).every(function(match2) {
          return match2 !== etag2 && match2 !== "W/" + etag2 && "W/" + match2 !== etag2;
        });
      }
      var unmodifiedSince = parseHttpDate(req.headers["if-unmodified-since"]);
      if (!isNaN(unmodifiedSince)) {
        var lastModified = parseHttpDate(res.getHeader("Last-Modified"));
        return isNaN(lastModified) || lastModified > unmodifiedSince;
      }
      return false;
    };
    SendStream.prototype.removeContentHeaderFields = function removeContentHeaderFields() {
      var res = this.res;
      res.removeHeader("Content-Encoding");
      res.removeHeader("Content-Language");
      res.removeHeader("Content-Length");
      res.removeHeader("Content-Range");
      res.removeHeader("Content-Type");
    };
    SendStream.prototype.notModified = function notModified() {
      var res = this.res;
      debug("not modified");
      this.removeContentHeaderFields();
      res.statusCode = 304;
      res.end();
    };
    SendStream.prototype.headersAlreadySent = function headersAlreadySent() {
      var err = new Error("Can't set headers after they are sent.");
      debug("headers already sent");
      this.error(500, err);
    };
    SendStream.prototype.isCachable = function isCachable() {
      var statusCode = this.res.statusCode;
      return statusCode >= 200 && statusCode < 300 || statusCode === 304;
    };
    SendStream.prototype.onStatError = function onStatError(error) {
      switch (error.code) {
        case "ENAMETOOLONG":
        case "ENOENT":
        case "ENOTDIR":
          this.error(404, error);
          break;
        default:
          this.error(500, error);
          break;
      }
    };
    SendStream.prototype.isFresh = function isFresh() {
      return fresh(this.req.headers, {
        etag: this.res.getHeader("ETag"),
        "last-modified": this.res.getHeader("Last-Modified")
      });
    };
    SendStream.prototype.isRangeFresh = function isRangeFresh() {
      var ifRange = this.req.headers["if-range"];
      if (!ifRange) {
        return true;
      }
      if (ifRange.indexOf('"') !== -1) {
        var etag2 = this.res.getHeader("ETag");
        return Boolean(etag2 && ifRange.indexOf(etag2) !== -1);
      }
      var lastModified = this.res.getHeader("Last-Modified");
      return parseHttpDate(lastModified) <= parseHttpDate(ifRange);
    };
    SendStream.prototype.redirect = function redirect(path2) {
      var res = this.res;
      if (hasListeners(this, "directory")) {
        this.emit("directory", res, path2);
        return;
      }
      if (this.hasTrailingSlash()) {
        this.error(403);
        return;
      }
      var loc = encodeUrl(collapseLeadingSlashes(this.path + "/"));
      var doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
      res.statusCode = 301;
      res.setHeader("Content-Type", "text/html; charset=UTF-8");
      res.setHeader("Content-Length", Buffer.byteLength(doc));
      res.setHeader("Content-Security-Policy", "default-src 'none'");
      res.setHeader("X-Content-Type-Options", "nosniff");
      res.setHeader("Location", loc);
      res.end(doc);
    };
    SendStream.prototype.pipe = function pipe(res) {
      var root = this._root;
      this.res = res;
      var path2 = decode(this.path);
      if (path2 === -1) {
        this.error(400);
        return res;
      }
      if (~path2.indexOf("\0")) {
        this.error(400);
        return res;
      }
      var parts;
      if (root !== null) {
        if (path2) {
          path2 = normalize("." + sep + path2);
        }
        if (UP_PATH_REGEXP.test(path2)) {
          debug('malicious path "%s"', path2);
          this.error(403);
          return res;
        }
        parts = path2.split(sep);
        path2 = normalize(join2(root, path2));
      } else {
        if (UP_PATH_REGEXP.test(path2)) {
          debug('malicious path "%s"', path2);
          this.error(403);
          return res;
        }
        parts = normalize(path2).split(sep);
        path2 = resolve(path2);
      }
      if (containsDotFile(parts)) {
        var access = this._dotfiles;
        if (access === void 0) {
          access = parts[parts.length - 1][0] === "." ? this._hidden ? "allow" : "ignore" : "allow";
        }
        debug('%s dotfile "%s"', access, path2);
        switch (access) {
          case "allow":
            break;
          case "deny":
            this.error(403);
            return res;
          case "ignore":
          default:
            this.error(404);
            return res;
        }
      }
      if (this._index.length && this.hasTrailingSlash()) {
        this.sendIndex(path2);
        return res;
      }
      this.sendFile(path2);
      return res;
    };
    SendStream.prototype.send = function send2(path2, stat) {
      var len = stat.size;
      var options = this.options;
      var opts = {};
      var res = this.res;
      var req = this.req;
      var ranges = req.headers.range;
      var offset = options.start || 0;
      if (headersSent(res)) {
        this.headersAlreadySent();
        return;
      }
      debug('pipe "%s"', path2);
      this.setHeader(path2, stat);
      this.type(path2);
      if (this.isConditionalGET()) {
        if (this.isPreconditionFailure()) {
          this.error(412);
          return;
        }
        if (this.isCachable() && this.isFresh()) {
          this.notModified();
          return;
        }
      }
      len = Math.max(0, len - offset);
      if (options.end !== void 0) {
        var bytes = options.end - offset + 1;
        if (len > bytes)
          len = bytes;
      }
      if (this._acceptRanges && BYTES_RANGE_REGEXP.test(ranges)) {
        ranges = parseRange(len, ranges, {
          combine: true
        });
        if (!this.isRangeFresh()) {
          debug("range stale");
          ranges = -2;
        }
        if (ranges === -1) {
          debug("range unsatisfiable");
          res.setHeader("Content-Range", contentRange("bytes", len));
          return this.error(416, {
            headers: { "Content-Range": res.getHeader("Content-Range") }
          });
        }
        if (ranges !== -2 && ranges.length === 1) {
          debug("range %j", ranges);
          res.statusCode = 206;
          res.setHeader("Content-Range", contentRange("bytes", len, ranges[0]));
          offset += ranges[0].start;
          len = ranges[0].end - ranges[0].start + 1;
        }
      }
      for (var prop in options) {
        opts[prop] = options[prop];
      }
      opts.start = offset;
      opts.end = Math.max(offset, offset + len - 1);
      res.setHeader("Content-Length", len);
      if (req.method === "HEAD") {
        res.end();
        return;
      }
      this.stream(path2, opts);
    };
    SendStream.prototype.sendFile = function sendFile(path2) {
      var i = 0;
      var self = this;
      debug('stat "%s"', path2);
      fs.stat(path2, function onstat(err, stat) {
        if (err && err.code === "ENOENT" && !extname(path2) && path2[path2.length - 1] !== sep) {
          return next(err);
        }
        if (err)
          return self.onStatError(err);
        if (stat.isDirectory())
          return self.redirect(path2);
        self.emit("file", path2, stat);
        self.send(path2, stat);
      });
      function next(err) {
        if (self._extensions.length <= i) {
          return err ? self.onStatError(err) : self.error(404);
        }
        var p = path2 + "." + self._extensions[i++];
        debug('stat "%s"', p);
        fs.stat(p, function(err2, stat) {
          if (err2)
            return next(err2);
          if (stat.isDirectory())
            return next();
          self.emit("file", p, stat);
          self.send(p, stat);
        });
      }
    };
    SendStream.prototype.sendIndex = function sendIndex(path2) {
      var i = -1;
      var self = this;
      function next(err) {
        if (++i >= self._index.length) {
          if (err)
            return self.onStatError(err);
          return self.error(404);
        }
        var p = join2(path2, self._index[i]);
        debug('stat "%s"', p);
        fs.stat(p, function(err2, stat) {
          if (err2)
            return next(err2);
          if (stat.isDirectory())
            return next();
          self.emit("file", p, stat);
          self.send(p, stat);
        });
      }
      next();
    };
    SendStream.prototype.stream = function stream(path2, options) {
      var self = this;
      var res = this.res;
      var stream2 = fs.createReadStream(path2, options);
      this.emit("stream", stream2);
      stream2.pipe(res);
      function cleanup() {
        destroy(stream2, true);
      }
      onFinished(res, cleanup);
      stream2.on("error", function onerror(err) {
        cleanup();
        self.onStatError(err);
      });
      stream2.on("end", function onend() {
        self.emit("end");
      });
    };
    SendStream.prototype.type = function type(path2) {
      var res = this.res;
      if (res.getHeader("Content-Type"))
        return;
      var type2 = mime.lookup(path2);
      if (!type2) {
        debug("no content-type");
        return;
      }
      var charset = mime.charsets.lookup(type2);
      debug("content-type %s", type2);
      res.setHeader("Content-Type", type2 + (charset ? "; charset=" + charset : ""));
    };
    SendStream.prototype.setHeader = function setHeader(path2, stat) {
      var res = this.res;
      this.emit("headers", res, path2, stat);
      if (this._acceptRanges && !res.getHeader("Accept-Ranges")) {
        debug("accept ranges");
        res.setHeader("Accept-Ranges", "bytes");
      }
      if (this._cacheControl && !res.getHeader("Cache-Control")) {
        var cacheControl = "public, max-age=" + Math.floor(this._maxage / 1e3);
        if (this._immutable) {
          cacheControl += ", immutable";
        }
        debug("cache-control %s", cacheControl);
        res.setHeader("Cache-Control", cacheControl);
      }
      if (this._lastModified && !res.getHeader("Last-Modified")) {
        var modified = stat.mtime.toUTCString();
        debug("modified %s", modified);
        res.setHeader("Last-Modified", modified);
      }
      if (this._etag && !res.getHeader("ETag")) {
        var val = etag(stat);
        debug("etag %s", val);
        res.setHeader("ETag", val);
      }
    };
    function clearHeaders(res) {
      var headers = getHeaderNames(res);
      for (var i = 0; i < headers.length; i++) {
        res.removeHeader(headers[i]);
      }
    }
    function collapseLeadingSlashes(str) {
      for (var i = 0; i < str.length; i++) {
        if (str[i] !== "/") {
          break;
        }
      }
      return i > 1 ? "/" + str.substr(i) : str;
    }
    function containsDotFile(parts) {
      for (var i = 0; i < parts.length; i++) {
        var part = parts[i];
        if (part.length > 1 && part[0] === ".") {
          return true;
        }
      }
      return false;
    }
    function contentRange(type, size, range) {
      return type + " " + (range ? range.start + "-" + range.end : "*") + "/" + size;
    }
    function createHtmlDocument(title, body) {
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>' + title + "</title>\n</head>\n<body>\n<pre>" + body + "</pre>\n</body>\n</html>\n";
    }
    function createHttpError(status, err) {
      if (!err) {
        return createError(status);
      }
      return err instanceof Error ? createError(status, err, { expose: false }) : createError(status, err);
    }
    function decode(path2) {
      try {
        return decodeURIComponent(path2);
      } catch (err) {
        return -1;
      }
    }
    function getHeaderNames(res) {
      return typeof res.getHeaderNames !== "function" ? Object.keys(res._headers || {}) : res.getHeaderNames();
    }
    function hasListeners(emitter, type) {
      var count = typeof emitter.listenerCount !== "function" ? emitter.listeners(type).length : emitter.listenerCount(type);
      return count > 0;
    }
    function headersSent(res) {
      return typeof res.headersSent !== "boolean" ? Boolean(res._header) : res.headersSent;
    }
    function normalizeList(val, name) {
      var list = [].concat(val || []);
      for (var i = 0; i < list.length; i++) {
        if (typeof list[i] !== "string") {
          throw new TypeError(name + " must be array of strings or false");
        }
      }
      return list;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp === "number" ? timestamp : NaN;
    }
    function parseTokenList(str) {
      var end = 0;
      var list = [];
      var start = 0;
      for (var i = 0, len = str.length; i < len; i++) {
        switch (str.charCodeAt(i)) {
          case 32:
            if (start === end) {
              start = end = i + 1;
            }
            break;
          case 44:
            if (start !== end) {
              list.push(str.substring(start, end));
            }
            start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      }
      if (start !== end) {
        list.push(str.substring(start, end));
      }
      return list;
    }
    function setHeaders(res, headers) {
      var keys = Object.keys(headers);
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// ../../common/temp/node_modules/.pnpm/serve-static@1.15.0/node_modules/serve-static/index.js
var require_serve_static = __commonJS({
  "../../common/temp/node_modules/.pnpm/serve-static@1.15.0/node_modules/serve-static/index.js"(exports, module) {
    "use strict";
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var parseUrl = require_parseurl();
    var resolve = __require("path").resolve;
    var send = require_send();
    var url = __require("url");
    module.exports = serveStatic2;
    module.exports.mime = send.mime;
    function serveStatic2(root, options) {
      if (!root) {
        throw new TypeError("root path required");
      }
      if (typeof root !== "string") {
        throw new TypeError("root path must be a string");
      }
      var opts = Object.create(options || null);
      var fallthrough = opts.fallthrough !== false;
      var redirect = opts.redirect !== false;
      var setHeaders = opts.setHeaders;
      if (setHeaders && typeof setHeaders !== "function") {
        throw new TypeError("option setHeaders must be function");
      }
      opts.maxage = opts.maxage || opts.maxAge || 0;
      opts.root = resolve(root);
      var onDirectory = redirect ? createRedirectDirectoryListener() : createNotFoundDirectoryListener();
      return function serveStatic3(req, res, next) {
        if (req.method !== "GET" && req.method !== "HEAD") {
          if (fallthrough) {
            return next();
          }
          res.statusCode = 405;
          res.setHeader("Allow", "GET, HEAD");
          res.setHeader("Content-Length", "0");
          res.end();
          return;
        }
        var forwardError = !fallthrough;
        var originalUrl = parseUrl.original(req);
        var path = parseUrl(req).pathname;
        if (path === "/" && originalUrl.pathname.substr(-1) !== "/") {
          path = "";
        }
        var stream = send(req, path, opts);
        stream.on("directory", onDirectory);
        if (setHeaders) {
          stream.on("headers", setHeaders);
        }
        if (fallthrough) {
          stream.on("file", function onFile() {
            forwardError = true;
          });
        }
        stream.on("error", function error(err) {
          if (forwardError || !(err.statusCode < 500)) {
            next(err);
            return;
          }
          next();
        });
        stream.pipe(res);
      };
    }
    function collapseLeadingSlashes(str) {
      for (var i = 0; i < str.length; i++) {
        if (str.charCodeAt(i) !== 47) {
          break;
        }
      }
      return i > 1 ? "/" + str.substr(i) : str;
    }
    function createHtmlDocument(title, body) {
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>' + title + "</title>\n</head>\n<body>\n<pre>" + body + "</pre>\n</body>\n</html>\n";
    }
    function createNotFoundDirectoryListener() {
      return function notFound() {
        this.error(404);
      };
    }
    function createRedirectDirectoryListener() {
      return function redirect(res) {
        if (this.hasTrailingSlash()) {
          this.error(404);
          return;
        }
        var originalUrl = parseUrl.original(this.req);
        originalUrl.path = null;
        originalUrl.pathname = collapseLeadingSlashes(originalUrl.pathname + "/");
        var loc = encodeUrl(url.format(originalUrl));
        var doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
        res.statusCode = 301;
        res.setHeader("Content-Type", "text/html; charset=UTF-8");
        res.setHeader("Content-Length", Buffer.byteLength(doc));
        res.setHeader("Content-Security-Policy", "default-src 'none'");
        res.setHeader("X-Content-Type-Options", "nosniff");
        res.setHeader("Location", loc);
        res.end(doc);
      };
    }
  }
});

// ../../common/temp/node_modules/.pnpm/wasm-feature-detect@1.5.0/node_modules/wasm-feature-detect/dist/cjs/index.cjs
var require_cjs = __commonJS({
  "../../common/temp/node_modules/.pnpm/wasm-feature-detect@1.5.0/node_modules/wasm-feature-detect/dist/cjs/index.cjs"(exports, module) {
    "use strict";
    var e = { bigInt: () => (async (e2) => {
      try {
        return (await WebAssembly.instantiate(e2)).instance.exports.b(BigInt(0)) === BigInt(0);
      } catch (e3) {
        return false;
      }
    })(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 6, 1, 96, 1, 126, 1, 126, 3, 2, 1, 0, 7, 5, 1, 1, 98, 0, 0, 10, 6, 1, 4, 0, 32, 0, 11])), bulkMemory: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 5, 3, 1, 0, 1, 10, 14, 1, 12, 0, 65, 0, 65, 0, 65, 0, 252, 10, 0, 0, 11])), exceptions: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 10, 8, 1, 6, 0, 6, 64, 25, 11, 11])), extendedConst: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 5, 3, 1, 0, 1, 11, 9, 1, 0, 65, 1, 65, 2, 106, 11, 0])), gc: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 10, 2, 95, 1, 125, 0, 96, 0, 1, 107, 0, 3, 2, 1, 1, 10, 12, 1, 10, 0, 67, 0, 0, 0, 0, 251, 7, 0, 11])), memory64: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 5, 3, 1, 4, 1])), multiValue: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 6, 1, 96, 0, 2, 127, 127, 3, 2, 1, 0, 10, 8, 1, 6, 0, 65, 0, 65, 0, 11])), mutableGlobals: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 2, 8, 1, 1, 97, 1, 98, 3, 127, 1, 6, 6, 1, 127, 1, 65, 0, 11, 7, 5, 1, 1, 97, 3, 1])), referenceTypes: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 10, 7, 1, 5, 0, 208, 112, 26, 11])), relaxedSimd: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 5, 1, 96, 0, 1, 123, 3, 2, 1, 0, 10, 15, 1, 13, 0, 65, 1, 253, 15, 65, 2, 253, 15, 253, 128, 2, 11])), saturatedFloatToInt: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 10, 12, 1, 10, 0, 67, 0, 0, 0, 0, 252, 0, 26, 11])), signExtensions: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 10, 8, 1, 6, 0, 65, 0, 192, 26, 11])), simd: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 5, 1, 96, 0, 1, 123, 3, 2, 1, 0, 10, 10, 1, 8, 0, 65, 0, 253, 15, 253, 98, 11])), streamingCompilation: () => (async () => "compileStreaming" in WebAssembly)(), tailCall: async () => WebAssembly.validate(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 10, 6, 1, 4, 0, 18, 0, 11])), threads: () => (async (e2) => {
      try {
        return "undefined" != typeof MessageChannel && new MessageChannel().port1.postMessage(new SharedArrayBuffer(1)), WebAssembly.validate(e2);
      } catch (e3) {
        return false;
      }
    })(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 4, 1, 96, 0, 0, 3, 2, 1, 0, 5, 4, 1, 3, 1, 1, 10, 11, 1, 9, 0, 65, 0, 254, 16, 2, 0, 26, 11])) };
    module.exports = e;
  }
});

// ../../build/build-common/lib/model/symbols/build.js
var BuildType;
(function(BuildType3) {
  BuildType3.Debug = Symbol("BuildType/Debug");
  BuildType3.Dev = Symbol("BuildType/Dev");
  BuildType3.Test = Symbol("BuildType/Test");
  BuildType3.Release = Symbol("BuildType/Release");
})(BuildType || (BuildType = {}));
var ThreadingModel;
(function(ThreadingModel3) {
  ThreadingModel3.Single = Symbol("ThreadingModel/Single");
  ThreadingModel3.Multi = Symbol("ThreadingModel/Multi");
})(ThreadingModel || (ThreadingModel = {}));
var BuildPhase;
(function(BuildPhase2) {
  BuildPhase2.Always = Symbol("BuildPhase/Always");
  BuildPhase2.Compile = Symbol("BuildPhase/Compile");
  BuildPhase2.Link = Symbol("BuildPhase/Link");
})(BuildPhase || (BuildPhase = {}));

// ../../build/build-common/lib/model/symbols/package.js
var PackageType;
(function(PackageType2) {
  PackageType2.Module = Symbol("PackageType/Module");
  PackageType2.Lib = Symbol("PackageType/Lib");
  PackageType2.Runtime = Symbol("PackageType/Runtime");
  PackageType2.Shell = Symbol("PackageType/Shell");
  PackageType2.App = Symbol("PackageType/App");
  PackageType2.Virtual = Symbol("PackageType/Virtual");
  PackageType2.Model = Symbol("PackageType/Model");
})(PackageType || (PackageType = {}));

// ../../build/build-common/lib/lib/banner.js
function getServeBanner(port, path, dir = "") {
  return `Serving${path ? " " + path + " " : " "}on port ${port}

  > Local:    http://localhost:${port}/${dir}

`;
}
function printServeBanner(port, path, dir = "") {
  console.log(getServeBanner(port, path, dir));
}

// ../../build/build-common/lib/api/build-common.api.js
var import_ts_command_line = __toESM(require_lib2(), 1);
var [, processCommand_, ...processArgs_] = process.argv;

// ../../build/build-serve/src/bin/BuildServeImplementation.ts
import { join } from "path";
var import_connect = __toESM(require_connect(), 1);
var import_serve_static = __toESM(require_serve_static(), 1);
var DEFAULT_SERVE_PORT = "4000";
var SERVE_HEADERS = {
  "Cross-Origin-Opener-Policy": "same-origin",
  "Cross-Origin-Embedder-Policy": "require-corp"
};
var BuildServeImplementation = class {
  static async serve(dir, port = DEFAULT_SERVE_PORT) {
    const path = join(process.cwd(), dir);
    (0, import_connect.default)().use(
      (0, import_serve_static.default)(path, {
        setHeaders(res) {
          for (let [name, value] of Object.entries(SERVE_HEADERS)) {
            res.setHeader(name, value);
          }
        }
      })
    ).listen(port, () => printServeBanner(port, path, dir !== "." ? dir : void 0));
  }
};

// lib/bin/OsgearthwasmCommandLineServeAction.js
var OsgearthwasmCommandLineServeAction = class extends import_ts_command_line.CommandLineAction {
  constructor() {
    super({
      actionName: "serve",
      summary: "Serve the whole packge in the current directory",
      documentation: `Starts a local webserver to serve the package on port ${DEFAULT_SERVE_PORT} (default, can be changed with --port).`
    });
  }
  onExecute() {
    return BuildServeImplementation.serve(".", this._port.value);
  }
  onDefineParameters() {
    this._port = this.defineStringParameter({
      parameterLongName: "--port",
      parameterShortName: "-P",
      argumentName: "PORT",
      description: `The port which the web server will listen on. Defaults to ${DEFAULT_SERVE_PORT} if not specified.`,
      defaultValue: DEFAULT_SERVE_PORT
    });
  }
};

// ../../model/model-emscripten/lib/model/Environment.js
var Platform;
(function(Platform2) {
  Platform2["node"] = "node";
  Platform2["browser"] = "browser";
})(Platform || (Platform = {}));
var BuildType2;
(function(BuildType3) {
  BuildType3["release"] = "release";
  BuildType3["test"] = "test";
  BuildType3["dev"] = "dev";
  BuildType3["debug"] = "debug";
})(BuildType2 || (BuildType2 = {}));
var ThreadingModel2;
(function(ThreadingModel3) {
  ThreadingModel3["single"] = "single";
  ThreadingModel3["multi"] = "multi";
})(ThreadingModel2 || (ThreadingModel2 = {}));
var Environment = class {
  constructor(platform, buildType, threadingModel, variables = {}) {
    this.platform = platform;
    this.buildType = buildType;
    this.threadingModel = threadingModel;
    this.variables = variables;
  }
};

// ../../model/model-emscripten/lib/model/Emscripten.js
var EmscriptenRuntimeStatus;
(function(EmscriptenRuntimeStatus2) {
  EmscriptenRuntimeStatus2["LOAD"] = "LOAD";
  EmscriptenRuntimeStatus2["READY"] = "READY";
  EmscriptenRuntimeStatus2["START"] = "START";
  EmscriptenRuntimeStatus2["CREATE"] = "CREATE";
  EmscriptenRuntimeStatus2["BOOT"] = "BOOT";
  EmscriptenRuntimeStatus2["SETUP"] = "SETUP";
  EmscriptenRuntimeStatus2["INIT"] = "INIT";
  EmscriptenRuntimeStatus2["RUN"] = "RUN";
})(EmscriptenRuntimeStatus || (EmscriptenRuntimeStatus = {}));

// ../../model/model-emscripten/lib/lib/EmscriptenRuntime/feature.js
var import_wasm_feature_detect = __toESM(require_cjs(), 1);
var FeatureNotSupportedError = class extends Error {
  constructor(message) {
    super(message);
    Object.setPrototypeOf(this, FeatureNotSupportedError.prototype);
  }
};
function webAssembly() {
  try {
    if (typeof WebAssembly === "object" && typeof WebAssembly.instantiate === "function") {
      const module = new WebAssembly.Module(Uint8Array.of(0, 97, 115, 109, 1, 0, 0, 0));
      if (module instanceof WebAssembly.Module)
        return new WebAssembly.Instance(module) instanceof WebAssembly.Instance;
    }
  } catch (e) {
    return false;
  }
  return true;
}
async function testWebAssembly(throwError = true) {
  const webAssemblySupported = webAssembly();
  if (!webAssemblySupported) {
    if (throwError) {
      throw new FeatureNotSupportedError("WebAssembly is not supported");
    }
    return false;
  }
  return true;
}
async function testWebGL2(throwError = true) {
  const webGL2Supported = document.createElement("canvas").getContext("webgl2");
  if (!webGL2Supported) {
    if (throwError) {
      throw new FeatureNotSupportedError("WebGL 2 is not supported");
    }
    return false;
  }
  return true;
}
async function testBigInt(throwError = true) {
  const bigIntSupported = await (0, import_wasm_feature_detect.bigInt)();
  if (!bigIntSupported) {
    if (throwError) {
      throw new FeatureNotSupportedError("WebAssembly big ints are not supported");
    }
    return false;
  }
  return true;
}
async function testExceptions(throwError = true) {
  const exceptionsSupported = await (0, import_wasm_feature_detect.exceptions)();
  if (!exceptionsSupported) {
    if (throwError) {
      throw new FeatureNotSupportedError("WebAssembly native exceptions are not supported");
    }
    return false;
  }
  return true;
}
async function testThreads(throwError = true) {
  const threadsupported = await (0, import_wasm_feature_detect.threads)();
  if (!threadsupported) {
    if (throwError) {
      throw new FeatureNotSupportedError("WebAssembly threads are not supported");
    }
    return false;
  }
  return true;
}
function offscreenCanvas() {
  const canvasTest = document.createElement("canvas");
  return typeof canvasTest["transferControlToOffscreen"] === "function";
}
async function testOffscreenCanvas(throwError = true) {
  const offscreenCanvasSupported = offscreenCanvas();
  if (!offscreenCanvasSupported) {
    if (throwError) {
      throw new FeatureNotSupportedError("OffscreenCanvas is not supported");
    }
    return false;
  }
  return true;
}
async function supportsEngine(throwError = true) {
  const results = await Promise.all([
    testWebAssembly(),
    testWebGL2(),
    testBigInt(),
    testExceptions()
  ]);
  return results.every((result) => result === true);
}
async function supportsOffscreenEngine(throwError = true) {
  const results = await Promise.all([
    supportsEngine(),
    testOffscreenCanvas(),
    testThreads()
  ]);
  return results.every((result) => result === true);
}

// ../../model/model-emscripten/lib/lib/environment.js
async function requestEnvironment(request = {}) {
  const variables = { ...request.variables || {} };
  if (!request.platform || request.platform === "browser") {
    const platform = Platform.browser;
    if (await supportsEngine()) {
      const buildType = request.buildType || BuildType2.release;
      if (request.threadingModel === ThreadingModel2.single) {
        return new Environment(platform, buildType, ThreadingModel2.single, variables);
      } else {
        const offscreenSupport = await supportsOffscreenEngine();
        if (offscreenSupport) {
          return new Environment(platform, buildType, ThreadingModel2.multi, variables);
        } else {
          if (request.threadingModel === ThreadingModel2.multi) {
            throw new Error("OffscreenCanvas not supported");
          } else {
            return new Environment(platform, buildType, ThreadingModel2.single, variables);
          }
        }
      }
    } else {
      throw new Error("WebAssembly engine is not supported");
    }
  } else {
    return new Environment(Platform.node, request.buildType || BuildType2.release, ThreadingModel2.multi, variables);
  }
}

// ../../model/model-emscripten/lib/lib/EmscriptenRuntime/init.js
function isRunningInNode() {
  return typeof process !== "undefined" && process.release.name === "node";
}
function preInit(runtime) {
  return [];
}
function preRun(runtime) {
  return [
    function(module) {
      if (module.NODEFS && isRunningInNode()) {
        module.FS.mkdir("/osgearthwasm");
        module.FS.mount(module.NODEFS, { root: "." }, "/osgearthwasm");
      }
    },
    function(module) {
      for (let [key, value] of Object.entries(runtime?.environmentVariables || {})) {
        module.ENV[key] = value;
      }
    }
  ];
}
function postRun(runtime) {
  return [];
}

// ../../model/model-emscripten/lib/lib/cli.js
function cliAction(environment, action, argumentList = []) {
  return new Promise(async (resolve, reject) => {
    const runtimeProfile = `runtime-${environment.threadingModel.toLocaleLowerCase()}-${environment.buildType.toLocaleLowerCase()}`;
    const runtimeAssets = `/home/boardend/dev/git/osgearthwasm/package/osgearthwasm/dist/assets/${runtimeProfile}`;
    const runtimeName = `runtime-osgearth-offscreen`;
    const createRuntime = (await new Function(`return import("${runtimeAssets}/${runtimeName}.${runtimeProfile}.js")`)()).default;
    const runtimeInformation = {
      environmentVariables: {
        // TODO: add this from the runtime config
        PROJ_LIB: "assets/lib-proj/proj",
        OGR_GEOMETRY_ACCEPT_UNCLOSED_RING: "YES"
      }
    };
    createRuntime({
      locateFile: (path) => runtimeAssets + "/" + path,
      preInit: preInit(runtimeInformation),
      preRun: preRun(runtimeInformation),
      postRun: postRun(runtimeInformation)
    }).then((runtime) => {
      const cli = runtime["cli_" + action];
      if (cli && typeof cli === "function") {
        const args = new runtime.StringList();
        [action, ...argumentList].forEach((s) => args.push_back(s));
        try {
          runtime.cli_tfs(args);
        } catch (error) {
          reject(error);
        } finally {
          args.delete();
        }
        resolve(runtime);
      } else {
        throw new Error("Action not found: " + action);
      }
    }).catch((error) => {
      reject(error);
    });
  });
}

// lib/bin/OsgearthwasmCommandLineTFSAction.js
var OsgearthwasmCommandLineTFSAction = class extends import_ts_command_line.CommandLineAction {
  constructor() {
    super({
      actionName: "tfs",
      summary: "Wrapper for 'osgearth_tfs'",
      documentation: `see osgearth_tfs.cpp`
    });
  }
  onExecute() {
    return new Promise(async (resolve, reject) => {
      const env = await requestEnvironment({
        platform: Platform.node,
        buildType: BuildType2.release,
        threadingModel: ThreadingModel2.multi
      });
      const args = [...process.argv.slice(3)];
      cliAction(env, "tfs", args);
      resolve();
    });
  }
  onDefineParameters() {
    this.defineCommandLineRemainder({
      description: "The remaining arguments are passed along to the action inside the WebAssembly module."
    });
  }
};

// lib/bin/OsgearthwasmCommandLine.js
var OsgearthwasmCommandLine = class extends import_ts_command_line.CommandLineParser {
  constructor() {
    super({
      toolFilename: "osgearthwasm",
      toolDescription: 'The "osgearthwasm" CLI.'
    });
    this.addAction(new OsgearthwasmCommandLineServeAction());
    this.addAction(new OsgearthwasmCommandLineTFSAction());
  }
  onDefineParameters() {
  }
};

// lib/bin/osgearthwasm.bin.js
var commandLine = new OsgearthwasmCommandLine();
commandLine.execute();
/*! Bundled license information:

encodeurl/index.js:
  (*!
   * encodeurl
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

escape-html/index.js:
  (*!
   * escape-html
   * Copyright(c) 2012-2013 TJ Holowaychuk
   * Copyright(c) 2015 Andreas Lubbe
   * Copyright(c) 2015 Tiancheng "Timothy" Gu
   * MIT Licensed
   *)

ee-first/index.js:
  (*!
   * ee-first
   * Copyright(c) 2014 Jonathan Ong
   * MIT Licensed
   *)

on-finished/index.js:
  (*!
   * on-finished
   * Copyright(c) 2013 Jonathan Ong
   * Copyright(c) 2014 Douglas Christopher Wilson
   * MIT Licensed
   *)

parseurl/index.js:
  (*!
   * parseurl
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2014-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

statuses/index.js:
  (*!
   * statuses
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

unpipe/index.js:
  (*!
   * unpipe
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

finalhandler/index.js:
  (*!
   * finalhandler
   * Copyright(c) 2014-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

connect/index.js:
  (*!
   * connect
   * Copyright(c) 2010 Sencha Inc.
   * Copyright(c) 2011 TJ Holowaychuk
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

depd/index.js:
  (*!
   * depd
   * Copyright(c) 2014-2018 Douglas Christopher Wilson
   * MIT Licensed
   *)

statuses/index.js:
  (*!
   * statuses
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

toidentifier/index.js:
  (*!
   * toidentifier
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

http-errors/index.js:
  (*!
   * http-errors
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

destroy/index.js:
  (*!
   * destroy
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2015-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

etag/index.js:
  (*!
   * etag
   * Copyright(c) 2014-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

fresh/index.js:
  (*!
   * fresh
   * Copyright(c) 2012 TJ Holowaychuk
   * Copyright(c) 2016-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

on-finished/index.js:
  (*!
   * on-finished
   * Copyright(c) 2013 Jonathan Ong
   * Copyright(c) 2014 Douglas Christopher Wilson
   * MIT Licensed
   *)

range-parser/index.js:
  (*!
   * range-parser
   * Copyright(c) 2012-2014 TJ Holowaychuk
   * Copyright(c) 2015-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

send/index.js:
  (*!
   * send
   * Copyright(c) 2012 TJ Holowaychuk
   * Copyright(c) 2014-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

serve-static/index.js:
  (*!
   * serve-static
   * Copyright(c) 2010 Sencha Inc.
   * Copyright(c) 2011 TJ Holowaychuk
   * Copyright(c) 2014-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)
*/
